<?php
/*
 * Reads a simple BackendReader map file, and let the user
 * exclude a certaion feature for a particular product name
 */
class BackendReader {

	/**
	 * Comments starts with #
	 *
	 * Key word is: "Listen 127.0.0.1: " connected with the combined name e.g. "Listen 127.0.0.1:8880"
	 * Every line after this keyword, contains of a feature name that will excluded
	 * when showed in the WebGUI.
	 *
	 * Product names can use wildcars '?' to match any character or
	 * '*' to match any substring (0 or more characters).
	 *
	 */


	private $file;
	private $port;


	public function BackendReader($filename = null) {

		if (is_null($filename)) {
			throw new Exception("We need an input file..");
		}
		$this->file = $filename;
		$this->load();
	}

	private function load() {
		$ssl = file_exists('/var/opt/openit/etc/httpd/use_ssl');
		$file = fopen($this->file,"r");
		
		//If we use SSL
		if($ssl || isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on"){
			while(!feof($file)){
				$str = fgets($file);
				if (preg_match("/^[^#]*Listen/", $str)){
					$this->port = substr(trim($str), 7);
				}
				if (preg_match("/^[^#]*127.0.0.1:/", $str)){
					$this->port = substr(trim($str), 17);
					break;
				}
			}
		}else{ //if not using SSL
			while(!feof($file)){
				$str = fgets($file);
				//check for the port being used
				if (preg_match("/^[^#]*Port/", $str)){
					$this->port = substr(trim($str), 5);
					break;	
				}
				if (preg_match("/^[^#]*Listen/", $str)){
					$this->port = substr(trim($str), 7);
					break;	
				}
			}
		}
	}

	public function getPort() {
		return trim($this->port);
	}

}
?>