<?php

class ClassificationAccess {
	
	private $name;
	private $access = true;
	private $exclude;
	private $include;
	private $excludeRegular;
	private $includeRegular;

	function __construct($name) {
		$this->name = $name;
		$this->exclude = array();
		$this->include = array();
		$this->excludeRegular = array();
		$this->includeRegular = array();
	}
	
	public function getName() {
		return $this->name;
	}
	
	function addExcludeValue($value) {
		$this->exclude[] = $value;
	}
	
	function getExcludeValues() {
		return $this->exclude;
	}

	function addIncludeValue($value) {
		$this->include[] = $value;
	}
	
	public function hasAccess() {
		return $this->access ? true : false;
	}
	
	
	public function getSQLString() {
		$SQL = "";
		
		// Include
		if (count($this->include) != 0) {
			$SQL .= " AND (";
			$i = 0;		
			foreach ($this->include as $include) {
				if ($i!=0) {
					$SQL .= " OR ";
				}
				$SQL .= "value = '" . $include . "' ";
				$i++;
			}
			$SQL .= ")";
		}

		// Exclude
		if (count($this->exclude) != 0) {
			$SQL .= " AND (";
			$i = 0;		
			foreach ($this->exclude as $exclude) {
				if ($i!=0) {
					$SQL .= " OR ";
				}
				$SQL .= "value != '" . $exclude . "' ";
				$i++;
			}
			$SQL .= ")";
		}
		
		return $SQL;
	}
}

?>