<?php
// ClassificationSelectionManager

class ClassificationSelectionManager {
	
	const ARRAY_KEY = "NEW_STAT";
	
	static public function removeAll() {
	
		// Empty the session variable
		$_SESSION[self::ARRAY_KEY] = array();

	}
	
	static public function removeAllClassificationValueSelection($classificationId) {
		
		// Create a copy of the array
		$stat = isset($_SESSION[self::ARRAY_KEY]) ? $_SESSION[self::ARRAY_KEY] : array();
		
		// Empty the session variable
		$_SESSION[self::ARRAY_KEY] = array();

		// Add back old selections, that dosen't fit the given classifcation id
		if (is_array($stat)){
			foreach ($stat as $key => $value) {
				if ($value == $classificationId) continue;
				$_SESSION[self::ARRAY_KEY][$key] = $value;
			}
		}
	}
	
	static public function removeClassificationValueSelection($classificationId, $classificationValueId) {
			// Create a copy of the array
		$stat = isset($_SESSION[self::ARRAY_KEY]) ? $_SESSION[self::ARRAY_KEY] : array();
		
		// Empty the session variable
		$_SESSION[self::ARRAY_KEY] = array();

		// Add back old selections, that dosen't fit the given classifcation id and classification value id
		if (is_array($stat)){
			foreach ($stat as $key => $value) {
				if ($value == $classificationId && $key == $classificationValueId) continue;
				$_SESSION[self::ARRAY_KEY][$key] = $value;
			}				
		}
	}
	
	static public function addClassificationValueSelection($classificationId, $classificationValueId) {
		if (!is_numeric($classificationId) || !is_numeric($classificationValueId)) return;
		$_SESSION[self::ARRAY_KEY][$classificationValueId] = $classificationId;		
	}
	
	static public function getClassificationValueSelection($classificationId) {
		$values = array();
		if (is_array($_SESSION[self::ARRAY_KEY])){
			foreach ($_SESSION[self::ARRAY_KEY] as $key => $value) {
				if ($value != $classificationId) continue;
				$values[] = $key;
			}
		}
		return $values;
	}
	
}


?>