<?php

class ClassificationValue {
	
	private $uid;
	
	private $value;
	private $anonymous;
	
	public $classification;
	
	// User input
	private $selected;
	
	
	
	// Real time data
	public $rtTotalLicenses;
	public $rtUsedLicenses;
	public $rtUsers;	
	
	
	public function __construct($uid, $value, $anonymous, $selected, Classification $classification = null) {
		$this->uid = $uid;
		$this->value = $value;
		$this->anonymous = $anonymous;		
		$this->selected = $selected;
		$this->classification = $classification;
	}
	
	public function getUID() {
		return $this->uid;
	}
	
	public function getValue($allowAnonymous = true) {
		if (!$allowAnonymous) return $this->value;
		
		if ($this->classification->isUseAnonymous() && !empty($this->anonymous)) {
			return $this->anonymous;
		}
		
		//return $this->value;
		//return htmlentities($this->value);
		return htmlspecialchars($this->value);
	}
	
	
	public function setSelected() {
		$this->selected = true;
		$this->classification->markClassificationValueAsSelected($this);
	}
	
	public function isSelected() {
		return $this->selected ? true : false;
	}
	
	public function getClassification() {
		return $this->classification;
	}
	
	static public function sortList($list) {
		//usort($list, array('ClassificationValue', 'sortByValue'));
		return $list;
	} 
	
	static private function sortByValue($a, $b) {
		return strcasecmp($a->getValue(), $b->getValue());
	}
}

?>