<?php

class DataTypeAccess {
	
	private $id;
	private $access;
	private $classificationsAccess;
	
	function __construct($id) {
		$this->id = $id;
		$this->access = true;
		$this->classificationsAccess = array();
	}
	
	public function getId() {
		return $this->id;
	}
	
	public function addClassificationAccess($classificationAccess) {
		$this->classificationsAccess[$classificationAccess->getName()] = $classificationAccess;
	}
	
	public function getClassificationsAccess() {
		return $this->classificationsAccess;
	}
	
	public function getClassificationsWithAccess() {
		$classificationsAccess = array();
		foreach ($this->classificationsAccess as $classificationAccess) {
			if ($classificationAccess->hasAccess()) {
				$classificationsAccess[] = $classificationAccess;
			}
		}
		return $classificationsAccess;
	}

	public function getClassificationsWithAccessSQLString() {
		$classificationsAccess = $this->getClassificationsWithAccess();
		$toString = array();
		foreach ($classificationsAccess as $classificationAccess) {
			$toString[] = "'" . $classificationAccess->getName() . "'";
		}
		return implode(",", $toString);
	}
	
	
	public function getClassificationAccess($name) {
		foreach ($this->classificationsAccess as $classificationAccess) {
			if ($classificationAccess->getName() == $name) {
				return $classificationAccess;
			}
		}
	}
	
	public function hasAccess() {
		return $this->access ? true : false;
	}
}

?>