<?php

class FolderManager {

	static private $instance;
	private $folders;
	
	public function __construct() {
		
		// Get folder URL
		$URL = ServerConfig::getServerUrl() . "cron_admin.pl?command=list&foldersonly=1";
		
		// Get folder content
		$content = @file($URL);
			
		if (empty($content)) die("Error: 23232325");
		
		// Variable to hold folders
		$this->folders = array();

		// Parse folders		
		foreach ($content as $line) {
			if (trim($line) == "SERVER_FOLDERS" || trim($line) == "") continue;
			$this->folders[] = new Folder($line);
		}		
	}
	
	static public function getInstance() {
		if (empty(self::$instance)) {
			self::$instance = new FolderManager();
		}
		return self::$instance;
	}
	
	static public function getFolders() {
		if (empty(self::$instance)) {
			self::$instance = new FolderManager();
		}
		return self::$instance->folders;
	}
	
    static public function checkFolders($str) {
		foreach (self::getFolders() as $folder) {
			if($str == $folder->getName()){
				return true;
			}
		}
		return false;
	}
}

?>