<?php

class LDAPSearcher {
	
	private $connection;
	
	private $server;
	private $port;	
	private $suffix;
	private $baseDn;
	
	private $username;
	private $password;
	
	private $isAd;
	
	
	public function __construct() {
		
	}
	
		
	public function getServer() {
		return $this->server;
	}

	public function setServer($server) {
		$this->server = $server;
	}
	
	public function getPort() {
		return $this->port;
	}

	public function setPort($port) {
		$this->port = $port;
	}

	public function getSuffix() {
		return $this->suffix;
	}

	public function setSuffix($suffix) {
		$this->suffix = $suffix;
	}

	public function getBaseDn() {
		return $this->baseDn;
	}

	public function setBaseDn($baseDn) {
		$this->baseDn = $baseDn;
	}

	public function getUsername() {
		return $this->username;
	}

	public function setUsername($username) {
		$this->username = $username;
	}

	public function getPassword() {
		return $this->password;
	}

	public function setPassword($password) {
		$this->password = $password;
	}

	public function setAd($boolean) {
		$this->isAd = $boolean;
	}
		
	public function connect() {
		if (is_null($this->server)) return false;
		if ($this->connection = ldap_connect($this->server, !is_null($this->port) ? $this->port : null)) {
			
			if ($this->isAd) {
				ldap_set_option($this->connection, LDAP_OPT_PROTOCOL_VERSION, 3);
				ldap_set_option($this->connection, LDAP_OPT_REFERRALS, 0);		
			}
			return true;
		}
		return false;
	}
	
	public function authorize() {
		if (@ldap_bind($this->connection, $this->username . $this->suffix, $this->password)) {
			return true;
		}
		return false;
	}
	
	
	/**
	 * @return User
	 */
	public function getUser($username) {
		// Search filter
		$filter = "samaccountname=" . $username;
		
		// Do a search
		if ($search = ldap_search($this->connection, $this->baseDn, $filter, array("displayname"))) {
			$entries = ldap_get_entries($this->connection, $search);
			
			// Only return the first 
			if (isset($entries[0]["displayname"][0])) {
				$user = new User(null, $username, null, $entries[0]["displayname"][0]);
				return $user;
			}
		}
		
		return null;
	}
	
	public function getUser2($username) {
		// Search filter
		$filter = "samaccountname=" . $username;
		
		// Do a search
		if ($search = ldap_search($this->connection, $this->baseDn, $filter, array("*"))) {
			$entries = ldap_get_entries($this->connection, $search);
			
			$data = array_keys($entries[0]);
			foreach ($data as $key) {
				if (!is_numeric($key) && !strstr($key, "msexc")) {
					echo $key . "\n";
				}
			}
			
						
			
			
			//print_r($entries);
		}
	}

}

/*
$server = "192.168.7.10";
$suffix = "@svg.openit.local";
$base_dn = "dc=svg,dc=openit,dc=local";

$ad_username = "cerberus";
$ad_password = "Hvd0bd#5";

*/

?>