<?php

class Logger {
	
	private static $instance;
	private $fh;
	private $logLevel;
	
	public function __construct() {
		$this->logLevel = ServerConfig::getLogLevel();
	}
	
	public function __destruct() {
	}
	
	public static function createLogFile() {
		if (!is_null(ServerConfig::getLogFile())) {
			$fh = @fopen(ServerConfig::getLogFile(), "a");
			if (!$fh) return;
			@fwrite($fh, "");
			@fclose($fh);
		}	
	}
	
	public static function Debug($where, $message, $line = null) {
		Logger::message($where, $message, $line, 0);
	}
	
	public static function Info($where, $message, $line = null) {
		Logger::message($where, $message, $line, 1);
	}
	
	public static function Warning($where, $message, $line = null) {
		Logger::message($where, $message, $line, 2);
	}
	
	public static function Error($where, $message, $line = null) {
		Logger::message($where, $message, $line, 3);
	}
	
	public static function Critical($where, $message, $line = null) {
		Logger::message($where, $message, $line, 4);
	}
	
	public static function message($where, $message, $line = null, $type = 0) {
		
		// If $where is a file referance, only return the string after 'src/'
		if (strstr($where, 'src/')) {
			$where = substr($where, strrpos($where, 'src/')+4); 
		}
		
		// Make sure that we have only one instance of the logger object
		if (self::$instance == null) {
			self::$instance = new Logger();
		}		

		// Check if we should display the log message, based on the loglevel
		if (self::$instance->logLevel > $type) {
			return;
		}
		
		// Type of log message
		switch ($type) {
			case 0:
				$logLevel = "DEBUG";
				break;
			case 1:
				$logLevel = "INFO";
				break;
			case 2:
				$logLevel = "WARNING";
				break;
			case 3:
				$logLevel = "ERROR";
				break;
			case 4:
				$logLevel = "CRITICAL";
				break;
		}
		
		// Create log line - for apache log file, we don't need to send time, since apache is already adding that information.
		if (is_null(ServerConfig::getLogFile())) {
			$log = "[" . $logLevel . "] {" . $where . "} : " . $message;;
		} else {
			$log = date("Y.m.d H:i:s") . " [" . $logLevel . "] {" . $where . "} : " . $message;;
		}
		
		// Add line number
		if (!is_null($line)) {
			$log .= " (#" . $line . ")";
		}
		
		// Write it to the file!		
		self::$instance->write($log);

	}
	
	private function write($line) {
		if (is_null(ServerConfig::getLogFile())) {
			@error_log($line . "\r\n");
		} else {
			$this->fh = @fopen(ServerConfig::getLogFile(), "a");
			if (!$this->fh) {
				return;
				die("Can't open log file '" . ServerConfig::getLogFile() . "', please fix this problem before you can continue!");
			}
			@fwrite($this->fh, $line . "\r\n");
			@fclose($this->fh);
		}
	}
	
}

?>