<?php

class Presentation {

	private $language;
	private $charset;

	public $tpl_var = array();
	
	function assign($tpl_var, $value = null) {
		if (is_array($tpl_var)){
			foreach ($tpl_var as $key => $val) {
				if ($key != '') {
					$this->_tpl_vars[$key] = $val;
				}
			}
		} else {
			if ($tpl_var != '')
			$this->_tpl_vars[$tpl_var] = $value;
		}
	}

	function __construct() {
		$this->charset = ServerConfig::getCharset();
		$this->language = (!empty($_SESSION["USER"]) ? ($_SESSION["USER"]->getLanguage() != "" && $_SESSION["USER"]->getLanguage() != "0" ? $_SESSION["USER"]->getLanguage() : ServerConfig::getDefaultLanguage()) : ServerConfig::getDefaultLanguage());

		$this->template_dir = $_SERVER["DOCUMENT_ROOT"] . "/../smarty/";
		$this->compile_dir = $_SERVER["DOCUMENT_ROOT"] . "/../smarty/compile/";
		$this->cache_dir = $_SERVER["DOCUMENT_ROOT"] . "/../smarty/cache/";
		$this->config_dir = $_SERVER["DOCUMENT_ROOT"] . "/../smarty/languages/";

		// Send user
		if (!empty($_SESSION["USER"])) $this->assign("activeUser", $_SESSION["USER"]);
		$this->assign("CONSOLELOG", ConsoleLogger::getMessage(true));

		// Set charset
		$this->assign("CHARSET", $this->charset);

		$this->assign("HTML_TITLE", ServerConfig::getTitle());
		$this->assign("VIEWSTATE", ViewState::getInstance());

		//$this->register_function("href_active", array($this, "print_href_active"));
		//$this->register_function("isSelected", array($this, "print_isSelected"));


		// Each Open IT shourt cut
		$ois = array("oi_text", "oi_checkbox", "oi_radio");
		foreach ($ois as $oi) {
			//$this->register_function($oi, array($this, "print_" . $oi));
		}
	}

	public function getText($key) {
		return tt($key);

		// Language file (based on charset and language)
		$languageFile = strtolower($this->charset) . "/". $this->language . ".ini";

		// Verify that the language exists
		if (!file_exists(ServerConfig::getLanguagePath() . $languageFile)) {
			$languageFile = "utf-8/en.ini";	// Default language file
		}

		$this->config_load($languageFile);

		return isset($this->_config[0]["vars"][$key]) ? $this->_config[0]["vars"][$key] : "";
	}

	public function display($template, $orginalePage = null, $cache_id = null, $compile_id = null) {

		// Language file (based on charset and language)
		$languageFile = strtolower($this->charset) . "/". $this->language . ".ini";

		// Verify that the language exists
		if (!file_exists(ServerConfig::getLanguagePath() . $languageFile)) {
			$languageFile = "utf-8/en.ini";	// Default language file
		}

		if (is_null($orginalePage)) {
			//$this->config_load($languageFile, basename($template, ".tpl"));
		} else {
			//$this->config_load($languageFile, basename($orginalePage, ".tpl"));
		}

		$this->assign("URL", $_SERVER["REQUEST_URI"]);
		$this->assign("TEMPLATE", $template);

		return $this->doInclude($template);

		parent::display($template, $cache_id, $compile_id);
	}

	private function doInclude($filetoinclude) {

		// Create local varibales for "templates"
		Logger::Debug(__METHOD__, 'Assigning variables', __LINE__);
		foreach ($this->_tpl_vars as $key => $value) {
			${$key} = $value;
		}
		Logger::Debug(__METHOD__, 'Done assigning variables', __LINE__);
		
			
		// TODO: Fix this hardcoded path - should not be based on language path
		$currentDir = getcwd();
		chdir(ServerConfig::getLanguagePath() . "/../");
		include($filetoinclude);
		chdir($currentDir);

		return;
	}

	public function get_content($template, $orginalePage = null, $cache_id = null, $compile_id = null) {

		ob_start();
		$this->doInclude($template);
		$data = ob_get_contents();
		ob_end_clean();
		return $data;

		die("get_content:: Presentation.php");
		// Language file (based on charset and language)
		$languageFile = strtolower($this->charset) . "/". $this->language . ".ini";

		// Verify that the language exists
		if (!file_exists(ServerConfig::getLanguagePath() . $languageFile)) {
			$languageFile = "utf-8/en.ini";	// Default language file
		}

		if (is_null($orginalePage)) {
			$this->config_load($languageFile, basename($template, ".tpl"));
		} else {
			$this->config_load($languageFile, basename($orginalePage, ".tpl"));
		}

		$this->assign("URL", $_SERVER["REQUEST_URI"]);
		$this->assign("TEMPLATE", $template);
		return parent::fetch($template, $cache_id, $compile_id);
	}

	public function print_href_active($params, &$smarty) {

		// Get VIEWSTATE
		$viewState = isset($this->_tpl_vars["VIEWSTATE"]) ? $this->_tpl_vars["VIEWSTATE"] : null;
			
		// get assigned variables
		$id = isset($params["id"]) ? $params["id"] : null;
		$url = $smarty->get_template_vars('URL');
		$template = $smarty->get_template_vars('TEMPLATE');

		// print "id" if given
		if (!is_null($id)) {
			echo 'id="' . $id . '" ';
		}

		// if diabled is set, and its true, show disabled
		if ((isset($params['disabled']) && $params['disabled']) || ($viewState->getState($id, ViewState::DISABLED))) {
			return 'class="disabled" onclick="return false;" ';
		}

		// if we are checking template
		if (isset($params["template"])) {
			if (in_array($template, explode("|", $params["template"]))) return 'class="active"';
		}

		// if we are checking url
		if (isset($params['url']) && !empty($url)) {
			foreach (explode("|", $params["url"]) as $checkUrl) {
				if ($checkUrl == "") continue;

				$wilde = false;
				if (substr($checkUrl, -1) == "*") {
					$wilde = true;
					$checkUrl = substr($checkUrl, 0, -1);
				}

				if ($wilde) {
					if (substr_count($url, $checkUrl) != 0) return 'class="active"';
				} else {
					if ($checkUrl == $url) return 'class="active"';
				}
			}
		}

		// else nothing
		return;
	}

	public function print_isSelected($params, &$smarty) {

		// get assigned variables
		$selection = $smarty->get_template_vars('selection');

		// if we are checking template
		if (isset($params["name"]) && isset($params["value"])) {
				
			$name = $params["name"] . (isset($params["name2"]) ? $params["name2"] : "");
				
			if ($selection->get($name) == $params["value"]) {
				return 'selected="selected"';
			}
				
		}
		return;
	}

	public function print_oi_text($params, &$smarty) {

		// get assigned variables
		$selection = $smarty->get_template_vars('selection');

		// if we are checking template
		if (isset($params["name"])) {
				
			$name = $params["name"] . (isset($params["name2"]) ? $params["name2"] : "");
			$value = $selection->get($name);
				
			if ($value == "" && isset($params["default"])) {
				$value = $params["default"];
			}
				
			return 'id="' . $name . '" name="' . $name . '" value="' . $value . '" onchange="setSelection(this);"';
				
		} else {
			die("Wrong usage of: " . __METHOD__);
		}
	}

	public function print_oi_checkbox($params, &$smarty) {

		// get assigned variables
		$selection = $smarty->get_template_vars('selection');

		// if we are checking template
		if (isset($params["name"]) && isset($params["value"])) {
				
			$name = $params["name"] . (isset($params["name2"]) ? $params["name2"] : "");
			$id = isset($params["id"]) ? $params["id"] : $name;
			$value = $params["value"];
			$selected = $selection->get($name) == $value ? ' checked="checked"' : "";
			$javascript = isset($params["javascript"]) ? $params["javascript"] : "setSelection(this);";
				
			return 'id="' . $id . '" name="' . $name . '" value="' . $value . '" onclick="' . $javascript . '" onkeyup="' . $javascript . '"' . $selected;
				
		} else {
			die("Wrong usage of: " . __METHOD__);
		}
	}

	public function print_oi_radio($params, &$smarty) {

		// get assigned variables
		$selection = $smarty->get_template_vars('selection');

		// if we are checking template
		if (isset($params["name"]) && isset($params["value"])) {
				
			$name = $params["name"] . (isset($params["name2"]) ? $params["name2"] : "");
			$id = isset($params["id"]) ? $params["id"] : $name;
			$value = $params["value"];
			$selected = $selection->get($name) == $value ? ' checked="checked"' : "";
			$javascript = isset($params["javascript"]) ? $params["javascript"] : "setSelection(this);";
				
			return 'id="' . $id . '" name="' . $name . '" value="' . $value . '" onclick="' . $javascript . '" onkeyup="' . $javascript . '"' . $selected;
				
		} else {
			die("Wrong usage of: " . __METHOD__);
		}
	}

}

// Wrapper around Translate::getText()
if (!function_exists('tt')) {
function tt($key) {
	$ini = parse_ini_file(ServerConfig::getLanguagePath() . strtolower(ServerConfig::getCharset()) . "/" . ServerConfig::getDefaultLanguage() . ".ini");
	$string = isset($ini[$key]) ? $ini[$key] : "NO KEY WITH : $key";

	for ($i=1; $i<func_num_args(); $i++) {
		$value = func_get_arg($i);
		$string = str_replace("%" . $i, $value, $string);
	}

	return $string;
}
}
// TODO: Remove this tmp functions
function href_active($url, $id = null, $isDisabled = false) {

	$id = (!is_null($id)) ? ' id="' . $id . '"' : '';

	// Check if there is a local variable forcing this to be disabled
	if ($isDisabled) {
		return 'class="disabled" onclick="return false;"' . $id;
	}

	// Variables with all urls found
	$urls = array();

	// Checking urls

	// Check if multi strings
	if (strstr($url, "|")) {
		$urls = explode("|", $url);
	}

	// One string only
	else {
		$urls[] = $url;
	}

	// For each url
	foreach ($urls as $url) {
		// If multi search
		if (strstr($url, "*")) {
			if (strstr($_SERVER['REQUEST_URI'], str_replace("*", "", $url))) {
				return 'class="active"' . $id;
			}
		}

		// Single search
		else {
			if (strstr($_SERVER['REQUEST_URI'], $url) == $url) {
				return 'class="active"' . $id;
			}
		}
	}

	return $id;
}


function isSelected($key, $value) {
	$selection = new ReportSelection();
	return ($selection->get($key) == $value) ? 'selected="selected"' : '';
}


function oi_radio($params, &$smarty) {

	// get assigned variables
	$selection = $smarty->get_template_vars('selection');

	// if we are checking template
	if (isset($params["name"]) && isset($params["value"])) {

		$name = $params["name"] . (isset($params["name2"]) ? $params["name2"] : "");
		$id = isset($params["id"]) ? $params["id"] : $name;
		$value = $params["value"];
		$selected = $selection->get($name) == $value ? ' checked="checked"' : "";
		$javascript = isset($params["javascript"]) ? $params["javascript"] : "setSelection(this);";

		return 'id="' . $id . '" name="' . $name . '" value="' . $value . '" onclick="' . $javascript . '" onkeyup="' . $javascript . '"' . $selected;

	} else {
		die("Wrong usage of: " . __METHOD__);
	}
}


class html {

	// Adding the checkbox html area
	public static function checkbox($name, $value, $id = null, $javascript = null) {

		// Selection from report
		$selection = new ReportSelection();

		// Header
		$html = '<input type="checkbox" ';

		// Data
		$html .= 'name="' . $name . '" ';
		$html .= !is_null($id) ? 'id="' . $id . '" ' : 'id="' . $name . '" ';
		$html .= 'value="' . (!is_null($value) ? $value : '') . '" ';
		$html .= $selection->get($name) == $value ? 'checked="checked" ' : '';
		$html .= 'onChange="' . (!is_null($javascript) ? $javascript : 'setSelection(this);') . '" ';
		$html .= 'onclick="this.blur()"';		

		// Footer
		$html .= '/>';

		return $html;
	}

	// Adding the checkbox html area
	public static function radio($name, $value, $id = null, $javascript = null, $disable = false) {

		// Selection from report
		$selection = new ReportSelection();

		// Header
		$html = '<input type="radio" ';

		// Data
		$html .= 'name="' . $name . '" ';
		$html .= !is_null($id) ? 'id="' . $id . '" ' : 'id="' . $name . '" ';
		$html .= 'value="' . (!is_null($value) ? $value : '') . '" ';
		$html .= $selection->get($name) == $value ? 'checked="checked" ' : '';
		$html .= 'onkeydown="' . (!is_null($javascript) ? $javascript : 'setSelection(this);') . '; return;" ';
		$html .= 'onclick="' . (!is_null($javascript) ? $javascript : 'setSelection(this);') . '; return;" ';
		$html .= $disable ? 'disabled="disabled" ' : '';

		// Footer
		$html .= '/>';

		return $html;
	}

	// Adding the text
	public static function text($name, $value = null, $id = null, $javascript = null, $disable = null, $size = null, $maxlength = null) {

		// Selection from report
		$selection = new ReportSelection();

		// Header
		$html = '<input type="text" ';

		// Data
		$html .= 'name="' . $name . '" ';
		$html .= !is_null($id) ? 'id="' . $id . '" ' : 'id="' . $name . '" ';

		$html .= !is_null($size) ? 'size="' . $size . '" ' : '';
		$html .= !is_null($maxlength) ? 'maxlength="' . $maxlength . '" ' : '';

		$html .= 'value="' . (!is_null($selection->get($name)) ? $selection->get($name) : (!is_null($value) ? $value : '')) . '" ';
                if( strpos($name, "graphic_y_axis_") !== FALSE ){$html .= 'onblur="' . (!is_null($javascript) ? $javascript : 'validateYSpecOnBlur(this);') . '" ';}
		$html .= 'onchange="' . (!is_null($javascript) ? $javascript : 'setSelection(this);') . '" ';
		$html .= $disable ? 'disabled="disabled" ' : '';

		// Footer
		$html .= '/>';

		return $html;
	}

	// Adding the checkbox html area
	public static function select($name, $values, $id = null, $javascript = null) {

		// Selection from report
		$selection = new ReportSelection();

		// Header
		$html = '<select ';

		// Data
		$html .= 'name="' . $name . '" ';
		$html .= !is_null($id) ? 'id="' . $id . '" ' : 'id="' . $name . '" ';
		$html .= 'onchange="' . (!is_null($javascript) ? $javascript : 'setSelection(this);') . '" ';
		$html .= ">\n";

		// Values
		$selected = $selection->get($name);
		foreach ($values as $key => $text) {
			$html .= "\t" . '<option value="' . $key . '" ' . ($selected == $key ? 'selected="selected" ' : '') . '>' . $text . '</option>' . "\n";
		}

		// Footer
		$html .= '</select>';


		return $html;
	}

}

?>