<?php


class Report {
	
	public $id;
	public $type;
	public $active;
	public $folder;
	public $title;
	public $ins;
	public $freq;
	public $pres;
	public $period;
	
	public $instances;
	
	function __construct($id = null) {
		$this->id = $id;
		$this->instances = array();
	}
	
	public function setType($type) {
		$this->type = $type;
	}
	
	public function setTitle($title) {
		$this->title = $title;
	}
	
	public function setActive($active) {
		$this->active = $active;
	}
	
	public function setFolder($folder) {
		$this->folder = $folder;
	}
	
	public function setIns($ins) {
		$this->ins = $ins;
	}
	
	public function setFreq($freq) {
		$this->freq = $freq;
	}
	
	public function setPres($pres) {
		$this->pres = $pres;
	}
	
	public function setPeriod($period) {
		$this->period = $period;
	}
	
	
	public function getId() {
		return $this->id;
	}
	
	public function getType() {
		return $this->type;
	}
	
	public function getTitle() {
		return $this->title;
	}
	
	public function getActive() {
		return $this->active;
	}
	
	public function getFolder() {
		return $this->folder;
	}
	
	public function getIns() {
		return $this->ins;
	}
	
	public function getFreq() {
		return $this->freq;
	}
	
	public function getPres() {
		return $this->pres;
	}
	
	public function getPeriod() {
		return $this->period;
	}
	
	
	public function getDate() {
		
		// if its an container, then return from first element
		if ($this->type == 'R' && count($this->instances) != 0) {

			// get last element
			$element = $this->instances[count($this->instances)-1];
			
			// Remove first char
			$date = substr($element->getIns(), 1);		
		}
		
		else {		
			// Remove first char
			$date = substr($this->ins, 1);
		}

		// Split text
		if (substr_count($date, " ") >= 2) {
			list ($date, $time, $templateId) = @explode(" ", $date, 3);
		}
		
		return $date;		
	}	

	public function getTime() {
		// if its an container, then return from first element
		if ($this->type == 'R' && count($this->instances) != 0) {

			// get last element
			$element = $this->instances[count($this->instances)-1];
			
			// Remove first char
			$date = substr($element->getIns(), 1);		
		}
		
		else {		
			// Remove first char
			$date = substr($this->ins, 1);
		}
		
		$time = null;
		if (substr_count($date, " ") >= 2) {
			list ($date, $time, $templateId) = @explode(" ", $date, 3);
		}
				
		return $time;		
	}
	
	public function getTemplateId() {
		
		if (empty($this->ins)) return false;
		
		// Remove first char
		$date = substr($this->ins, 1);

		// Split text
		list ($date, $time, $templateId) = explode(" ", $date, 3);
		
		return $templateId;		
	}
	
	public function hasInstaces() {
		return (count($this->instances) == 0) ? false : true;
	}
	
	public function isActive() {
		return $this->active == "Y" ? true : false;
	}
	
	public function isSeen() {
		if (empty($this->ins)) return false;
		return (substr($this->ins, 0, 1) == "+") ? true : false;
	}
	
	
	public function addInstance($instance) {
		if (!$instance instanceof Report) return;
		$this->instances[] = $instance;
	}
	
	public function getInstances() {
		return array_reverse($this->instances);
	}
	


	public function sortDate($a, $b) {		
		if (!$a instanceof Report || !$b instanceof Report) return 0;

		// Sort by date and time
		if ($a->getDate() == $b->getDate() ) {
			if ($a->getTime() == $b->getTime() ) return 0;
			return ($a->getTime() > $b->getTime()) ? -1 : 1;
		}
		return ($a->getDate() > $b->getDate()) ? -1 : 1;
	}
	
	public function sortTitle($a, $b) {		
		if (!$a instanceof Report || !$b instanceof Report) return 0;
		return strcmp($a->getTitle(), $b->getTitle());
	}
	
	public function sortFolder($a, $b) {	
		if (!$a instanceof Report || !$b instanceof Report) return 0;
		return strcmp($a->getFolder(), $b->getFolder());
	}
	
}


?>