<?php

class SystemSettings {
	
	const USER_NS = 'com.openit.user.';
	
	const SESSION_NS = 'com.openit.session.';
	const SESSION_DEBUG = 'com.openit.session.debug'; 
	
	const SERVER_NS = 'com.openit.server.';
	
	
	static public $SESSION_KEY = 'system_settings';

	static public function get($key, $default = null) {
		if (strstr($key, self::SERVER_NS)) {
			$entry = wgRegistry::fetchEntry($key);
			
			// If there is no object, we create the object, with null as value
			// Reason: So we can list all possible values...
			if (is_null($entry)) {				
				self::set($key, $default);								
				return $default;
			}
			
			return $entry->value;
		}
		
		return isset($_SESSION[self::$SESSION_KEY][$key]) ? $_SESSION[self::$SESSION_KEY][$key] : null;
	}
	
	static public function getAll() {
		return wgRegistry::fetchEntries();
	}
	
	
	static public function set($key, $value) {
		if (isset($key) && isset($value)) {
			
			if (strstr($key, self::SERVER_NS)) {
				wgRegistry::set($key, $value);
				return;
			}				
			
			$_SESSION[self::$SESSION_KEY][$key] = $value;
		}
	}
	
}


?>