<?php


class ViewState {

	const SESSION_KEY = "VIEWSTATE";
	
	const DISABLED = 1;
	const ACTIVE = 2;
	const OPEN = 3;

	private static $instance;
	
	private $controls;
		
	
	public function __construct() {
			if (isset($_SESSION[ViewState::SESSION_KEY])) {
				$this->controls = unserialize($_SESSION[ViewState::SESSION_KEY]);
			} else {
				$this->controls = array();
			}
	}
	
	public function __destruct() {
		$_SESSION[ViewState::SESSION_KEY] = serialize($this->controls);
	}
	
	static public function setState($id, $property, $value) {
		self::check();
		if (!isset(self::$instance->controls[$id])) {
			self::$instance->controls[$id] = array();
		}
		self::$instance->controls[$id][$property] = $value;
	}
	
	static public function getState($id, $property) {
		self::check();		
		if (isset(self::$instance->controls[$id][$property])) return self::$instance->controls[$id][$property];
		return null;
	}
	
	static private function check() {
		if (self::$instance == null) {
			self::$instance = new ViewState();
		}				
	}
	
	static function getInstance() {
		self::check();
		return self::$instance;
	}
	
}


//ViewState::setState("unik-id", ViewState::DISABLED, true);





?>