<?php

/**
 * Registry
 * 
 * Settings that goes to database, are going thru this one
 * 
 * @package core
 * @version 2.0
 */
class wgRegistry {
	
	static private $_table = 'registry';
	
	private $id;
	public $key;
	public $value;
	private $updated;
	
	static public function set($key, $value) {
		
		// Update / Create entry
		$entry = self::fetchEntry($key);
		if (is_null($entry)) {
			$entry = new wgRegistry();
			$entry->key = $key;			
		}
		
		$entry->value = $value;
		$entry->updated = time();
		
		wgDatabaseManager::getTable(__CLASS__, self::$_table)->store($entry);	
	}
	
	static public function fetchEntry($key) {
		$list = wgDatabaseManager::getTable(__CLASS__, self::$_table)->select()->where('key = ?', $key)->toObject();
		return count($list) > 0 ? $list[0] : null;		
	}
	
	static public function fetchEntries() {
		return wgDatabaseManager::getTable(__CLASS__, self::$_table)->select()->toObject();
	}
	
	static public function deleteEntry($key) {
		$list = wgDatabaseManager::getTable(__CLASS__, self::$_table)->delete()->where('key = ?', $key)->toObject();
		return count($list) > 0 ? $list[0] : null;		
	}
	
	public function __toString() {
		return $this->value;
	}
	
}

?>