<?php

class wgDatabaseQuery {

	public $table;
	public $tableName;
	
	private $sql;
	private $values;
	
	public function __construct(wgDatabaseTable $table) {
		$this->table = $table;
	}	
	
	public function addSQL($sql) {
		if (is_null($this->sql)) $this->sql = array();
		$this->sql[] = $sql;
	}
	
	public function addValue($value) {
		if (is_null($this->values)) $this->values = array();
		$this->values[] = $value;		
	}
	
	public function getSQL() {
		if (is_null($this->sql)) return null;
		return implode(' ', $this->sql);
	}
	
	public function getValues() {
		if (is_null($this->values)) return array();
		return $this->values;
	}
	
	/**
	 * @return PDO
	 */
	public function getDatabase() {
		try {
			
			// In development
			/*
			if (file_exists(ServerConfig::getConfigPath() . "/../../helpers" . self::OPENIT_SERVER_CONFIG_FILE)) {			
				$pdo = new PDO('sqlite:/home/glarsen/Projects/openit/webgui/trunk/src/db/general/system.s3db');
			}
			
			// Normal 
			else {
				$pdo = new PDO('sqlite:/opt/openit/db/general/system.s3db'); // TODO: Should not be hardcoded!?	
			}
			*/
			$pdo = new PDO('sqlite:' . (isset($_SERVER['DOCUMENT_ROOT']) ? $_SERVER['DOCUMENT_ROOT'].'/' : '') .  '../db/general/system.s3db');

			//$pdo = new PDO('sqlite:/opt/openit/db/general/system.s3db'); // TODO: Should not be hardcoded!?
			
			$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $pdo;			
		} catch (PDOException $e) {
			echo 'Error: 56a98af112';
			Logger::Debug(__FILE__ . '::' . __METHOD__, $e->getMessage());
			exit;
		}		
	}
	
	
	
	
	
	
	
	
	public function printSQL() {
		if (is_null($this->sql)) return null;
		return implode(' ', $this->sql) . (is_array($this->values) ? ' <====> ' . implode(', ', $this->values) : '');
	}
	
}

?>