<?php

set_time_limit(0);
//ini_set("memory_limit", "512M");

// Include util classe
require_once($_SERVER["DOCUMENT_ROOT"] . "/../" . "classes/utils.php");

// We have too many classes now, swithing over to autoload..
if (!function_exists("__autoload")) {
	function __autoload($className) {
		$rootPath = $_SERVER["DOCUMENT_ROOT"] . '/../classes/';
		$filename = $rootPath . $className . '.php';
		if (file_exists($filename)) {
			require($filename);
			return;
		}
		
		// If we havent find the file here, we would need to check in sub folders
		$subFile = glob($rootPath . '*/' . $className . '.php');
		if (count($subFile) == 1) require($subFile[0]);
	
		// If we havent find the file here, we would need to check in sub folders
		$subFile = glob($rootPath . '*/*/' . $className . '.php');
		if (count($subFile) == 1) require($subFile[0]);
	
		// If we havent find the file here, we would need to check in sub folders
		$subFile = glob($rootPath . '*/*/*/' . $className . '.php');
		if (count($subFile) == 1) require($subFile[0]);
	}
}

// Start session
session_start();

// Verify that the system is correct configured
// Check system
// TODO: Should not be nesseccery
//       We should run all migration scripts while installing a patch,
//       or when ever a DB dosent exists...
SystemChecker::run();

// Enable good error message support
set_error_handler('exceptions_error_handler');

// Send charset
//ini_set("default_charset", "EUC-JP"); // For testing!
header('Content-Type: text/html; charset=' . ServerConfig::getCharset());

// Start access controll manager
new AccessControlManager();

// Try to force sqlite to use mixed values
ini_set("sqlite.assoc_case", 0);

// Check if access controll is loaded
if (!isset($_SESSION["ACCESSCONTROL"])) {
	$_SESSION["ACCESSCONTROL"] = new AccessControl();
}


define("SELECTED_PRESENTATION", "selectedPresentation");

// Access Control

if(isset($_SERVER["SERVER_PORT"]) && $_SERVER["SERVER_PORT"] == 443){
	$_SERVER["HTTPS"] = "on";
}

// Allow no user login...
if (isset($_REQUEST['xauth']) && $_REQUEST['xauth'] == 'asdjkd292de') {
	$_SESSION["USER"] = new User(9999999, 'xauth', null, 'License Monitor', null, null, true, null, null, null);
	UserSettings::setValue($_SESSION["USER"], UserSettings::REALTIME_ACCESS, true);
}

if (isset($_REQUEST['xfeed']) && $_REQUEST['xfeed'] == '5050d18b56372079fc5b0fd9fcebb984') {
	$_SESSION["TMP_USER"]=$_SESSION["USER"];
	$_SESSION["USER"] = new User('9999998', 'xfeed', null, 'Feed', null, null, true, null, null, null);
	UserSettings::setValue($_SESSION["USER"], UserSettings::REALTIME_ACCESS, true);
}

// Check if the user is logged in, if not, only alow user login page to be visible
if (empty($_SESSION["USER"]) || !$_SESSION["USER"] instanceof User || $_SESSION["USER"]->getId() == null) {
	
	// Since this is the first time we access gui (for this session), we do a check on the URL

	$data = @file_get_contents(ServerConfig::getServerUrl() . "cron_admin.pl?command=unknown_command");
	
	
	if ($data == null) {
		
		// If we are on our way to a error page, try a new redirect
		if (substr($_SERVER["REQUEST_URI"], 0, 10) != "/error.php") {
			session_destroy();
			//header("Location: /error.php?error=3");
			ini_set("display_errors", "on");
//			echo file_get_contents('https://gollin.localdomain/OpeniT/config_dump.pl');
//			print_r(file('https://gollin.localdomain/OpeniT/config_dump.pl'));
//			echo file_get_contents(ServerConfig::getServerUrl() . "cron_admin.pl?command=unknown_command");
			//die(ServerConfig::getServerUrl() . "cron_admin.pl?command=unknown_command");
			exit;
		}
	}

	if (!($_SERVER["REQUEST_URI"] == "/login.php" || $_SERVER["REQUEST_URI"] == "/login.php?error=true" || substr($_SERVER["REQUEST_URI"],0,15) == "/post_login.php" || $_SERVER["REQUEST_URI"] == "/disclaimer.php" || substr($_SERVER["REQUEST_URI"], 0, 10) == "/error.php")) {
		header("Location: /login.php");
		exit();
	}
}


// Check if user has access to requested page
$folder = @substr($_SERVER["REQUEST_URI"], 1, strpos($_SERVER["REQUEST_URI"], "/", 2)-1);
$folders = @explode('/', strtoupper(@substr($_SERVER["REQUEST_URI"], 1)));

//if ($_SESSION["USER"]->isAdmin() || $_SESSION["USER"]->isRealTimeUser()) {

switch (strtoupper($folder)) {
	
	case "REALTIME": 
		if (!($_SESSION["USER"]->isAdmin() || $_SESSION["USER"]->isRealTimeUser())) {
			header("Location: /access.php");
		}
		break;
	
	case "TEMPLATE_SELECTION": 
		if (!($_SESSION["USER"]->isAdmin() || $_SESSION["USER"]->isTemplateUser())) {
			header("Location: /access.php");
		}
		break;
	
	case "PERIODIC_JOBS": 
		if (!($_SESSION["USER"]->isAdmin() || $_SESSION["USER"]->isTemplateUser() || $_SESSION["USER"]->isReportGeneratorUser())) {
			header("Location: /access.php");
		}
		break;
	
	case "COMPLETE_SELECTION": 
		if (!($_SESSION["USER"]->isAdmin() || $_SESSION["USER"]->isReportGeneratorUser())) {
			header("Location: /access.php");
		}
		break;

	case "GENERATED_REPORTS": 
		if (!($_SESSION["USER"]->isAdmin() || $_SESSION["USER"]->isTemplateUser() || $_SESSION["USER"]->isReportGeneratorUser() || $_SESSION["USER"]->isViewUser())) {
			header("Location: /access.php");
		}
		break;
	
	case "ACCESS_CONTROL":
		if (!$_SESSION["USER"]->isAdmin()){
		
			if($_SERVER['REQUEST_METHOD'] == 'GET') {
				$url = (!empty($_SERVER['HTTPS'])) ? "https://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'] : "http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
			
				list($address, $others) = split('=', $url);
				list($userId, $etc) = split('&', $others);
				if((strpos($address, 'edit_user.php') == false) || ($userId != $_SESSION[UserHelper::SESSION_CACHE_KEY]->getId())){
					header("Location: /access.php");
				}
			} else {
				$id = $_POST["id"];
				if ($id != $_SESSION[UserHelper::SESSION_CACHE_KEY]->getId())  header("Location: /access.php");
			}
		}		
		break;
		
	case "ADMIN": 
		if (!$_SESSION["USER"]->isAdmin()) {
			header("Location: /access.php");
		}
		break;
		
	case "DASHBOARD":
		if (isset($folders[1])) {
			
			// LICENSE			
			if ($folders[1] == 'LICENSE') {
				if (!$_SESSION["USER"]->isAdmin() && !$_SESSION["USER"]->isRealTimeUser()) {
					header("Location: /access.php");
					return;
				}				
			}
			
			// SYSTEM_INFO
			if ($folders[1] == 'SYSTEM_INFO' && !$_SESSION["USER"]->isAdmin()) {
				header("Location: /access.php");
				return;
			}			
		}
		break;
	
}

unset($folder);
unset($folders);

// Set the Product and Feature Rename in session
if (! strstr(PHP_OS, "WIN")){
	$mapReader = new MapReader("/var/opt/openit/etc/product-rename.map");
	$_SESSION['productRenameMap'] = $mapReader->getMap();
	$mapReader = new MapReader("/var/opt/openit/etc/feature-rename.map");
	$_SESSION['featureRenameMap'] = $mapReader->getMap();
}else{
	$mapReader = new MapReader($_SERVER["DOCUMENT_ROOT"] . "/../../Configuration/product-rename.map");
	$_SESSION['productRenameMap'] = $mapReader->getMap();
	$mapReader = new MapReader($_SERVER["DOCUMENT_ROOT"] . "/../../Configuration/feature-rename.map");
	$_SESSION['featureRenameMap'] = $mapReader->getMap();
}

Logger::Debug("NEW REQUEST", "Creating new lines for new request\n\n\n\n");
//ConsoleLogger::write("DEBUG - " . $_SERVER['REQUEST_URI']);

?>