<?php
class MapReader {
	private $file;
	private $map;
	
	public function MapReader($filename){
		if (is_null($filename)) {
			throw new Exception("We need a product-rename map file..");
		}

		$this->map = array();
		$this->file = $filename;

		$this->load();
	}

	private function load() {

		if (!(file_exists($this->file) && is_readable ($this->file))) return;

		// Parse the mapping file, to an easier format for looking up data..
		$parser = new Parser(file_get_contents($this->file),
		ParserSettings::create(ParserSettings::COMMENT_CHAR, '#')
		->set(ParserSettings::SKIP_COMMENTS, true)
		->set(ParserSettings::SKIP_BLANK_LINES, true)
		);

		$product = null;

		// For each line we have...
		while ($parser->hasMore()) {
				
			// Get next line
			$line = $parser->next();
				
			// Check if got the keyword
			if (substr(trim($line->toString()), 0, 4) == 'MAP:') {
				//$map = $line->next(ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_SEMI_COLON));
				$product = trim(substr($line->toString(), 4));
				//echo "<br/>";
				//echo($product);
				
				continue;
			} else {
				if(strpos(trim($line->toString()),"\\") !== false) {
					$arr = explode("\\",$line->toString());
					$this->map[trim($arr[0])] = array($product,$arr);
				} else {
					$this->map[trim($line->toString())] = $product;
				}
				//$this->map[trim($line->toString())] = $product;
			}
				
			// if we dont have a product name, we ontinue..
			//if (is_null($product)) continue;

			// add product name to combined product name
			//$this->map[$product][] = trim($line->toString());
		}

	}
	
	public function getMap(){
		return $this->map;
	}
	
	public function listMapEntries(){
		var_dump($this->map);
	}
	
}
?>