<?php

/**
 * Our own __autoload implementation
 */

class AutoLoader {
	
	static private $sub = array();
	

	
	public static function register() {
		// Let the system load classes when they are needed..
		spl_autoload_register(array('AutoLoader', 'load'));
	}
	
	public static function addFolder($folder) {
		 self::$sub[] = $folder;
	}

	
	public static function load($className) {

		// Set the root path to out root classe folder
		$rootPath = $_SERVER["DOCUMENT_ROOT"] . '/../classes/';

		// Try to find class in between our root classes
		if (($file = self::findFile($rootPath, $className)) != false) {
			require($file);
			return;
		}
		
		// Try to find class in all registerd pathes
		foreach (self::$sub as $folder) {
			if (($file = self::findFile($folder, $className)) != false) {
				require($file);
				return;
			}		
		}		
		
		// Since we are not allowed to throw messages witout having a class, we need to fake a class
		eval("class $className {}"); 
		throw new Exception("Can't find and load the class '$className' under class folder.");
	}
	

	/**
	 * Finding class file under a given folder
	 *
	 * @param String $path Path where we should start looking for the class
	 * @param String $className Classname we are looking for
	 * @param int $start Which level we should start the search (default root / 0)
	 * @return String Filname for the class
	 */
	static private function findFile($path, $className, $start = 0) {

		$MAX_LEVELS = 10;
		
		// Start for top folder
		for ($i=$start; $i<$MAX_LEVELS; $i++) {
			$searchString = $path . str_repeat('*/', $i) .$className . '.php';
			$result = glob($searchString);
			if (count($result) == 1) {
				return $result[0];
			}
		}
		
		return false;
	}

}

?>