<?php

/**
 * Class Modifyer is a class that can be used to modify instaces of other
 * classes. The purpose of this class, is that you can use this one, to modify
 * private/proteced variables inside an object.
  */
class ClassModifyer {
	
	private $object;
	private $className;
	private $SPLIT_CHAR;
	
	/**
	 * Create an instance of the class
	 *
	 * @param object $class Insert an object that you would like to modify
	 */
	public function __construct($object) {
		$this->object = $object;
		$this->className = get_class($object);
		$this->SPLIT_CHAR = chr(0);
	}
	
	
	/**
	 * Get all values from an object. (Includes private and proteced variables as well)
	 *
	 * @return mixed
	 */
	public function getValues() {		
		$values = array();
		$classValues = (array) $this->object;
		
		foreach ($classValues as $key => $value) {
			if ($key[0] == $this->SPLIT_CHAR) {
				$key = substr($key, strrpos($key, $this->SPLIT_CHAR)+1);
			}
			$values[$key] = $value;
		}
		return $values;
	}
	
	/**
	 * Get value from object
	 *
	 * @param String $key Variable name
	 * @return mixed
	 */
	public function getValue($key) {
		// Convert to array, so we can access all elements
		$class = (array) $this->object;
		
		// Check if the key exists as a public key
		if (isset($class[$key])) {
			return $class[$key];
		}
		
		// Check if the valye exists as a private/proteced key
		else if (isset($class[$this->SPLIT_CHAR . $this->className . $this->SPLIT_CHAR . $key])) {
			return $class[$this->SPLIT_CHAR . $this->className . $this->SPLIT_CHAR . $key];
		}
		
		// No valid key!
		else {
			return false;
		}		
	}
	
	/**
	 * Set value to object
	 *
	 * @param String $key Variable name
	 * @param mixed $value Value to set
	 * @return boolean
	 */
	public function setValue($key, $value) {
		
		// Convert to array, so we can access all elements
		$class = (array) $this->object;
		$variables = array_keys($class);
		
		// Check if the key exists as a public key
		//if (isset($class[$key])) {
		if (in_array($key, $variables)) {
			$class[$key] = $value;
		}
		
		// Check if the valye exists as a private/proteced key
		//else if (is_string($class[$this->SPLIT_CHAR . $this->className . $this->SPLIT_CHAR . $key])) {
		else if (in_array($this->SPLIT_CHAR . $this->className . $this->SPLIT_CHAR . $key, $variables)) {
			$class[$this->SPLIT_CHAR . $this->className . $this->SPLIT_CHAR . $key] = $value;
		}
		
		// No valid key!
		else {
			echo "feil";
			return false;
		}
		
		// Convert back to instace
		$class = unserialize('O:' . strlen($this->className) . ':"' . $this->className . '"' . substr(serialize((object) $class), 14));
		if (is_object($class)) {
			$this->object = $class;
			return true;
		}
		
		return false;
	}
	
	/**
	 * Get object
	 *
	 * @return mixed The modifyed object
	 */
	public function getObject() {
		return $this->object;
	}
		
}

?>