<?php

class XMLSerializer {
	
	static public function getXML($class, $array, $isList = false) {
		
		//header("Content-Type: text/xml");
		$string = '<?xml version="1.0" encoding="UTF-8" ?>' . "\n";
		$list = $isList ? 's' : '';
			
		$string .= "<{$class}{$list}>\n";
				
		foreach ($array as $key => $value) {
			if (is_array($value)) {
				$string .= self::getContent($class, $value, $isList);
			} else {
				$string .= "\t<{$key}>" . $value . "</{$key}>\n";
			}  
		}
		$string .= "</{$class}{$list}>\n";
	
		return $string;
		
	}
	
	private static function getContent($class, $array, $isList, $level = 1) {
		
		$string = str_repeat("\t", $level) . "<{$class}>\n";
	
		foreach ($array as $key => $value) {
			if (is_array($value)) {
				$string .= self::getContent($class, $value, $isList, $level++);
			} else {
				$string .= str_repeat("\t", $level) . "\t<{$key}>" . $value . "</{$key}>\n";
			}  
		}
		$string .= str_repeat("\t", $level) . "</{$class}>\n";		
		return $string;
	}
	
	
}

?>