<?php

class JSONPresentation implements ModulePresentation {
	
	private $module;
	private $data;
	
	public function __construct(Controller $module, $data = null) {
		$this->module = $module;
		$this->data = $data;
	}
	
	public function display() {
		header("Status: 200");
		//header('Content-type: application/x-json');

		// list
		if (!is_null($this->module->getList()) && is_array($this->module->getList())) {
			$list = array();						
			foreach ($this->module->getList() as $model) {
				$mod = new ClassModifyer($model);
				$list[] = $mod->getValues();
			}
			echo json_encode($list);
		}
		
		// not list and not modul
		else if (is_null($this->module->getModel())) {
			
			if (is_array($this->data)) {			
				echo json_encode($this->data);
			} else {		
				echo $this->data;
			}
		}
		
		// modul
		else {
			$mod = new ClassModifyer($this->module->getModel());
			echo json_encode($mod->getValues());
		}
	}		
	
}

?>