<?php

class TemplatePresentation implements ModulePresentation {
	
	private $module;
	
	public function __construct(Controller $module) {
		$this->module = $module;
	}
	
	public function display() {
		
		$this->proccessDocument($this->module);
		
		// Do we have an template
		
		// Load template from document
		$template = FrontController::PRESENTATION_FOLDER_TEMPLATES . $this->module->getDocument()->template . '.php';
		
		// If we do have an template, we display or data here..
		if (file_exists($template)) {
			$document = $this->module->getDocument();
			include $template;
			return;
		} 
		
		// Diplay raw content..
		echo $this->module->getDocument()->body;		
		return;
	}
	

	public function proccessDocument(&$module) {
		
		// Module directory
		$_moduleDir =  $this->module->getModuleInfo()->getModulePath() . FrontController::MODULE_FOLDER_HTML;

		// Local variables
		$list = $this->module->getList();
		$model = $this->module->getModel();
		$controller = $module = $this->module;
		$document = $this->module->getDocument();
		
		// Get data
		ob_start();
		include $_moduleDir . $this->module->getRequest()->action . '.php';
		$data = ob_get_contents();
		ob_end_clean();

		
		// Look for submit forms in the source, if this is an edit action and we validate has been implemented in the class
		if (($this->module->getRequest()->action == 'edit' || $this->module->getRequest()->action == 'index' || $this->module->getRequest()->action == 'new') && method_exists($this->module, 'validate')) {
			if (strstr($data, '<form')) {
				if (preg_match_all('#<form(.*)>#imsU', $data, $result)) {
					for ($i=0; $i<count($result[0]); $i++) {
						$form = $result[0][$i];
						$attributes = $result[1][$i];
						
						// If there is no onsubmit javascript function there, we add it..
						if (!strstr(strtolower($attributes), 'onsubmit')) {
							$data = str_replace($form, str_replace($attributes, $attributes . ' onsubmit="return OpeniT_FormValidator.validate(this, true);" ', $form), $data);
						}
						
					}
				}
			}
		}
		
		// If '<body>' exist in the string, we try to parse the output
		
		$module->getDocument()->menu = $module->getMenu();
		$module->getDocument()->subMenu = $module->getSubMenu();
		
		if (strstr($data, '<body>')) {

			// HEAD and BODY
			if (preg_match('#<html>.*<head>(.*)</head>.*<body>(.*)</body>.*</html>#imsU', $data, $result)) {
			// TODO: DOM modyfier - Handle head (title, style etc)
				$module->getDocument()->head .= $result[1];
				$module->getDocument()->body .= $result[2];
				return; 
			}
			
			// BODY only
			if (preg_match('#<html>.*<body>(.*)</body>.*</html>#imsU', $data, $result)) {
				$module->getDocument()->body .= $result[1];
				return;
			}
		}

		$module->getDocument()->body .= $data;		
	}

}

?>