<?php

class XMLPresentation implements ModulePresentation {

	private $module;
	private $data;
	
	public function __construct(Controller $module, $data = null) {
		$this->module = $module;
		$this->data = $data;
	}
	
	public function display() {
		header("Status: 200");
		header('Content-type: text/xml');
		if (!is_null($this->module->getList())) {
			$list = array();						
			foreach ($this->module->getList() as $model) {
				$mod = new ClassModifyer($model);
				$list[] = $mod->getValues();
			}
			echo XMLSerializer::getXML(get_class($model), $list, true);
		}
		
		else if (!is_null($this->module->getModel())) {
			$mod = new ClassModifyer($this->module->getModel());
			echo XMLSerializer::getXML(get_class($this->module->getModel()), $mod->getValues());
		}
		
		else {
			
			if (is_array($this->data)) {								
				echo XMLSerializer::getXML('object', $this->data);
			} else {		
				echo $this->data;
			}
			
		}
	}	
	
}

?>