<?php


/**
 * This class is used to parse the current request
 * 
 * @static 
 */
class RequestParser {

	static private $uri;
	static private $baseUri;
	static private $params;
	static private $extension;

	static public function getBaseUri() {
		
		// Return allready parsed base uri
		if (!is_null(self::$baseUri)) return self::$baseUri;
		
		// Make sure we have a request uri, should always be deliverd from php
		if (!isset($_SERVER['REQUEST_URI'])) throw new Exception('Can\'t get the request uri from php engine...');
		
		// Set to local variable	
		self::$uri = self::$baseUri = $validateUrl = $_SERVER['REQUEST_URI'];
		
		// If we have / at the end of the uri, we do a redirect
		while (strpos($validateUrl, "?")) $validateUrl = substr($validateUrl, 0, strpos($validateUrl, "?"));
		if (substr($validateUrl, -1) == '/') {
			if (count($_POST) > 0) die('can\'t do "/" redirect fix, since we have a post');		
			$newUri = self::$uri;
			$newParams = '';
			while (strpos($newUri, "?")) {
				$newParams .= substr($newUri, strpos($newUri, "?"));
				$newUri = substr($newUri, 0, strpos($newUri, "?"));
			}			
			// Remove / at the end of the uri
			while (substr($newUri, -1) == "/") $newUri = substr($newUri, 0, -1);					
			header('Location: ' . $newUri.$newParams);
			exit;
		}		
		
		
		if (substr(self::$baseUri, -1) == "/") {
			while (substr(self::$baseUri, -1) == "/") {
				self::$baseUri = substr(self::$baseUri, 0, -1);
			}
			header('Location: ' . $newUri.$newParams);
			exit;
		}
		
		// Remove doubble / in the whole uri
		while (strstr(self::$baseUri, "//")) {
			self::$baseUri = str_replace("//", "/", self::$baseUri);
		}
		
		// Remove extra / at the start of the uri
		while (substr(self::$baseUri, 0, 1) == "/") {
			self::$baseUri = substr(self::$baseUri, 1);
		}

		// Remove helper file from beginning of file..
		// This should always be the first element in the string
		self::$baseUri = substr(self::$baseUri, strpos(self::$baseUri, '/')+1);				
				
		// Remove extra / at the start of the uri
		// We run this again, in case the URI is something like: //helper///////tooomanyslahses//
		while (substr(self::$baseUri, 0, 1) == "/") {
			self::$baseUri = substr(self::$baseUri, 1);
		}
		
		// Remove all ? - and keep the string before ?
		while (strpos(self::$baseUri, "?")) {
			self::$params = substr(self::$baseUri, strpos(self::$baseUri, "?")+1); 
			self::$baseUri = substr(self::$baseUri, 0, strpos(self::$baseUri, "?"));
		}
						
		// Remove and keep extension, if the 4 last char is . (xml, raw, rss)
		if (self::$baseUri[strlen(self::$baseUri)-4] ==  '.') {
			self::$extension = substr(self::$baseUri, strlen(self::$baseUri)-3);
			self::$baseUri = substr(self::$baseUri, 0, strlen(self::$baseUri)-4);
		}		
						
		// Remove and keep extension, if the 5 last char is . (json, html etc)
		if (self::$baseUri[strlen(self::$baseUri)-5] ==  '.') {
			self::$extension = substr(self::$baseUri, strlen(self::$baseUri)-4);
			self::$baseUri = substr(self::$baseUri, 0, strlen(self::$baseUri)-5);
		}		
		
		return self::$baseUri;
	} 
	
	static public function getParams() {
		// Make sure we have the params loaded
		self::getBaseUri();
		return self::$params;
	}
	
	static public function getUri() {
		// Make sure we have the params loaded
		self::getBaseUri();
		return self::$uri;
	}
	
	static public function getExtension() {
		return self::$extension;
	}
	
}

?>