<?php

/**
 * 
 * Class for reading Open iT Server Config
 * 
 */
class OpeniT_Server_Config {
	
	// Session cache key - ( md5 of OpeniT_Server_Config )
	const SESSION_CACHE_KEY = "67cbabd52c5bfd82508e88b125b5346e";
	
	// Open iT cfg file is always on the same location
	const OPENIT_SERVER_CONFIG_FILE_LIN = "/etc/opt/openit/openit.cfg";
	
	// Local array, holding key => value, of the config file
	private $config;
	
	
	public function __construct() {
		$os = "";
		//for checking of OS
		if (strstr(PHP_OS, "WIN")){
			$os = $_SERVER["DOCUMENT_ROOT"] . "/../../Configuration/openit.cfg";
		} else {
			$os = self::OPENIT_SERVER_CONFIG_FILE_LIN;
		}
		
		// Used while devloping 
		if (file_exists(ServerConfig::getConfigPath() . "/../../helpers" . $os)) {
			$openITconfigData = file_get_contents(ServerConfig::getConfigPath() . "/../../helpers" . $os);
		} else
		
		
		// Read real open it config file
		if (file_exists($os)) {
			$openITconfigData = file_get_contents($os);
		}		
		
		// Init the parser		
		$parser = new Parser($openITconfigData, ParserSettings::create(ParserSettings::COMMENT_CHAR, "#")->set(ParserSettings::SKIP_COMMENTS, true)->set(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_WHITE_SPACE)->set(ParserSettings::SKIP_BLANK_LINES, true));	

		// Parse truh the config file
		while ($parser->hasMore()) {
			
			// Get line
			$line = $parser->next();
			
			// Insert key, value into array
			$this->config[$line->get(0)->toString()] = $line->get(1)->toString();
		}
	}
	
	// Get the value of a key, default is parsed (PARSE = parse $ tokens)
	public function get($key, $parsed = true) {
		
		// Return null if there is no key in the config array
		if (!isset($this->config[$key])) return null;
		
		// Local copy of the value
		$value = $this->config[$key];
				
		// Parse $ strings
		if ($parsed) {
			while (strstr($value,'$')) {
				preg_match('#\$[a-zA-Z_]*?#U', $value, $var);
				$var = $var[0];
				$value = str_replace($var, $this->get(substr($var,1)), $value);
			}
		}
		
		// Return value
		return trim($value);
	}
			
}

?>