<?php

class MappingConfig {

	/* Static */
	private static $dbTable = 'mapConfig';
	private static $dbId = 'id';
	private static $dbFields = array('id', 'sourceId', 'file', 'historic', 'mapTypeId');

	static public function getConfigs() {
		if (!$records = MappingDatabaseConnector::get(
		self::$dbTable,
		self::$dbFields,
		__CLASS__,
		null,
		true
		)) {
			return null;
		}
		return $records;
	}

	/**
	 * @return MappingConfig
	 */
	static public function getConfig($id) {
		if (!$record = MappingDatabaseConnector::get(
		self::$dbTable,
		self::$dbFields,
		__CLASS__,
		array("id = {$id}"),
		false
		)) {
			return null;
		}
		return $record;
	}

	static public function store(MappingConfig $config) {
		return MappingDatabaseConnector::set(self::$dbTable, self::$dbId, self::$dbFields, $config);
	}

	static public function delete($id) {
		return MappingDatabaseConnector::delete(self::$dbTable, self::$dbId, $id);
	}


	/* Private */
	private $id;
	private $sourceId;
	private $file;
	private $historic;
	private $mapTypeId;

	public function getId() {
		return $this->id;
	}

	public function setId($id) {
		$this->id = $id;
	}

	public function getSourceId() {
		return $this->sourceId;
	}

	public function setSourceId($sourceId) {
		if(is_array($sourceId)) {
			$tmpSourceID = "";
			foreach($sourceId as $source) {
				$tmpSourceID .= ($tmpSourceID == "") ? $source : "," . $source;
			}
			$this->sourceId = $tmpSourceID;
		} else {
			$this->sourceId = $sourceId;
		}
	}

	public function getFile() {
		return $this->file;
	}

	public function setFile($file) {
		$this->file = $file;
	}

	public function getHistoric() {
		return $this->historic;
	}

	public function setHistoric($historic) {
		$this->historic = $historic;
	}

	public function getMapTypeId() {
		return $this->mapTypeId;
	}

	public function getMapType() {
		if (is_null($this->mapTypeId)) return null;
		return MappingType::getType($this->mapTypeId)->getName();
	}

	public function setMapTypeId($mapTypeId) {
		$this->mapTypeId = $mapTypeId;
	}
	public function query($sql){
		return MappingDatabaseConnector::query($sql);
	}
}

?>