<?php

class MappingConfigField {
	
	/* Static */
	private static $dbTable = 'mapfields';
	private static $dbId = 'id';
	private static $dbFields = array('id', 'mapConfigId', 'sourceFieldId', 'fieldType');
	
	static public function getFields($mappingConfigId) {
		if (!$records = MappingDatabaseConnector::get(
					self::$dbTable,
					self::$dbFields,
					__CLASS__,
					array("mapConfigId = {$mappingConfigId}")
					)) {
			return null;
		}
		return $records;
	}
	
	static public function getField($id) {
		if (!$record = MappingDatabaseConnector::get(
					self::$dbTable,
					self::$dbFields,
					__CLASS__,
					array("id = {$id}")					
					)) {
			return null;
		}			
		return $record;
	}

	static public function deleteByMap($mapConfigId) {
		MappingDatabaseConnector::query("DELETE FROM mapfields WHERE mapConfigId = {$mapConfigId};");
	}
	
	static public function store(MappingConfigField $field) {
		return MappingDatabaseConnector::set(self::$dbTable, self::$dbId, self::$dbFields, $field);		
	}
	
	
	private $id;
	private $mapConfigId;
	private $sourceFieldId;
	private $fieldType;
	
	public function __construct($id = null, $mapConfigId = null, $sourceFieldId = null, $fieldType = null) {
		$this->id = $id;
		$this->mapConfigId = $mapConfigId;
		$this->sourceFieldId = $sourceFieldId;
		$this->fieldType = $fieldType;
	}
	
	public function getId() {
		return $this->id;
	}

	public function setId($id) {
		$this->id = $id;
	}

	public function getMapConfigId() {
		return $this->mapConfigId;
	}

	public function setMapConfigId($mapConfigId) {
		$this->mapConfigId = $mapConfigId;
	}

	public function getSourceFieldId() {
		return $this->sourceFieldId;
	}

	public function setSourceFieldId($sourceFieldId) {
		$this->sourceFieldId = $sourceFieldId;
	}

	public function isFieldType() {
		return $this->fieldType == 1 ? true : false;
	}
	
	public function getFieldType() {
		return $this->fieldType;
	}
	
	public function setFieldType($fieldType) {
		$this->fieldType = $fieldType;
	}

}

?>