<?php

class MappingSource {
	
	private $id;
	private $typeId;
	private $name;
	
	private static $dbTable = 'source';
	private static $dbId = 'id';
	private static $dbFields = array('id', 'typeId', 'name');
	private static $fields = array('id', 'typeId', 'name');

	
	static public function getSources() {
		if (!$sources = MappingDatabaseConnector::get('source', self::$fields, __CLASS__, null, true)) {
			die ('something went bad..'); //todo: better error handeling
		}
		return $sources;
	}
	
	/**
	 * Return a MappingSource instance from database
	 *
	 * @param int $id Uniq id
	 * @return MappingSource
	 */
	static public function getSource($id) {
		if (!$source = MappingDatabaseConnector::get('source', self::$fields, __CLASS__, array("id = {$id}"))) {
			die ('something went bad..'); //todo: better error handeling
		}
		return $source;
	}
	
	
	static public function store(MappingSource $source) {		
		return MappingDatabaseConnector::set(self::$dbTable, self::$dbId, self::$dbFields, $source);
	}
	
	static public function delete($id) {
		//delete from source and sourceconfig tables
		$returnflag = true;
		$returnflag = $returnflag && MappingDatabaseConnector::delete('sourceconfig', 'sourceid', $id);
		$returnflag = $returnflag && MappingDatabaseConnector::delete(self::$dbTable, self::$dbId, $id); 
		return $returnflag;
	}
	
	
	/*
	 * SELECT * FROM sourceConfig WHERE sourceConfigElementId = (SELECT id FROM sourceConfigElement WHERE typeId = 1 AND name = 'X')
	 * 
	 */
	
	/**
	 * Get element
	 *
	 * @param unknown_type $key
	 * @return MappingSourceConfig
	 */
	public function getConfig($key) {
		$sourceValue = MappingSourceConfig::getSourceValue($this, $key);
		
		if (is_null($sourceValue)) {
			return new MappingSourceConfig(null, $this->id, $key);
		}
		
		return $sourceValue;
	}
	
	public function setConfig($key, $value) {
		$obj = $this->getConfig($key);
		$obj->setValue($value);
		return MappingSourceConfig::store($obj);		
	}
	
	
	public function __construct($id = null, $type = null, $name = null) {
		$this->id = $id;
		$this->typeId = $type;
		$this->name = $name;
	}
	
	
	public function getId() {
		return $this->id;
	}

	public function setId($id) {
		$this->id = $id;
	}

	public function getTypeId() {
		return $this->typeId;
	}

	public function setTypeId($type) {
		$this->typeId = $type;
	}

	public function getName() {
		return $this->name;
	}

	public function setName($name) {
		$this->name = $name;
	}
	
	static public function query($sql){
		return MappingDatabaseConnector::query($sql);
	}

	static public function getSeparator() {
		return MappingDatabaseConnector::query("Select delimiter from sourceConfigDelimiter;");
	}
	
	

}

?>