<?php

class MappingSourceConfig {
	
	private $id;
	private $sourceId;
	private $sourceConfigElement;
	private $sourceConfigElementId;	
	private $value;

	private static $fields = array('id', 'sourceId', 'sourceConfigElementId', 'value');

	static public function getSources(MappingSource $source) {
		if (!$sources = MappingDatabaseConnector::get(
					'sourceConfig',
					self::$fields,
					__CLASS__,
					array(
						"sourceConfigElementId IN (SELECT id FROM sourceConfigElement WHERE typeId = {$source->getTypeId()})",
						"sourceId = {$source->getId()}"
					)
					)) {
			//die ('something went bad..'); //todo: better error handeling
			return null;
		}
		return $sources;
	}
	
	static public function getSourceValue(MappingSource $source, $name) {
		if (!$source = MappingDatabaseConnector::get(
					'sourceConfig',
					self::$fields,
					__CLASS__,
					array(
						"sourceConfigElementId = (SELECT id FROM sourceConfigElement WHERE typeId = {$source->getTypeId()} AND name = '{$name}')",
						"sourceId = {$source->getId()}"
					)					
					)) {
			//die ('something went bad..'); //todo: better error handeling
			return null;
		}			
		return $source;
	}
	
	static public function store(MappingSourceConfig $sourceConfig) {
		// Check if we have the $sourceConfigElementId or $sourceConfigElement
		if ($sourceConfig->getSourceConfigElementId() == '') {			
			$sourceConfigElement = MappingDatabaseConnector::get('sourceConfigElement', 'id', null, array("typeId = (SELECT typeId FROM source WHERE id = {$sourceConfig->getSourceId()} ) AND name = '{$sourceConfig->getSourceConfigElement()}'"));
			if (!isset($sourceConfigElement[0]['id'])) {
				die('Error: 2387283728');
			}
			$sourceConfig->setSourceConfigElementId($sourceConfigElement[0]['id']);
		} 
		return MappingDatabaseConnector::set('sourceConfig', 'id', self::$fields, $sourceConfig);
	}
	
	
	// SELECT * FROM sourceConfig WHERE sourceConfigElementId = (SELECT id FROM sourceConfigElement WHERE typeId = 1 AND name = 'X')
	
	public function __construct($id = null, $sourceId = null, $sourceConfigElement = null, $sourceConfigElementId = null, $value = null) {
		$this->id = $id;
		$this->sourceId = $sourceId;
		$this->sourceConfigElement = $sourceConfigElement;
		$this->sourceConfigElementId = $sourceConfigElementId;
		$this->value = $value;
	}
	
	
	public function getId() {
		return $this->id;
	}

	public function setId($id) {
		$this->id = $id;
	}

	public function getSourceId() {
		return $this->sourceId;
	}

	public function setSourceId($sourceId) {
		$this->sourceId = $sourceId;
	}

	public function getSourceConfigElementId() {
		return $this->sourceConfigElementId;
	}

	public function getSourceConfigElement() {
		return $this->sourceConfigElement;
	}

	public function setSourceConfigElementId($sourceConfigElement) {
		$this->sourceConfigElementId = $sourceConfigElement;
	}

	public function getValue() {
		return $this->value;
	}
	
	public function __toString() {
		return isset($this->value) ? $this->value : '';
	}

	public function setValue($value) {
		$this->value = $value;
	}
		
}

?>