<?php

class MapppingManager {
	
	private static $dbh;
	
	const DB_FILE = '/opt/openit/db/map/map.dbl';
	
	static private function getConnection() {
	$os = "";
	//for checking of OS
	if (strstr(PHP_OS, "WIN")){
	$dblPath = $_SERVER['DOCUMENT_ROOT'] . '/../db/map/map.dbl';
	} else {
	$dblPath = MapppingManager::DB_FILE;
	}
		if (is_null(self::$dbh)) {
			try {
				//self::$dbh = new PDO('sqlite:' . ServerConfig::getDatabasePath() . '/../test.db');
				if (!file_exists(realpath($dblPath))) {
					
					// Try to create it...
					if (file_exists($_SERVER['DOCUMENT_ROOT'] . "/../db/map/sql/1.txt")) {		
						$db = new PDO("sqlite:" . $dblPath);
						$sql = file_get_contents($_SERVER['DOCUMENT_ROOT'] . "/../db/map/sql/1.txt");
						$db->exec($sql);
						unset($db);
					}					
					
					if (!file_exists(realpath($dblPath))) {
						die("Error creating mapping database..");
						//throw new Exception('No mapping file...');
					}
				}
				self::$dbh = new PDO('sqlite:' .realpath($dblPath));
				self::$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch (PDOException $e) {
				die($e->getMessage() . '-g');
			}
		}
		return self::$dbh;
	}	
	
	static public function getSources() {
		
		$dbh = self::getConnection();
		
		try {
			$result = self::$dbh->query("SELECT * FROM source");
			$rows = $result->fetchAll(PDO::FETCH_ASSOC); 
		} catch (PDOException $e) {
			die($e->getMessage());
		}
		
		$sources = array();
		foreach($rows as $i => $row) {
			$id = isset($rows[$i]['id']) ? $rows[$i]['id'] : null;
			$type = isset($rows[$i]['type']) ? $rows[$i]['type'] : null;
			$name = isset($rows[$i]['name']) ? $rows[$i]['name'] : null;
			
			$sources[] = new MappingSource($id, $type, $name);	
		}
		
		return $sources;
	}
	
	static public function getSource($id) {
		
		$dbh = self::getConnection();
		
		try {
			$result = self::$dbh->query("SELECT * FROM source WHERE id = " . $id);
			$rows = $result->fetchAll(PDO::FETCH_ASSOC); 
		} catch (PDOException $e) {
			die($e->getMessage());
		}
		
		if (count($rows) == 1) {
			$id = isset($rows[0]['id']) ? $rows[0]['id'] : null;
			$type = isset($rows[0]['type']) ? $rows[0]['type'] : null;
			$name = isset($rows[0]['name']) ? $rows[0]['name'] : null;
			
			return new MappingSource($id, $type, $name);	
		}
		
		return null;
	}
	
	
}

?>