<?php

/**
 * UserHelper
 * 
 * A simple static class that helps handling the current logged in user
 * 
 * @static 
 * @version 2
 *
 */

class UserHelper {
	
	const SESSION_CACHE_KEY = "c2bfa79ee58f8010748a297de15e3543";
	
	/**
	 * Get the current user
	 *
	 * @return User Current logged in user object
	 */
	static public function getCurrentUser() {
		if (isset($_SESSION[self::SESSION_CACHE_KEY]) && $_SESSION[self::SESSION_CACHE_KEY] instanceof User) {
			return $_SESSION[self::SESSION_CACHE_KEY];
		}
		return new User();
	}
	
	/**
	 * Set current user object to session
	 *
	 * @param User $user
	 */
	static public function setCurrentUser(User $user) {
		$_SESSION[self::SESSION_CACHE_KEY] = $user;
	}
	
	static public function isLoggedIn() {
		if (isset($_SESSION[self::SESSION_CACHE_KEY]) && $_SESSION[self::SESSION_CACHE_KEY] instanceof User) {
			return true;
		}
		return false;
	}
	
	
}

?>