<?php

class ParserSettings {
	
	// Config values
	const COMMENT_CHAR 		= 1;
	const SPLIT 			= 2;
	const SKIP_BLANK_LINES	= 3;
	const SKIP_COMMENTS		= 4;
	const ONLY_LINES_THAT_STARTS_WITH = 5;	
	
		
	// Split type
	const SPLIT_TYPE_WHITE_SPACE	= 101;
	const SPLIT_TYPE_SPACE			= 102;	
	const SPLIT_TYPE_TAB 			= 103;
	const SPLIT_TYPE_COMMA 			= 104;
	const SPLIT_TYPE_PIPE 			= 105;
	const SPLIT_TYPE_EQUALS			= 106;
	const SPLIT_TYPE_SEMI_COLON		= 107;
	const SPLIT_TYPE_PROSENTAGE		= 108;
	const SPLIT_TYPE_PARENTESE_START= 109;	
	
	private $config;
	
	public function __construct($key = null, $value = null) {
		$this->config = array();
		if ($key != null && $value != null) {
			$this->config[$key] = $value;
		}
	}

	/**
	 * @return ParserSettings
	 */	
	public static function create($key, $value) {
		return new ParserSettings($key, $value);
	}
	
	
	/**
	 * @return ParserSettings
	 */
	public function set($key, $value) {
		
		if (!isset($this)) {			
			return new ParserSettings($key, $value);
		}

		$this->config[$key] = $value;
		return $this;
	} 
	
	public function get($key) {
		return isset($this->config[$key]) ? $this->config[$key] : null;
	} 
	 
		
}

?>