<?php

/**
 * SearchBuilder class
 * 
 * The class that builds the SearchEntry and SearchGroup objects
 * 
 */
class SearchBuilder {
	
	
	public static function getSearchGroups($selections) {
		
		$groups = array();
		$group = null;
		
		$lastId = null;
		$lastValue = null;
			
		foreach($selections as $value => $id) {
			
			// Check if the id is different from the previous id
			if ($lastId != $id) {
				$lastId = $id;
				
				// Reset last value
				$lastValue = null;
				
				// And previous group to list
				if (!is_null($group)) {
					$groups[] = $group;
				}
				
				// Create new group
				$group = new SearchGroup($id);
			}
						
			// Check if value is one bigger than last value
			if (($lastValue+1) == $value) {
				
				// Update previous Entry
				$lastEntryIndex = count($group->entries)-1;
				$group->entries[$lastEntryIndex]->toValue = $value;

				// Update last value
				$lastValue = $value;
				
				// Continue to next value
				continue;
			}
			
			// Update last value
			$lastValue = $value;
						
			// Add items to group
			$group->entries[] = new SearchEntry($id, $value);		
		}		
		
		// Add the last group to the list
		if (!is_null($group)) {
			$groups[] = $group;
		}
		
		return $groups;
		
	}
	
}


// Test
//$oo = SearchBuilder::getSearchGroups($data);
//print_r($oo);

?>