<?php

class SearchGenerator {
	
	public static $done;
	public static $relations;
	
	public static function generateSql($classificationUID, $groups, $relations) {

		self::$relations = $relations;
        //$classificationFilter = wgDbClassificationFilter::getSql();
		
		$SQL = "SELECT DISTINCT id, value, anonymous, static FROM ClassificationValue WHERE classificationId = " . $classificationUID;

		// For each group
		foreach ($groups as $group) {

			$subSQL = "";
			
			foreach($group->entries as $index => $entry) {
	
				/* @var $entry SearchEntry */
				self::$done = array();	
						
				if (!($classificationUID == $entry->id)) {
					$subSQL .= self::generateSubQuery($classificationUID, $entry->id, $entry->value, $entry->toValue, ($index != 0 ? "OR" : ''));
				}
				
			}			
			
			if ($subSQL != "") {
				$SQL .=  " AND ( " . $subSQL . " )";
			}				
			
		}
		
		// Hide classification based on a "secret" file... - A quick fix for COP
		$hide = "";			
		if (file_exists('/opt/openit/config/hide')) {
			foreach (file('/opt/openit/config/hide') as $hideValue) {
				$hideValue = trim($hideValue);
				$hide .= "AND value NOT LIKE '{$hideValue}' ";
			}				
		}			
	    $SQL .= $hide . " ORDER BY value;";
		
		return $SQL;		
	}
	
	
	
	/**
	 * Generating SQL subquries
	 * 
	 * @param $dest Classification ID that you want to return
	 * @param $src Classification ID that has a value set
	 * @param $value Classification Value ID that is set
	 * @return string Returns a SQL string 
	 */
	static public function generateSubQuery($dest, $src, $value, $toValue = null, $type = "AND") {

		// Check if the classification is directly connected to us..	
		if (isset(self::$relations[$dest][$src])) {

			if (is_null($toValue)) {			
			
$SQL = <<<EOT
	$type (
	        	id IN (SELECT leftValueId FROM ValuesRelationship WHERE rightValueId = $value)
		OR 	id IN (SELECT rightValueId FROM ValuesRelationship WHERE leftValueId = $value)
  	)
EOT;

			} else {

$SQL = <<<EOT
	$type (
	        	id IN (SELECT leftValueId FROM ValuesRelationship WHERE rightValueId BETWEEN $value AND $toValue)
		OR 	id IN (SELECT rightValueId FROM ValuesRelationship WHERE leftValueId BETWEEN $value AND $toValue)
  	)
EOT;

			}

			return $SQL;
		}

		// if there is no cirectly connection, we need to find the connection
		// this is done by using the relation table
		else {

			// Try first, if none, try next unitil its failing	
			self::$done[$dest] = 1;

			// TODO: find shortest way
			foreach(self::$relations[$dest] as $key => $null) {
				if (isset(self::$done[$key])) continue;			
	
				$data = self::generateSubQuery($key, $src, $value, $toValue, "AND");
				if (trim($data) == "") continue;
		
$SQL = <<<EOT
	$type (
			id IN (
				SELECT leftValueId FROM ValuesRelationship WHERE rightValueId IN ( 
					SELECT id FROM ClassificationValue WHERE classificationId = $key
$data 
				)
			)
		OR	id IN (
				SELECT rightValueId FROM ValuesRelationship WHERE leftValueId IN ( 
					SELECT id FROM ClassificationValue WHERE classificationId = $key
$data
				)
			)
	)
EOT;
				return $SQL;
			}
		}		
	}	
	
	
}


?>