<?php

if (!isset($argv[0])) {
	echo "\nError: 238293\n";
	exit(8);
}

// include path
$path = dirname($argv[0]) . "/../";
$_SERVER["DOCUMENT_ROOT"] = $path;

// Include util classe
require_once($_SERVER["DOCUMENT_ROOT"] . "/../" . "classes/utils.php");

// We have too many classes now, swithing over to autoload..
if (!function_exists("__autoload")) {
	function __autoload($className) {
		$rootPath = $_SERVER["DOCUMENT_ROOT"] . '/../classes/';
	
		$filename = $rootPath . $className . '.php';
		if (file_exists($filename)) {
			require($filename);
			return;
		}
		
		// If we havent find the file here, we would need to check in sub folders
		$subFile = glob($rootPath . '*/' . $className . '.php');
		if (count($subFile) == 1) require($subFile[0]);
	
		// If we havent find the file here, we would need to check in sub folders
		$subFile = glob($rootPath . '*/*/' . $className . '.php');
		if (count($subFile) == 1) require($subFile[0]);
	
		// If we havent find the file here, we would need to check in sub folders
		$subFile = glob($rootPath . '*/*/*/' . $className . '.php');
		if (count($subFile) == 1) require($subFile[0]);		
	}
}


// Get existing database in use
$dbFolder = realpath(ServerConfig::getDatabasePath()); 
$fileSeparator = strstr(PHP_OS, "WIN") ? "\\" : "/";
$currrentDatabase = str_replace($dbFolder . $fileSeparator, "", realpath(ServerConfig::getDatabase()));

// Delete all other databases, and temp files
Logger::Info("{CLI:resfreshdata.php}", "Removing old databases");
foreach (glob($dbFolder . "/*.s3db*") as $filename) {
	if (!(strstr($filename, $currrentDatabase))) {
		Logger::Debug("{CLI:resfreshdata.php}", "Removing database file: " . $filename);
		@unlink($filename);
	}    
}


// Reload configuration
if (strstr(PHP_OS, "WIN")){
	$br = new BackendReader($_SERVER["DOCUMENT_ROOT"] . "/../../Configuration/httpd/httpd.conf");
} else {
	$br = new BackendReader("/var/opt/openit/etc/httpd/httpd.conf");
}
$cfg = "http://127.0.0.1:" . $br->getPort() ."/OpeniT/config_dump.pl?version=5.4";
$config = new ConfigReader($cfg);

// Update the database
if ($config->parse() === false) {
	echo "[Warning] " . date("r") . ": [WEBGUI] Datebase reloading failed, trying another source...\n";
	$config = new ConfigReader(ServerConfig::getServerUrl() . 'config_dump.pl?version=5.4');
	if (!$config->parse()) die("[Critical] " . date("r") . ": [WEBGUI] Datebase reloading failed!\n");
}

// Log
Logger::Info("{CLI:resfreshdata.php}", "The database has been reloaded");

// Write to ouput
echo "[INFO] " . date("r") . ": [WEBGUI] The database has been reloaded\n";

