BEGIN;

CREATE TABLE "Users" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"username" VARCHAR(255) NOT NULL,
	"password" VARCHAR(255) NULL,
	"name" VARCHAR(255) NULL,
	"division" VARCHAR(255) NULL,
	"admin" INTEGER DEFAULT '0' NULL,
	"agreement" INTEGER DEFAULT '0' NULL,	
	"templateUser" INTEGER DEFAULT '0' NULL,
	"viewUser" INTEGER DEFAULT '0' NULL,
	"reportGeneratorUser" INTEGER DEFAULT '0' NULL
);
				
CREATE TABLE "Groups" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"name" VARCHAR(255) NOT NULL,
	"description" TEXT NULL
);
				
CREATE TABLE "Members" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"groupId" INTEGER NOT NULL,
	"type" INTEGER NOT NULL,
	"member" INTEGER NOT NULL
);

CREATE TABLE "DataTypeAccess" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"groupId" INTEGER NOT NULL,
	"datatypeId" INTEGER NOT NULL,
	"visible" INTEGER NOT NULL
);

CREATE TABLE "FolderAccess" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"groupId" INTEGER NOT NULL,
	"folder" VARCHAR(255) NOT NULL
);

CREATE TABLE "AnonymousAccess" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"groupId" INTEGER NOT NULL,
	"datatypeId" INTEGER NOT NULL,
	"classificationId" INTEGER NOT NULL
);

CREATE TABLE "ClassificationValuesAccess" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"groupId" INTEGER NOT NULL,
	"datatypeId" INTEGER NOT NULL,
	"value" VARCHAR(255) NOT NULL
);

CREATE TABLE "ClassificationValuesRegularAccess" (
	"id" INTEGER PRIMARY KEY NOT NULL,
	"groupId" INTEGER NOT NULL,
	"datatypeId" INTEGER NOT NULL,
	"type" INTEGER NOT NULL,
	"value" VARCHAR(255) NOT NULL
);

INSERT INTO Users VALUES (null, "admin", "21232f297a57a5a743894a0e4a801fc3", "Admin User", null, 1, 1, 0, 0, 0);
				
COMMIT;