<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

$accessControlManager = new AccessControlManager();
	
if ($_REQUEST["id"] != "new" && $_REQUEST["id"] != "") {	
	$user = $accessControlManager->getUser($_REQUEST["id"]);
	if (!$user) {
		header("Location: index.php");	
		return;
	}
} else {

	// Verify that the user name is not taken
	$userNameCheck = $accessControlManager->getUser(null, strtolower($_REQUEST["edit_username"]));
	if ($userNameCheck) {
		header("Location: index.php?error=" . User::ERROR_USERNAMEEXISTS);
		return;
	}
	$user = new User();
}


// Check some of the values
$username = (trim($_REQUEST["edit_username"]) != "") ? trim($_REQUEST["edit_username"]) : null;
$name = (trim($_REQUEST["name"]) != "") ? trim($_REQUEST["name"]) : null;

// Verify username and name
if (ServerConfig::getPasswordBackend() == AccessControlManager::PASSWORDBACKEND_LOCAL && (is_null($username) || is_null($name))) {
	header("Location: index.php?error=" . User::ERROR_NONAMEORNOUSERNAME);
	return;
}

// If we are using LDAP / AD
if (ServerConfig::getPasswordBackend() == AccessControlManager::PASSWORDBACKEND_AD || ServerConfig::getPasswordBackend() == AccessControlManager::PASSWORDBACKEND_LDAP) {
	if ($ldapUser = AccessControlManager::getLDAPUser($username)) {
		$name = $ldapUser->getName();
	}
}


// Are we changing the username?
if ($user->getUsername() != $username) {
	$userNameCheck = $accessControlManager->getUser(null, strtolower($_REQUEST["edit_username"]));
	if ($userNameCheck && $userNameCheck->getId() != $_REQUEST["id"]) {
		header("Location: index.php?error=" . User::ERROR_USERNAMEEXISTS);
		return;
	}	
}



// Set values
if($_SESSION["USER"]->getName()==$user->getName()) $_SESSION["USER"]->setName($_REQUEST["name"]);
$user->setUsername(strtolower($_REQUEST["edit_username"]));
$user->setName($_REQUEST["name"]);
$user->setDivision($_REQUEST["division"]);

if($_SESSION["USER"]->isAdmin()){
	$user->setAdmin($_REQUEST["admin"]);
	$user->setAgreement($_REQUEST["agreement"]);
	// Set roles
	$user->setTemplateUser(empty($_REQUEST["templateuser"]) ? 0 : 1);
	$user->setViewUser(empty($_REQUEST["viewuser"]) ? 0 : 1);
	$user->setReportGeneratorUser(empty($_REQUEST["reportgeneratoruser"]) ? 0 : 1);
	$user->setRealTimeUser(empty($_REQUEST["realtimeuser"]) ? 0 : 1);
	$accessControlManager->removeMembersFromUser($user);
	
	if (!empty($_REQUEST["group"])) {
		$accessControlManager->addMembersFromUser($user, $_REQUEST["group"]);
	}
}

if (!empty($_REQUEST["edit_password"])) {
	$user->setPassword($_REQUEST["edit_password"]);
}


//if($_SESSION["USER"]->isAdmin()){
	
//}
// save user
if (!$user->store()) {
	die("Error while saving to db...");
}

// This values are set in "UserSettings", and need to be set after the user object is set
$user->setLanguage($_REQUEST["language"]);
$user->setLanguage($_REQUEST["language"]);

//if($_SESSION["USER"]->isAdmin()){
	// update members
	
//}

if($_SESSION["USER"]->isAdmin()){
	header("Location: index.php");
}else{
	//echo "<script language='javascript'>";
	//echo "alert('Your account has been successfully updated.');";
	//echo "window.location=\"edit_user.php?id=".$_SESSION[UserHelper::SESSION_CACHE_KEY]->getId() . "\"";
	header("Location: edit_user.php?id=".$_SESSION[UserHelper::SESSION_CACHE_KEY]->getId()."&success=true");
	//echo "</script>";
}

?>
