<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

// Load presentation layer class
$presentation = new Presentation();


// Status
$status = "";
if (isset($_REQUEST["status"])) {
	switch ($_REQUEST["status"]) {
		case 1:
			$status = $presentation->getText("administration_configuration_status_1");
			break;
		case 2:
			$status = $presentation->getText("administration_configuration_status_2");
			break;
	}
}

// Set values
$presentation->assign("status", $status);

$presentation->assign("title", ServerConfig::getTitle());
$presentation->assign("server", ServerConfig::getServer());
$presentation->assign("client", ServerConfig::getClient());
$presentation->assign("loglevel", ServerConfig::getLogLevel());
$presentation->assign("logfile", (ServerConfig::getLogFile() == "") ? "" : ((strstr(PHP_OS, "WIN")) ? str_replace("\\","/",realpath(ServerConfig::getLogFile())) : realpath(ServerConfig::getLogFile())));
$presentation->assign("charset", ServerConfig::getCharset());
$presentation->assign("charsets", ServerConfig::getAvailableCharset());
$presentation->assign("language", ServerConfig::getDefaultLanguage());
$presentation->assign("languages", ServerConfig::getAvailableLanguages());
$presentation->assign("weekformat", ServerConfig::getWeekFormat());
$presentation->assign("reusereportwindow", ServerConfig::getReuseReportWindow());
$presentation->assign("passwordBackend", ServerConfig::getPasswordBackend());
$presentation->assign("topbanner", ServerConfig::getTopBanner());
$presentation->assign("bottombanner", ServerConfig::getBottomBanner());

/*
$presentation->assign("ldapServer", "192.168.7.10");
$presentation->assign("ldapSuffix", "@svg.openit.local");
$presentation->assign("ldapBaseDn", "dc=svg,dc=openit,dc=local");
$presentation->assign("ldapUsername", "Administrator");
$presentation->assign("ldapPassword", "glennerkul");
*/


// Read only variables
$presentation->assign("database", basename(ServerConfig::getDatabase()));
$presentation->assign("dbversion", ServerConfig::getDbVersion());


// Show presentation
$presentation->display("pages/admin/configuration.php");


?>