<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

$reportSelection = new ReportSelection();

// Load presentation layer class
$presentation = new Presentation();

// Load active datatype
$dataType =& $_SESSION["ACTIVE"]; 

// If we miss a data type, or there is not enough selections - display an error
if (is_null($dataType) || ($_SESSION[SELECTED_PRESENTATION] == "chart" && $dataType->getNumberOfSelectedClassifications() < 2) || $dataType->getNumberOfSelectedMeasurements() == 0) {
	header("Location: presentation.php");
	return;
}

// Set default folder
if ($reportSelection->get("generation_folder") == "") {
	$defaultFolder = null;
	
	foreach ($_SESSION[UserHelper::SESSION_CACHE_KEY]->getFolders() as $folder) {
		if (is_null($defaultFolder)) {
			$reportSelection->set("generation_folder", $folder);
		}
	
		if (substr_count($folder->getName(), "Trashcan") > 0) {
			$reportSelection->set("generation_folder", $folder->getName());
			break;
		}else $reportSelection->set("generation_folder", $folder->getName());
	}
}


// Check if we are using resolution
$classifications =& $dataType->getClassifications();
foreach ($classifications as $classification) {
	if ($classification->getId() == "T" ) {

		if ($classification->isSelected()) {
			
			// If we are using table, make sure its not unasigned
			if ($_SESSION[SELECTED_PRESENTATION] == "table") {
				
				// Default all classifications are located in box 2
				$box = 2;
				
				// Check if the classification has been given another box position
				if ($reportSelection->get("table_classification_location_", $classification->getId()) != "") {
					@list($box, $index) = @explode(":", $reportSelection->get("table_classification_location_", $classification->getId()));
				}
				
				// If the position is something other than unassigned, then show resolution
				if ($box != 1) {
					$reportSelection->set("resolution", true);
				} else {
					$reportSelection->set("resolution", false);
				}
				
			} else {
				$reportSelection->set("resolution", true);
			}
		
		} else {
			$reportSelection->set("resolution", false);
		}
		break;	
	}
}


// Set default values
// "Peridic job"
if ($reportSelection->get("generation_periodic") == "") $reportSelection->set("generation_periodic", "D");
if ($reportSelection->get("generation_periodic_value") == "") $reportSelection->set("generation_periodic_value", "1");
// top
if ($reportSelection->get("table_filter_top_text") == "") $reportSelection->set("table_filter_top_text", "50");
if ($reportSelection->get("generation_timeout") == "") $reportSelection->set("generation_timeout", "10");




// Assing variables to template
$presentation->assign("selection", $reportSelection);
$presentation->assign("folders", $_SESSION["USER"]->getFolders());
$presentation->display("pages/complete_selection/generation.php");

?>