<?php

// No time limit
set_time_limit(0);

$type = isset($_REQUEST["type"]) ? $_REQUEST["type"] : null;
$id = isset($_REQUEST["id"]) ? $_REQUEST["id"] : null;
if (is_null($type)) return;


// Init Data Loader
//$dataLoader = new DataLoader();

// Load presentation layer class
$presentation = new Presentation();

$reportSelection = new ReportSelection();

// Load active datatype
$dataType =& $_SESSION["ACTIVE"];

if (!is_null($dataType)) {

	$data = array();
	
	if ($type == "measurements" || $type == "all") {
		// Load Measurements from active DataType
		$presentation->assign("measurements", $dataType->getMeasurements());
		
		// Test if the selected measurement is still in list, if not, set the first one
		//$reportSelection->set("graphic_measurement", "");
		
		$data["measurements"] = $presentation->get_content("components/complete_selection/measurement_list.php", "pages/complete_selection/index.php");
	}
	
	if ($type == "classifications" || $type == "all") {
		// Load Classifications from active DataType
		$presentation->assign("classifications", $dataType->getClassifications());
		
		// Empty 
		$reportSelection->set("graphic_classification_primary", "");
		$reportSelection->set("graphic_classification_secondary", "");
		
		$data["classifications"] = $presentation->get_content("components/complete_selection/classification_list.php", "pages/complete_selection/index.php");		
	}
	
	if ($type == "classificationvalues" && !is_null($id)) {
		
		// Load classificationvalues from active DataType		
		$classification = $dataType->getClassification($id);
		
		$enableMasking = $_SESSION["USER"]->isClassificationAnonymous($dataType->getId(), $classification->getID()) ? false : true;
		
		$presentation->assign("selection", new ReportSelection());
		$presentation->assign("enablemasking", $enableMasking);
		$presentation->assign("classification", $classification);
		$presentation->assign("classificationName", $classification->getValue());
		$presentation->assign("classificationvalues", $classification->getClassificationValues());
		Logger::Debug(__FILE__, 'Start rendering page', __LINE__);
		$data["classificationvalues"] = $presentation->get_content("components/complete_selection/classification_value_list.php", "pages/complete_selection/index.php");
		Logger::Debug(__FILE__, 'Page is done rendering', __LINE__);		
	}
	

	// Return data as a JSON array/object
	echo php2js($data);

	
} else {
	
}

?>
