<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

// Load presentation layer class
$presentation = new Presentation();

// Get all Data Types
$dataTypes = DatabaseManager::getDataTypes();

$reportSelection = new ReportSelection();

// Check if we need to filter the datatypes list
if ($reportSelection->get("modulesList") != "" && $reportSelection->get("modulesList") != "ALL") {
	$module = new Module($reportSelection->get("modulesList"), "");
	$dataTypes = $module->getDataTypes();
}




// Send data to presentation template
$presentation->assign("generation_disabled", ($reportSelection->get("graphic_classification_primary") == "") ? true : false);

$presentation->assign("modules", DatabaseManager::getModules());
$presentation->assign("datatypes", $dataTypes);
$presentation->assign("selection", $reportSelection);



/*
$_SESSION[SESSION_DATATYPE] = $dataLoader->getDataType(32);
$dataType =& $_SESSION[SESSION_DATATYPE];
*/


// Load active datatype
$dataType =& $_SESSION["ACTIVE"];

// If we don't have any dataype selected, make sure that presentation and generation tab is disabled
if (is_null($dataType)) {
	ViewState::setState("complete_selection_presentation", ViewState::DISABLED, true);
	ViewState::setState("complete_selection_generation", ViewState::DISABLED, true);
}


$datatypeId = null;


if (!is_null($dataType)) {

	// Send active datatype id to presentation
	$datatypeId = $dataType->getUID();
	
	// Load Measurements and Classifications from active DataType
	$measurements = $dataType->getMeasurements();
	$classifications =& $dataType->getClassifications();

	// Send data to presentation template
	$presentation->assign("measurements", $measurements);
	$presentation->assign("classifications", $classifications);
		
}

// Send active datatype id to presentation
$presentation->assign("datatypeId", $datatypeId);


/*
$classification =& $dataType->getClassification(183);
$classificationvalues = $classification->getValues();
$presentation->assign("classificationvalues", $classificationvalues);
*/

$presentation->assign("classificationvalues", null);

// Show presentation
$presentation->display("pages/complete_selection/index.php");

?>