<?php

// No time limit
set_time_limit(0);

$reportSelection = new ReportSelection();
$params = $reportSelection->getVariables();


$report = new ReportGenerator(ServerConfig::getServerUrl());

$filter = "0";
$treshold = "";
$yAxis = false;


// Set presentation type
$report->setPresentationType($_SESSION[SELECTED_PRESENTATION]);


foreach ($params as $key => $value) {
	//echo $key . " = " . $value . "\n";
	
	switch ($key) {
		
		case "generation_timeout":
			$report->setArgument("timeout", (is_numeric($reportSelection->get("generation_timeout")) ? $reportSelection->get("generation_timeout") : 10));
			break;

		case "generation_date_from":
			$report->setFrom($value);
			break;

		case "generation_date_to":
			$report->setTo($value);
			break;
		
		case "generation_date_from_year":
			$report->setFromDate($value);
			break;
		
		case "generation_date_to_year":
			$report->setToDate($value);
			break;

		case "generation_title":
			$report->setTitle($value);
			break;

		case "generation_folder":
			$report->setFolder($value);
			break;
			
		// graphic
		case "graphic_measurement":
			$report->setArgument("av", $value);
			break;
		
		case "graphic_classification_primary":
			if ($value == "T") {
				$report->setArgument("pnum", 2);
			} else {
				$report->setArgument("pnum", $value + 3);
			}
			break;
		
		case "graphic_classification_secondary":
			if ($value == "T") {
				$report->setArgument("snum", 2);
			} else {
				$report->setArgument("snum", $value + 3);
			}
			break;
		
		case "graphic_chart_type":
			$report->setArgument("pres", $value);
			break;
		
		case "graphic_chart_bar_type":
			$report->setArgument("stack", $value);
			break;
		
		case "graphic_filter":
			$filter = $value;
			break;
			
		case "graphic_filter_top_text":
			if ($filter != "top") break;
			$report->setArgument("top", $value);
			break;
			
		case "graphic_filter_top_others":
			if ($filter != "top") break;
			$report->setArgument("others", $value);
			break;
			
		// 2
//		case "graphic_filter_threshold_type":
//			if ($filter != "threshold") break;
//			$treshold = $value;
//			break;
//			
//		case "graphic_filter_threshold_value":
//			if ($filter != "threshold") break;
//			$report->setArgument("threshold", $value . ":" . $treshold);
//			break;
//			
//		case "graphic_filter_threshold_others":
//			if ($filter != "threshold") break;
//			$report->setArgument("others", $value);
//			break;
			
		// axsis
		case "graphic_y_axis":
			if ($value) {
				$yAxis = 1;
			} else {
				$yAxis = 0;
			}
			break;
		
		case "graphic_y_axis_minimum":
			if ($yAxis != 1) break;
			$report->setArgument("y_min", $value);
			break;
		
		case "graphic_y_axis_maximum":
			if ($yAxis != 1) break;
			$report->setArgument("y_max", $value);
			break;
		
			
		case "resolution":
			if ($value) {
				$report->setResolution($reportSelection->get("generation_resolution"));
			}
			break;
	}
	
}

$dataType =& $_SESSION["ACTIVE"];

/* @var $dataType DataType */
$classifications = $dataType->getClassifications();
$measurements = $dataType->getMeasurements();

$report->setDataType($dataType);


// Let's check what kind of parameters we need to send

// Chart 
if ($_SESSION[SELECTED_PRESENTATION] == "chart") {

	// Filters
	$displayFilter = $reportSelection->get("graphic_filter");
	if ($displayFilter == "top") {
		$report->setArgument("top", $reportSelection->get("graphic_filter_top_text"));
		$report->setArgument("others", $reportSelection->get("graphic_filter_top_others") ? "true" : "false");
	} else if ($displayFilter == "threshold") {
		
		
		// value
		if (strpos($reportSelection->get("graphic_filter_threshold_value"), ".")) {
			$threshold = $reportSelection->get("graphic_filter_threshold_value");
		} else {
			$threshold = $reportSelection->get("graphic_filter_threshold_value") . ".0";
		}

		// add split
		$threshold .= ":";
		
		// threshold type/mode
		if (strlen($reportSelection->get("graphic_filter_threshold_type")) == 0) {
			$threshold .= ">";
		} else {
			$threshold .= $reportSelection->get("graphic_filter_threshold_type");
		}
		
		$report->setArgument("threshold", urlencode($threshold));
		
		
		$report->setArgument("others", $reportSelection->get("graphic_filter_threshold_others") ? "true" : "false");	
		$report->setArgument("top", "0");	
	} else {
		$report->setArgument("top", "0");
		$report->setArgument("others", "false");
	}
	
	// Y axsis
	if ($reportSelection->get("graphic_y_axis")) {
		$report->setArgument("y_min", 		$reportSelection->get("graphic_y_axis_minimum"));
		$report->setArgument("y_miny_max", 	$reportSelection->get("graphic_y_axis_maximum"));	
	}

}

// Table
else {
	
	// Table type
	$type = $reportSelection->get("table_filter");
	
	$report->setArgument("pres", "table");
		
	// Measurements
	$av = "";
	$threshold = "";
	$measurements = $dataType->getMeasurements();
	$internalId = -1;
	foreach ($measurements as $measurement) {
		if ($measurement->isSelected() && !$reportSelection->get("table_measurement_" . $type . "_exclude_", $measurement->getId())) {
			
			$internalId++;
			
			if ($av != "") $av .= ",";
			$av .= $measurement->getId();
			
			
			// vsort
			if ($reportSelection->get("table_measurement_" . $type . "_sort") == $measurement->getId()) {
				$report->setArgument("vsort", $internalId);
			}
			
			// rank (top by)
			if ($reportSelection->get("table_measurement_" . $type . "_rank") == $measurement->getId()) {
				$report->setArgument("vtop", $internalId);
			}
			
			// threshold
			if ($type == "threshold") {
				if ($threshold != "") $threshold .= ",";
				$threshold .= $reportSelection->get("table_measurement_threshold_value_", $measurement->getId()) . ":" . $reportSelection->get("table_measurement_threshold_type_", $measurement->getId());
				//$threshold .= $reportSelection->get("table_measurement_threshold_exclude_", $measurement->getId()) . ":" . $reportSelection->get("table_measurement_threshold_type_", $measurement->getId());
			}
			
			// top
			if ($reportSelection->get("table_filter_" . $type . "_text") != "") {
				$report->setArgument("top", $reportSelection->get("table_filter_" . $type . "_text"));	
			}
						
			// others
			$report->setArgument("others", $reportSelection->get("table_filter_" . $type . "_others") ? "true" : "false");
						
			// subtotal
			$report->setArgument("subtotal", $reportSelection->get("table_filter_" . $type . "_subtotal") ? "true" : "false");
			
			// rowspan
			$report->setArgument("rowspan", $reportSelection->get("table_filter_" . $type . "_norowspan") ? "false" : "true");

		}		
	}
	
	$report->setArgument("av", $av);
	if ($threshold != "") {
		$report->setArgument("threshold", urlencode($threshold));
	}
	
	
	// Classification selection - Vertical / Hosizontal / Not included
	$classificationFakeId = array();	// Really don’t like this, but I need to create a fake ID, or else it want work
	$timeIncluded = false;
	$vertical = array();
	$horizontal = array();
	$blankOption = array();
	foreach ($classifications as $classification) {
		if ($classification->isSelected()) {
			
			if ($classification->getId() != "T") {
				$classificationFakeId[] = $classification->getId();
			}
			
			// Check for masking, if found, set it to be anonymous
			if ($reportSelection->get("anonymous_", $classification->getUID()) == 1) {
				$report->setAnonymous($classification->getId());
			}
			
			// In case of blank
			//if ($blankOption != "") $blankOption .= ",";
			if ($classification->getId() == "T") {
				$blankOption[] = "2";
			} else {
				$blankOption[] = count($classificationFakeId) + 3;
			}
			
			if ($reportSelection->get("table_classification_location_", $classification->getId()) == "") {
				$box = 2;
				$index = count($vertical) + 100;
			} else {
				list($box, $index) = explode(":", $reportSelection->get("table_classification_location_", $classification->getId()));	
			}
			
			switch ($box) {
				
				case 2:
					//if ($vertical != "") $vertical .= ",";
					if ($classification->getId() == "T") {
						$timeIncluded = true;
						$vertical[$index] = "2";
					} else {
						if ($timeIncluded) {
							$vertical[$index] = count($classificationFakeId) + 3;
						} else {
							$vertical[$index] = count($classificationFakeId) + 3;
						}
					}
					break;
					
				case 3:
					//if ($horizontal != "") $horizontal .= ",";
					if ($classification->getId() == "T") {
						$timeIncluded = true;
						$horizontal[$index] = "2";
					} else {
						if ($timeIncluded) {
							$horizontal[$index] = count($classificationFakeId) + 3;
						} else {
							$horizontal[$index] = count($classificationFakeId) + 3;
						}
					}
					break;
					
				default:
					if ($classification->getId() == "T") $timeIncluded = true;
					break;
			}		
			
		}
	}
	
	ksort($blankOption);
	ksort($vertical);
	ksort($horizontal);
	
	// Are both vertical and horizontal blank, set all to vertical
	if ($vertical == "" && $horizontal == "") {
		$report->setArgument("vertical", implode(",", $blankOption));
		$report->setArgument("horizontal", "");
	} else {
		$report->setArgument("vertical", implode(",", $vertical));
		$report->setArgument("horizontal", implode(",", $horizontal));
	}
	
	
}


// Default - Should be moved into ReportGenerator
$report->setArgument("command", "instant");
//$report->setArgument("loc", "NO,no,null");



// Periodic
if (!empty($_REQUEST["periodic"])) {
	$report->setArgument("freq", $reportSelection->get("generation_periodic"));
	$report->setArgument("pperiod", $reportSelection->get("generation_periodic_value"));
	$report->setArgument("command", "add");
	$report->setArgument("from", "0");
	$report->setArgument("to", "0");	
}


// Setting Period - Used if we generate a template from the report (Bug #3778)
if ($reportSelection->get('generation_period') != '') {
	$report->setArgument("period", $reportSelection->get('generation_period'));	
}
// - default value if we dont have the value...
else {
	$report->setArgument("period", "M");	
}


if (!$report->isValid()) {
	$return["STATUS"] = "ERROR";
	$return["MESSAGE"] = "Not valid!";
	echo php2js($return);
	return;
}

/*
$return["STATUS"] = "ERROR";
$return["MESSAGE"] = "VALID!";
echo php2js($return);
return;
*/

$report->generate();


?>