<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

// Load presentation layer class
$presentation = new Presentation();

// Load active datatype
$dataType =& $_SESSION["ACTIVE"];

// If we miss a data type, or there is not enough selections - display an error
if (is_null($dataType) || $dataType->getNumberOfSelectedClassifications() == 0 || $dataType->getNumberOfSelectedMeasurements() == 0) {
	$presentation->assign("generation_disabled", true);
	$presentation->display("pages/complete_selection/error_selections.php");
	return;
}

// Load Measurements and Classifications from active DataType
$measurements = $dataType->getMeasurements();
$classifications = $dataType->getClassifications();


// If the user has't done any selections yet, we do some selections for him
$reportSelection = new ReportSelection();

// Classifications
if ($reportSelection->get("graphic_classification_primary") == "" && $reportSelection->get("graphic_classification_secondary") == "") {
	// Find the first and second selected classifications
	foreach ($classifications as $classification) {
		if ($classification->isSelected()) {
			if ($classification->getId() == "T") {
				$reportSelection->set("graphic_classification_primary", 0);
				$reportSelection->set("graphic_classification_secondary", 1);
				break;
			} else {
				$reportSelection->set("graphic_classification_primary", 1);
				$reportSelection->set("graphic_classification_secondary", 2);
				break;
			}
		}
	}
}

// others
if ($reportSelection->get("graphic_filter") == "") {
	$reportSelection->set("graphic_filter", "0");
}

if ($reportSelection->get("graphic_chart_type") == "") {
	$reportSelection->set("graphic_chart_type", "bar");
}

if ($reportSelection->get("graphic_chart_bar_type") == "") {
	$reportSelection->set("graphic_chart_bar_type", "false");
}

if ($reportSelection->get("graphic_measurement") == "") {
	// Find the first selected measurement
	foreach ($measurements as $measurement) {
		if ($measurement->isSelected()) {
			$reportSelection->set("graphic_measurement", $measurement->getId());
			break;
		}
	}
}

# FOR "TABLE"
if ($reportSelection->get("table_filter") == "") {
	$reportSelection->set("table_filter", "0");
}
	
	
// Table sorting..	
$classificationsSort = array(1 => array(), 2 => array(), 3 => array());
$classifications = $dataType->getClassifications();
$classificationsUndef = array();

foreach ($classifications as $classification) {
	if (!$classification->isSelected()) continue;

	if ($reportSelection->get("table_classification_location_", $classification->getId()) != "") {	
		list($box, $index) = explode(":", $reportSelection->get("table_classification_location_", $classification->getId()));
		$classificationsSort[$box][$index] = $classification;
	} else {
		// Doesn't have a index
		$classificationsUndef[] = $classification;
	}
}

foreach ($classificationsUndef as $classification) {
	$classificationsSort[2][] = $classification;
}

// Sort arrays
if (isset($classificationsSort[1]) && is_array($classificationsSort[1])) ksort($classificationsSort[1]);
if (isset($classificationsSort[2]) && is_array($classificationsSort[2])) ksort($classificationsSort[2]);
if (isset($classificationsSort[3]) && is_array($classificationsSort[3])) ksort($classificationsSort[3]);
$presentation->assign("classificationSort", $classificationsSort);
	

// Send data to presentation template
$presentation->assign("selection", $reportSelection);
$presentation->assign("measurements", $measurements);
$presentation->assign("classifications", $classifications);


// Check wich presentation we should use
if (isset($_REQUEST["type"])) {
	$_SESSION[SELECTED_PRESENTATION] = $_REQUEST["type"];
}

if (!isset($_SESSION[SELECTED_PRESENTATION])) {
	$_SESSION[SELECTED_PRESENTATION] = "chart";
}

// Show presentation
if ($_SESSION[SELECTED_PRESENTATION] == "chart") {
	
	// If we only have one classifcation, we need to disable the "Generation" tab
	if ($dataType->getNumberOfSelectedClassifications() == 1) {
		ViewState::setState("complete_selection_generation", ViewState::DISABLED, true);
	} else {
		ViewState::setState("complete_selection_generation", ViewState::DISABLED, false);	
	}
	
	$presentation->display("pages/complete_selection/presentation_chart.php");
	
	
} else {
	
	// We need to verify that we have aleast one element i vertical box
	ViewState::setState("complete_selection_generation", ViewState::DISABLED, true);
	foreach ($classifications as $classification) {
		if (!$classification->isSelected()) continue;
			@list($box, $index) = @explode(":", $reportSelection->get("table_classification_location_", $classification->getId()));		

			if ($box == "" || $box == 2) {
				ViewState::setState("complete_selection_generation", ViewState::DISABLED, false);
				break;
			} else {
				ViewState::setState("complete_selection_generation", ViewState::DISABLED, true);
			}
			
	}

	// Verify that we have all the variables set
	
	// For the Measurements Section
	$ids = array();
	foreach ($measurements as $measurement) {
		if ($measurement->isSelected()) {
			$ids[] = $measurement->getId();
		}
	}
	
	// Now check for each Display filter
	if (
		$reportSelection->get("table_measurement_0_sort") != "" &&
		$reportSelection->get("table_measurement_0_sort") != "AZ" &&
		!in_array($reportSelection->get("table_measurement_0_sort"), $ids)
		) {
		$reportSelection->set("table_measurement_0_sort", "AZ");
	}
	
	if (
		$reportSelection->get("table_measurement_top_sort") != "" &&
		$reportSelection->get("table_measurement_top_sort") != "AZ" &&
		!in_array($reportSelection->get("table_measurement_top_sort"), $ids)
		) {
		$reportSelection->set("table_measurement_top_sort", "AZ");
	}
	
	if (
		$reportSelection->get("table_measurement_threshold_sort") != "" &&
		$reportSelection->get("table_measurement_threshold_sort") != "AZ" &&
		!in_array($reportSelection->get("table_measurement_threshold_sort"), $ids)
		) {
		$reportSelection->set("table_measurement_threshold_sort", "AZ");
	}
	
	// Display the page
	$presentation->display("pages/complete_selection/presentation_table.php");
}

?>