<?php

// Force reload
$fresh = isset($_REQUEST['fresh']) ? true : false;

// Get realtime data
//This will store temporarily the RealTime Data into this Session
if($fresh || !isset($_SESSION["REALTIME"]["LICENSE_MONITOR"])) {
	$_SESSION["REALTIME"]["LICENSE_MONITOR"] = RealTime::getInstance($fresh,true);
}
$realtime = &$_SESSION["REALTIME"]["LICENSE_MONITOR"];

// Load presentation layer class
$presentation = new Presentation();

// Get user selection
$selection = new ReportSelection();

// Get selected mesasure point..
$measurement = $selection->get(RealTime::GUI_VIEWBY);
$sortBy = $selection->get(RealTime::GUI_SORTBY);
$sortAsc = $selection->get(RealTime::GUI_SORTASC);

// Send data to presentation
switch ($measurement) {

/*
 	case "features":
		$entries = $realtime->getFeatures(true, $sortBy, $sortAsc);
		$presentation->assign("measurement", "features");
		$template = "components/dashboard/license/chart_usage.php";
		break;
*/
	
	case "users":
	case "features":
		$entries = $realtime->getFeatures(true, $sortBy, $sortAsc);
		$presentation->assign("showUsers", true);
		$presentation->assign("measurement", "users");				
		$template = "components/dashboard/license/chart_usage.php";
		break;
		
	case "products":
	default:
		$entries = $realtime->getProducts(true, $sortBy, $sortAsc);
		$presentation->assign("measurement", "products");
		$template = "components/dashboard/license/chart_usage.php";
		break;
}


// Find MAX
$MAX = $selection->get(RealTime::MAX);
$MAX = null;

//if ($fresh || is_null($MAX) || !is_numeric($MAX)) {
if (is_null($MAX) || !is_numeric($MAX)) {
	$MAX = 0;
	$AVG = 0;
	$TOP_MAX = 0;
	$maxes = array();
	foreach ($entries as $entry) {
		$emax = $entry->getRealTimeTotaltLicenses();
		if ($emax > $MAX) $MAX = $emax;
		if ($emax > 0) $maxes[] = $emax;
		$AVG =+ $emax;
	}
	
	// Sort 
	rsort($maxes);
	
	
	// Get top value from registry, if nothing is set, use 5
	// Name: com.openit.server.licensemonitor.topby
	// Set new value like: /module/system_settings/com.openit.server.licensemonitor.topby/set/10
	$TOP = SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.topby", 5); //) ? SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.topby") : 5;
	
	$TOP = 0;
	
	for ($i=0; $i<(count($maxes) >= $TOP ? $TOP : 0); $i++) {
		$TOP_MAX =+ $maxes[$i];
	}
	
	// If we have a TOP_MAX, and the avg of all is smaler than the avg of TOP MAX,
	// we create a new MAX
	if ($TOP_MAX != 0 && (($AVG / count($maxes))*2) < ($TOP_MAX / $TOP)) {
		$MAX = $TOP_MAX / $TOP;
		//$MAX = $AVG*2;
		
	}
	
	// Dont allow max to be less than 1000
	if ($MAX < 1000) $MAX = 1000;
	
	// Dont allow max to be bigger than max license count (default 50000)
	if ($MAX > SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.maxlicensecount", 50000))
		$MAX = SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.maxlicensecount", 50000);
		
	$selection->set(RealTime::MAX, $MAX);
	
}

//$MAX = 50000;
$selection->set(RealTime::MAX, $MAX);


/*
echo '<pre>';
echo "TOP MAX: $TOP_MAX\n";
echo "AVG: $AVG\n";
print_r($maxes);
echo '</pre>';
return;*/

////////////////////////////////



$presentation->assign("realtime", $realtime);

// Send entries and MAX
$presentation->assign("MAX", $MAX);
$presentation->assign("userblock", $selection->get(RealTime::GUI_USERBLOCK));
$presentation->assign("entries", $entries);

$selection = new ReportSelection();
$TIMEZONE_OFFSET = $selection->get(RealTime::GUI_TIMEZONE_OFFSET) != "" && is_numeric($selection->get(RealTime::GUI_TIMEZONE_OFFSET)) ? (int) $selection->get(RealTime::GUI_TIMEZONE_OFFSET) : 0;

// Show presentation
date_default_timezone_set('UTC');
$data = array();
$data["updated"] = date("Y-m-d H:i", $realtime->getLastUpdated() + $TIMEZONE_OFFSET);
$data["rtusage"] = $presentation->get_content($template);
echo json_encode($data);


?>