<?php 

	// Load the initiation file
	require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");
	
	
	if (!function_exists('tt')) {
		function tt($key) {
			$ini = parse_ini_file(ServerConfig::getLanguagePath() . strtolower(ServerConfig::getCharset()) . "/" . ServerConfig::getDefaultLanguage() . ".ini");
			$string = isset($ini[$key]) ? $ini[$key] : "NO KEY WITH : $key";
		
			for ($i=1; $i<func_num_args(); $i++) {
				$value = func_get_arg($i);
				$string = str_replace("%" . $i, $value, $string);
			}
		
			return $string;
		}
	}
	

	//This will store temporarily the RealTime Data into this Session
	if(!isset($_SESSION["REALTIME"]["LICENSE_MONITOR"])) {
		$_SESSION["REALTIME"]["LICENSE_MONITOR"] = RealTime::getInstance(false,true);
		Logger::DEBUG('getInstance', "License Monitor");
	}
	$realtime = &$_SESSION["REALTIME"]["LICENSE_MONITOR"];

	$CSS_for_IE6 = (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6.') !== FALSE) ? '-IE' : '';
	
	$tz = date_default_timezone_get();
	date_default_timezone_set('UTC');
	// Get user selections
	$selection = new ReportSelection();
	
	
	// If we have a offset posted, we use this when displaying checkout time
	$TIMEZONE_OFFSET = $selection->get(RealTime::GUI_TIMEZONE_OFFSET) != "" && is_numeric($selection->get(RealTime::GUI_TIMEZONE_OFFSET)) ? (int) $selection->get(RealTime::GUI_TIMEZONE_OFFSET) : 0;
	$CLIENT_TIME = $selection->get(RealTime::GUI_CLIENT_TIME);
	$CLIENT_TIME = substr($CLIENT_TIME, 0, 10);
	//echo $TIMEZONE_OFFSET . " " . $CLIENT_TIME;  
	$odd = false;
	
	// Get user sort selections
	$userSortBy = $selection->get(RealTime::GUI_USER_SORTBY);
	$userSortAsc = $selection->get(RealTime::GUI_USER_SORTASC);
	
	$overlayFlag = SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.overlay.mapping.data", 0);
	$entry = null;
	
	$MAX = $selection->get(RealTime::MAX);
	$e = 50 / log($MAX);
	$features = $realtime->getFeatures(false);
	
	foreach($features as $feature) {
		if(strtolower($feature->name) == strtolower($_REQUEST["feature"])) {
			$entry  = $feature;
		
			// Get data from object
			$usage = $entry->getRealTimeLicenseUsage(true);
			$usageT = $entry->getRealTimeLicenseUsage();
			$total = $entry->getRealTimeTotaltLicenses();
			
			// Support 0 in totalt
			if ($total == 0 && $usageT > 0) {
				$total = $usageT;
			}
			
				
			// Find % of Available (Natural logarithm)
			$available = log($total - $usageT) * $e;
		
			// Is data going "out-of-screen"
			$availableCorrected = (!is_nan($available) && $available > 50) ? true : false;
			
			
			// Find % of used (Natural logarithm)
			$used = log($usage) * $e;
			$usedT = 0;
				
			// If usage and usage totalt differs, we need to calculate the used for total
			if ($usage != $usageT) {		
				// Find % of used total (Natural logarithm)
				$usedT = log($usageT) * $e;		
			}
			
			// Don't allow any of the values to pass 50%
			if (!is_nan($available) && $available > 50) $available = 50;
			if (!is_nan($used) && $used > 50) 			$used = 50;
			if (!is_nan($usedT) && $usedT > 50) 		$usedT = 50;
			
			// If we have data, don't allow the % to be smaller than 0.3
			if ($used < 0.3 && $usage >= 1) $used = 0.3;
			if ($available < 0.3 && ($total - $usageT) >= 1) $available = 0.3;
			break;
		}
	}
	
	//Query users
	if($overlayFlag > 0) {
		RealTime::LMUserDataQuery($entry->getUsers($userSortBy, $userSortAsc));
	}
	
	
	// Chart display
	if ($selection->get("presentation_type") == "chart") {
	
		
	////////////////
	////////////////   CHART VIEW
	////////////////
?>
<table id="table-users<?=$_REQUEST["feature"];?>" class="sortable list">
		<thead>
			<tr>
				<th><?= tt("dashboard_license_sort_username") ?></th>
				<th><?= tt("dashboard_license_sort_host") ?></th>
				<th class="sorttable_numeric"><?= tt("dashboard_license_sort_time") ?></th>
				<th class="sorttable_numeric"><?= tt("dashboard_license_usage_inuse") ?></th>
			</tr>
		</thead>	
		<tbody>
		<?php
		foreach($entry->getUsers($userSortBy, $userSortAsc) as $user) {
			$displayName = $user->name;
			$result = null;
			if($overlayFlag > 0 && isset($_SESSION["USERDATA"]["SELECTION"][strtoupper($user->name)])){
				$result = $_SESSION["USERDATA"]["SELECTION"][strtoupper($user->name)];
				$firstName = "";
				$lastName = "";
				if(is_array($result)){
					foreach($result as $row){
						if($row['name']=="cn" || $row['name']=="displayName" && $row['value']!=null){
							$displayName = $row['value'];
						}
						if($row['name']=="givenName" && $row['value']!=null) $firstName = $row['value'];
						if($row['name']=="sn"&& $row['value']!=null) $lastName = $row['value'];
					}
				}
				$fullName = $firstName . " " . $lastName;
				/*
				*  If we have display name and it's longer than the concatenated first name and last name use it
				*  Make sure that we use the firstname lastname syntax and not lastname, firstname
				*/
				$displayName = !strstr($displayName, ',') && strlen($displayName) >= strlen($fullName) ? $displayName : $fullName;	
			}
			
			if ($usage != $usageT && !$user->isSelected()) continue;
			$odd = $odd == false ? true : false;
			
			// User friendly time since checkout..
			// Verify that the start date is not in future
			if (time() > $user->start ) {
				$flag = false;
				$timeSpent = time() - $user->start;
				$days = floor($timeSpent / 86400);
				$hours = floor(($timeSpent - ($days * 86400)) / 3600); 
				$minutes = floor(($timeSpent - ($days * 86400) - ($hours * 3600)) / 60);			
				$timeSinceCheckout =  ($days != 0 ? $days . " day(s), " : "") . ($hours != 0 ? $hours . " hour(s), " : "") . $minutes . " minute(s)";
				$CoTimeFlag = ($timeSpent < 0 ? true : false);
			} else {
				$flag = true;
				$timeSpent = 0;
				$timeSinceCheckout = 'N/A';
			}
			
		?>		
			<tr class="<?= $odd ? 'odd' : 'even' ?>">
				<? if($overlayFlag > 0 && count($result) > 1){ ?>
					<td sorttable_customkey="<?= $displayName ?>" class="item drilldown" ><div><img style="float:left; border:0; padding-right:8px" src="/gfx/icons/id_card16.png" /></div><span style="color:#008080;text-decoration:underline; cursor:hand;" onmouseout="showHideDescription('tiptool<?=$user->name?>', false);" onmouseover="showHideDescription('tiptool<?=$user->name?>', true);"><?= strlen($displayName) > 0 ? $displayName : $user->name; ?></span> </td>
				<?}else{?>
					<td sorttable_customkey="<?= trim($user->name); ?>"><?= $user->name; ?></td>
				<?}?>
				<td sorttable_customkey="<?= $user->host ?>"><?= $user->host ?></td>
				<td sorttable_customkey="<?= $timeSpent; ?>">
					<div style="float: left;" <?= $flag ? 'class="redflag" title="The checkout time seems to be collected in the future. Please check the clock on your server and client(s)"' : '' ?>><?= date("Y-m-d H:i", $user->start + $TIMEZONE_OFFSET) ?></div>
					<div style="float: right;" <?= $CoTimeFlag ? 'class="redflag" title="The system clock is incorrect. Please check if it is set to keep synchronized with internet servers, or manually set the correct date/time."' : '' ?>><?= $timeSinceCheckout ?></div>
				</td>
				<td sorttable_customkey="<?= $user->count ?>"><?= $user->count ?></td>
			</tr>					
		<?php } ?>
		</tbody>
	</table>
<?php } else { ?>
	<table id="table-users<?=$_REQUEST["feature"];?>" class="sortable list users">
		<thead>
			<tr>
				<th><?= tt("dashboard_license_sort_username") ?></th>
				<th><?= tt("dashboard_license_sort_host") ?></th>
				<th class="sorttable_numeric"><?= tt("dashboard_license_sort_time") ?></th>
				<th class="sorttable_numeric"><?= tt("dashboard_license_usage_inuse") ?></th>
			</tr>
		</thead>	
		<tbody>
		<?php
		$subTotal = 0;
		foreach($entry->getUsers($userSortBy, $userSortAsc) as $user) {
			$displayName = $user->name;
			$result = null;
			if($overlayFlag > 0 && isset($_SESSION["USERDATA"]["SELECTION"][strtoupper($user->name)])){
				$result = $_SESSION["USERDATA"]["SELECTION"][strtoupper($user->name)];
				$firstName = "";
				$lastName = "";
				if(is_array($result)){
					foreach($result as $row){
						if($row['name']=="cn" || $row['name']=="displayName" && $row['value']!=null){
							$displayName = $row['value'];
						}
						if($row['name']=="givenName" && $row['value']!=null) $firstName = $row['value'];
						if($row['name']=="sn"&& $row['value']!=null) $lastName = $row['value'];
					}
				}
				$fullName = $firstName . " " . $lastName;
				/*
				*  If we have display name and it's longer than the concatenated first name and last name use it
				*  Make sure that we use the firstname lastname syntax and not lastname, firstname
				*/
				$displayName = !strstr($displayName, ',') && strlen($displayName) >= strlen($fullName) ? $displayName : $fullName;	
			}
			
			if ($usage != $usageT && !$user->isSelected()) continue;
			$odd = $odd == false ? true : false;
			$subTotal += $user->count;				
			
			
			// Verify that the start date is not in future
			if (time() > $user->start ) {
				$flag = false;
				$timeSpent = time() - $user->start;
				$days = floor($timeSpent / 86400);
				$hours = floor(($timeSpent - ($days * 86400)) / 3600); 
				$minutes = floor(($timeSpent - ($days * 86400) - ($hours * 3600)) / 60);			
				$timeSinceCheckout =  ($days != 0 ? $days . " day(s), " : "") . ($hours != 0 ? $hours . " hour(s), " : "") . $minutes . " minute(s)";
				$CoTimeFlag = ($timeSpent < 0 ? true : false);			
			}
			
			// .. it is... :~  Flag warning
			else {
				$timeSpent = 0;
				$flag = true;
				$timeSinceCheckout = 'N/A';
			}
		?>		
			<tr class="<?= $odd ? 'odd' : 'even' ?>">
				<? if($overlayFlag > 0 && count($result) > 1){ ?>
					<td sorttable_customkey="<?= $displayName ?>" class="item drilldown" ><div><img style="float:left; border:0; padding-right:8px" src="/gfx/icons/id_card16.png" /></div><span style="color:#008080;text-decoration:underline" onmouseout="showHideDescription('tiptool<?=$user->name?>', false);" onmouseover="showHideDescription('tiptool<?=$user->name?>', true);"><?= strlen($displayName) > 0 ? $displayName : $user->name; ?></span> </td>
				<?}else{?>
					<td sorttable_customkey="<?= $user->name; ?>"><?= $user->name; ?></td>
				<?}?>
				<td sorttable_customkey="<?= $user->host ?>"><?= $user->host ?></td>
				<td sorttable_customkey="<?= $timeSpent ?>">
					<div style="float: left;" <?= $flag ? 'class="redflag" title="The checkout time seems to be collected in the future. Please check the clock on your server and client(s)"' : '' ?>><?= date("Y-m-d H:i", $user->start + $TIMEZONE_OFFSET) ?></div>
					<div style="float: right;" <?= $CoTimeFlag ? 'class="redflag" title="The system clock is incorrect. Please check if it is set to keep synchronized with internet servers, or manually set the correct date/time."' : '' ?>><?= $timeSinceCheckout ?></div>
				</td>
				<td sorttable_customkey="<?= $user->count ?>"><?= $user->count ?></td>
			</tr>					
		<?php } ?>
		</tbody>
	</table>
<?php } ?>