<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

// Store state
if (isset($_REQUEST["folder"])) ViewState::setState("generated_reports", "folder", $_REQUEST["folder"]);
if (isset($_REQUEST["sort"])) ViewState::setState("generated_reports", "sort", $_REQUEST["sort"]);
if (isset($_REQUEST["asc"])) ViewState::setState("generated_reports", "asc", $_REQUEST["asc"]);

// Load state
$folder = ViewState::getState("generated_reports", "folder") != "" ? ViewState::getState("generated_reports", "folder") : null;
$sortBy = ViewState::getState("generated_reports", "sort") != "" ? ViewState::getState("generated_reports", "sort") : "date";
$sortAsc = ViewState::getState("generated_reports", "asc") == "1" ? true : false;

// Load report loader
$reportLoader = new ReportLoader();

// Get folders where we have access to...
if (!$_SESSION["USER"]->isAdmin()) {
	$folders = $_SESSION["USER"]->getFolders();
} else {
	$folders = $reportLoader->getFolders();
}


// No folder set, we make {Trashcan} as the default folder
if (is_null($folder)) {
	$folder = "*"; // Default folder, if we dont find trashcan
	foreach ($folders as $defaultFolder) {
		if ($defaultFolder->getName() == "{Trashcan}") {
			$folder = "{Trashcan}";
		}
	}
}

$reports = $reportLoader->getReports($folder, $sortBy, $sortAsc);

// Load presentation layer class
$presentation = new Presentation();

// Send data to presentation
$presentation->assign("currentFolder", is_null($folder) ? "" : $folder);
$presentation->assign("folders", $folders);
$presentation->assign("reports", $reports);

$presentation->assign("selectedFolder", $folder);
$presentation->assign("sortAsc", $sortAsc);
$presentation->assign("server", ServerConfig::getServerUrl());

// Show presentation
$presentation->display("pages/generated_reports/index.php");

?>