<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

// Clean up cache controller for Complete Selection
$_SESSION["ACTIVE"] = null;

// Load presentation layer class
$presentation = new Presentation();

// Get templates
$templateLoader = new TemplateLoader();

// Fetch templates in tree mode
$presentation->assign("templates", $templateLoader->getTemplateTreeByUser($_SESSION["USER"]));
$presentation->assign("folderstatus", $templateLoader->getFolderStatus());

// Try to load previous template, and tell the menu if it was user enabled
$reportSelection = new ReportSelection();
$template = $templateLoader->getTemplate($reportSelection->get("PRESENTATION_ID"));
if ($template) {
	$presentation->assign("inputDisabled", !$template->isUserInputEnabled());
}


// Show presentation
$presentation->display("pages/template_selection/index.php");

?>