<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

// Load presentation layer class
$presentation = new Presentation();
$reportSelection = new ReportSelection();

$templateId = isset($_REQUEST["id"]) ? $_REQUEST["id"] : $reportSelection->get("PRESENTATION_ID");

// If we miss a data type, or there is not enough selections - display an error
//if ($reportSelection == "") {
//	$presentation->display("pages/template_selection/error_selections.php");
//	return;
//}


// Get templates
$templateLoader = new TemplateLoader();

// Remove _ALL_ other selections - since this could effect the results for this template
ClassificationSelectionManager::removeAll();

// Get selected template
/*@var $template Template */
$template = $templateLoader->getTemplate($templateId);
if (!$template) {
	$presentation->display("pages/template_selection/error_selections.php");
	return;
}

// If a new template is selected, make sure that we have the "general" selections made
if ($reportSelection->get("PRESENTATION_ID") == "" || $reportSelection->get("PRESENTATION_ID") != $templateId || 1 == 1) {
	
	// Clear all selections first
	$reportSelection->clear();
	
	// Set default title as the same as the template name, and default folder
	$reportSelection->set("generation_title", $template->reportData["title"]);
	$folder = new Folder($template->reportData["folder"]);
	$reportSelection->set("generation_folder", $folder->getName());
	
	// Since we use a new system for marking things as selected, we need to
	// "convert" the existing selection to the new... 
	foreach ($template->getClassifications() as $classification) {				
		ClassificationSelectionManager::removeAllClassificationValueSelection($classification->getUID());	
		foreach ($classification->getMarkedClassificationValues() as $classificationValue) {
			ClassificationSelectionManager::addClassificationValueSelection($classification->getUID(), $classificationValue);
		}
	}
	
	/*
	ClassificationSelectionManager::removeAllClassificationValueSelection($classification->getUID());
	foreach ($values as $classificationValueId) {
		die($classificationValueId);
		ClassificationSelectionManager::addClassificationValueSelection($classification->getUID(), $classificationValueId);
	}
*/								

	
}

// Shold we display missing user input
if (isset($_REQUEST["showMissing"])) {
	$presentation->assign("showMissing", true);
}

$reportSelection->set("PRESENTATION_ID", $templateId);


// If it doesn't support user input, we jump directly to generation.
if (!$template->isUserInputEnabled()) {
	header("Location: generate.php");
	return;
}

// Send data
$presentation->assign("selection", $reportSelection);
$presentation->assign("template", $template);
$presentation->assign("inputDisabled", !$template->isUserInputEnabled());

// Show presentation
$presentation->display("pages/template_selection/input.php");

/*
echo "<pre>";
echo $template->getId() . "\n";
echo $template->getuId() . "\n";
echo $templateId . " <-- template id \n";
echo count(ClassificationSelectionManager::getClassificationValueSelection($template->getId())) . "\n";
echo $template->isSelectionValid() ? "SEC OK\n" : "SEC NOT OK\n";
foreach ($template->getClassifications() as $s) {
	echo $s->getUID() . " - ";
	echo $s->getID() . " - ";
	echo $s->getValue();
	echo $s->isSelectionValid() ? " - OK\n" : " - FALSE!\n";
}
print_r($_SESSION["NEW_STAT"]);
echo "\n\n";
*/

?>
