<?php

// No time limit
set_time_limit(0);

// Load presentation layer class
$presentation = new Presentation();
$reportSelection = new ReportSelection();

if ($reportSelection->get("PRESENTATION_ID") == "") {
	$presentation->display("pages/template_selection/error_selections.php");
	return;
}

// Get templates
$templateLoader = new TemplateLoader();
//$templateLoader->load();

// Get selected template
/*@var $template Template */
$template = $templateLoader->getTemplate($reportSelection->get("PRESENTATION_ID"));

//if no selection was made on the input tab then select all values on the option box
foreach ($template->getClassifications() as $key => $classification) {
	
	if ($classification->isAllowInput()) {
		if (!$classification->hasValueSelected()) {
			$classification->markAllClassificationValuesAsSelected();
			
			//set this session to trigger if user is selected any value on the input tab
			$_SESSION["isClicked"] = true;
			
		}
	}
}
		
		
$classifications = $template->getClassifications();


// Add classifications
/*@var $templateSection TemplateSection */
/*
foreach ($template->getClassifications() as $classification) {
	$report->addClassification($classification);
	//$report->addClassification($classification, $classification->getMarkedClassificationValues());
}
*/

// Create a report
$report = new ReportGenerator(ServerConfig::getServerUrl());
$report->setDataType($template);


// Set presentation mode
switch (strtoupper($template->reportData["pres"])) {
	case "TABLE":
		$report->setPresentationType("table");
		break;	
	case "BAR":
		$report->setPresentationType("chart");
		$report->setArgument("pres", "bar");
		break;
	case "PIE":
		$report->setPresentationType("chart");
		$report->setArgument("pres", "pie");
		break;
	case "LINE":
		$report->setPresentationType("chart");
		$report->setArgument("pres", "line");
		break;	
}


// Check for forcing of anonymous

// Check if the user has selected the classification to be masked
foreach ($classifications as $classification) {
	if ($reportSelection->get("anonymous" . $classification->getId()) == 1) {
		Logger::Debug("template_selection::post_generate", "Adding classification '" . $classification->getValue() .  "' to masking list.");
		$report->setAnonymous($classification->getId());
	}
}


//for ($i=0; $i<20; $i++) {
//	if ($reportSelection->get("anonymous" . $i) == 1) {
//		$report->setAnonymous($i);		
//	}
//}

// Set variables
$variables = $template->reportData;
foreach ($variables as $key => $value) {
	if ($key != "classvars")
	$report->setArgument($key, $value);
}

// Setting data from FORM
$report->setFrom($reportSelection->get("generation_date_from"));
$report->setTo($reportSelection->get("generation_date_to"));
$report->setTitle($reportSelection->get("generation_title"));
$report->setFolder($reportSelection->get("generation_folder"));

// Set resolution if its picked
if ($reportSelection->get("generation_resolution") != "") {
	$report->setResolution($reportSelection->get("generation_resolution"));
}


// Periodic
if (!empty($_REQUEST["periodic"])) {
	$report->setArgument("freq", $reportSelection->get("generation_periodic"));
	$report->setArgument("pperiod", $reportSelection->get("generation_periodic_value"));
	$report->setArgument("command", "add");
	$report->setArgument("from", "0");
	$report->setArgument("to", "0");	
}


// Setting Period - Used if we generate a template from the report (Bug #3778)
if ($reportSelection->get('generation_period') != '') {
	$report->setArgument("period", $reportSelection->get('generation_period'));	
}
// - default value if we dont have the value...
else {
	$report->setArgument("period", "M");	
}


if (!$report->isValid()) {
	$return["STATUS"] = "ERROR";
	$return["MESSAGE"] = "Not valid!";
	echo php2js($return);
	return;
}

// Set Timout
$report->setArgument("timeout", (is_numeric($reportSelection->get("generation_timeout")) ? $reportSelection->get("generation_timeout") : 10));

$report->generate();


?>