<?php

// Get IDs that are selected
$id = isset($_REQUEST["id"]) ? $_REQUEST["id"] : null;
$values = isset($_REQUEST["values"]) ? explode("|", $_REQUEST["values"]) : null;

if (is_null($id) || is_null($values)) {
	Logger::Error("TEMPLATE_SELECTION->POST_INPUT", "Can’t add selected values, null in id or values");
	echo "error";
	return;
}

if (isset($_SESSION["isClicked"])) {
	unset($_SESSION["isClicked"]);
}

$reportSelection = new ReportSelection();

// Load template
$templateLoader = new TemplateLoader();

/*@var $template Template */
$template = $templateLoader->getTemplate($reportSelection->get("PRESENTATION_ID"));

/*@var $classification Classification */
$classification = $template->getClassificationByInternalId($id);

ClassificationSelectionManager::removeAllClassificationValueSelection($classification->getUID());
foreach ($values as $classificationValueId) {
	ClassificationSelectionManager::addClassificationValueSelection($classification->getUID(), $classificationValueId);
}

// TODO: To be removed

/*@var $classification Classification */

$classification = $template->getClassificationByInternalId($id);
$classification->removeSelections();
$classificationValues = $classification->getClassificationValues();

foreach ($classificationValues as $classificationValue) {	
	if (in_array($classificationValue->getUID(), $values)) {
		$classificationValue->setSelected();
	}
}


// Should we update the others?
$relationIds = $classification->getRelationIds();
echo php2js($relationIds);


?>
