<?php

class Feature_Status extends AbstractController {

	private $list;
	private $CSS_for_IE6;
	
	public function init() {
		
		// Load the initiation file
		require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");
		if(!isset($_SESSION["USER"])){
			header('Location: /login.php');
		}
		/*if (!UserHelper::getCurrentUser()->isAdmin()) {
			header('Location: /access.php?txt=' . urlencode('You don\'t have access to this part of the system'));
			exit;
		}*/
		//FeedWriter::init();
		if(SystemSettings::get(SystemSettings::SERVER_NS . "menu.statusmonitor.featureexpiry", 0) <= 0){
			header('Location: /access.php?txt=' . urlencode('Feature Expiry is still expiremental and is set to off as default.  You can turn this on in Administration->Registry in Reporting Server'));
			exit;
		}
		//$this->getDocument()->title = 'Feature Expiry';
		$this->CSS_for_IE6 = (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6.') !== FALSE || strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 7.') !== FALSE) ? '-IE' : '';
		
		if(!isset($_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"])) $_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"] = 50;
		if(!isset($_SESSION["REALTIME"]["FEATURES"]["ORDER"])) $_SESSION["REALTIME"]["FEATURES"]["ORDER"] = "ASC";
		
	}

	public function getModel() {
		//return '3';
	}

	public function getList() {		
		return $this->list;
	}
	
	public function index() {		
	
		// Add RSS feed link in the header
		$this->getDocument()->head = '<link rel="alternate" type="application/rss+xml" title="Open iT patches" href="' . '/module/feature_status/feed.rss" />';

		if (isset($_REQUEST['xauth']) && $_REQUEST['xauth'] == 'asdjkd292de')
			$this->getDocument()->template = 'tiny';
	}
	
	public function put() {
		echo 'put';
	}
	
	public function feed() {
		$this->index();
	//	$this->list
	}
	
	public function create() {
	}
	
	public function show($id = "") {
		
		if(!isset($_SESSION["USER"])){
			exit("timeout");
		}
		
		if(is_array($this->getRequest()->subs)) {
			
			switch(strtolower($this->getRequest()->subs[0])) {
				case "sort":
					
					$_SESSION["REALTIME"]["FEATURES"]["SORTBY"] = strtoupper($this->getRequest()->subs[1]);
					$_SESSION["REALTIME"]["FEATURES"]["ORDER"] = strtoupper($this->getRequest()->subs[2]);
					self::sort();
					self::display();
					break;
					
				case "page":
					
					$page = $this->getRequest()->subs[1];
					$row = $_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"];
					
					$_SESSION["REALTIME"]["FEATURES"]["PAGE"] = $page;
					$_SESSION["REALTIME"]["FEATURES"]["STARTAT"] = (($page - 1) * $row) + 1;
					
					self::sort();
					self::display();
					break;
				
				case "filter":
					
					RealTime::clearSelections();
					$realtime = RealTime::getInstance(true);		
					$this->list = $realtime->getProducts(true);
					
					$field = ($this->getRequest()->subs[1] != "") ? $this->getRequest()->subs[1] : null;
					$key = ($this->getRequest()->subs[2] != "") ? $this->getRequest()->subs[2] : null;
					
					$_SESSION["REALTIME"]["FEATURE_EXPIRY"] = self::loadFeature($this->list,$field,urldecode($key));
					$_SESSION["REALTIME"]["FEATURES"]["PAGE"] = 1;
					$_SESSION["REALTIME"]["FEATURES"]["STARTAT"] = 1;
					
					self::sort();
					self::display();
					break;
					
				case "rows":
					
					$_SESSION["REALTIME"]["FEATURES"]["PAGE"] = 1;
					$_SESSION["REALTIME"]["FEATURES"]["STARTAT"] = 1;
					$_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"] = $this->getRequest()->subs[1];
					
					break;
					
				case "getjson":
					
					$obj = &$_SESSION["REALTIME"]["FEATURE_EXPIRY"];
					$start = $_SESSION["REALTIME"]["FEATURES"]["STARTAT"];
					$row = $_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"];
					$strJSON = '{ features: [';
					
					$j = 0;
					for($i = $start - 1; $i < ($start + ($row - 1)); $i++) {
						
						if(!isset($obj[$i][0])) break;

						$productName = addslashes($obj[$i][9]);
						$licenseServer = addslashes($obj[$i][10]);
						$licenseFile = addslashes($obj[$i][11]);
						$licensePath = addslashes($obj[$i][12]);
						
						$strJSON .= '{productname: "'.$productName.'",licenseServer: "'.$licenseServer.'",licenseFile: "'.$licenseFile.'",licensePath: "'.$licensePath.'"}';
						
						if($i+1 < ($start + ($row - 1))) $strJSON .= ','; 
					}
					$strJSON .= "]}";
					
					header('Cache-Control: no-cache, must-revalidate'); //IE fix for not caching data
					header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');	//IE fix for not caching data
					header('Content-type: application/json');
									
 					echo json_encode($strJSON);
					break;
				
				case "count":
					
					echo count($_SESSION["REALTIME"]["FEATURE_EXPIRY"]);
					break;
					
				default:
					foreach($this->getRequest() as $a => $b) {
						echo $a . " --- " . var_dump($b) . "<br/>";
					}
			}
			
		}
	}
		
	public function getMenu() {
		return 'dashboard';
	}
	
	public function validate() {	
		$this->getValidator()->setRequired('mail', 'Need an email adr');
		$this->getValidator()->isEmail('mail', 'Need to be a valid email adr');
	}
	
	private function loadFeature($list,$filter = null,$filterText = null) {
	// Get user selections
	$selection = new ReportSelection();
	// If we have a offset posted, we use this when displaying checkout time
	$TIMEZONE_OFFSET = $selection->get(RealTime::GUI_TIMEZONE_OFFSET) != "" && is_numeric($selection->get(RealTime::GUI_TIMEZONE_OFFSET)) ? (int) $selection->get(RealTime::GUI_TIMEZONE_OFFSET) : 0;
	
	Logger::Debug('FeatureStatus', "TIMEZONE_OFFSET = " . $TIMEZONE_OFFSET);
	
		$feat = array();
		$i = 0;
		foreach($list as $product) {
			$featureList = $product->getFeatures();
			foreach($featureList as $feature) {
				$feature_license = $feature->getLicenseFile();
				$expires = $feature->getExpiryFormat($TIMEZONE_OFFSET);
				$expiryDate = $feature->getExpiryValue();
				$expiryDate = date("Y-m-d H:i", $expiryDate);
				$expiryInSeconds =  $feature->getExpiryEpoch($TIMEZONE_OFFSET);
				$expiryInHours = $feature->getExpiry($TIMEZONE_OFFSET);
						
				$prodname = str_split($feature->getProductName(),30);
				$productname = "";
				for($i = 0; $i < count($prodname); $i++){
					if($i == 0)
						$productname = $prodname[$i];
					else
						$productname = $productname . "<br/>". $prodname[$i];
				}
				$basename = $feature_license['basename'] != "" || $feature_license['basename'] != null ? $feature_license['basename'] : "undefined";
				$dirname = $feature_license['dirname'] != "" || $feature_license['dirname'] != null ? str_replace("\\\\", "\\",  $feature_license['dirname']) : "undefined";
				
				if(trim($filter) != "" && trim($filterText) != "") {
					switch($filter) {
						case "product": $strValue = $product->name; break;
						case "feature": $strValue = $feature->name; break;
						case "version": 
							$strValue = ($feature->version < 0 || $feature->version == "") ? "N/A" : $feature->version; 
							break;
						case "total": $strValue = $feature->licensesTotal; break;
						case "expiry": 
							if($expiryInHours != "N/A") {
								$strValue = (string) date("Y-m-d H:i", $expiryDate) . " " . $expires;
							} else {
								 $strValue = (string) date("Y-m-d H:i", $expiryDate) . " Expired for " . $expires;
							}
							break;
					}
					$toInclude = (stristr($strValue, $filterText) === FALSE) ? false : true;
				} else {
					$toInclude = true;
				}
				
				if($toInclude) {
					$feat[] = array("{$product->name}",
							"{$feature->name}",
							"{$feature->version}",
							(int) $feature->licensesTotal,
							(string)$feature->getExpiry($TIMEZONE_OFFSET),
							"{$expiryInHours}",
							(int) $expiryInSeconds,
							"{$expiryDate}",
							"{$expires}",
							"{$productname}",
							"{$feature->getLicenseServer()}",
							"{$basename}",
							"{$dirname}",
							1
							);
				}
			}
		}
		
		return $feat;
	}
	
	public function features_init() {
		
		RealTime::clearSelections();
		$realtime = RealTime::getInstance();		
		$this->list = $realtime->getProducts(true);
		
		$_SESSION["REALTIME"]["FEATURE_EXPIRY"] = self::loadFeature($this->list);
		$_SESSION["REALTIME"]["FEATURES"]["SORTBY"] = "EXPIRY";
		$_SESSION["REALTIME"]["FEATURES"]["ORDER"] = "ASC";
		$_SESSION["REALTIME"]["FEATURES"]["PAGE"] = 1;
		$_SESSION["REALTIME"]["FEATURES"]["STARTAT"] = 1;
		$_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"] = 6;
		
		if(!isset($_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"])) $_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"] = 50;
		
		self::sort();
		self::display();
	}
	
	private function sort() {
		
		$object = &$_SESSION["REALTIME"]["FEATURE_EXPIRY"];
		$sort = $_SESSION["REALTIME"]["FEATURES"]["SORTBY"];
		
		switch($sort) {
			case "PRODUCT":
					$_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"] = 0;
					usort($object,"sortText");
					break;
			case "FEATURE":
					$_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"] = 1;
					usort($object,"sortText");
					break;
			case "VERSION":
					$_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"] = 2;
					usort($object,"sortNumeric");
					break;
			case "TOTAL":
					$_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"] = 3;
					usort($object,"sortNumeric");
					break;
			case "EXPIRY":
					$_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"] = 6;
					usort($object,"sortNumeric");
					break;			
		}
	}
	
	public function display() {
		$start = $_SESSION["REALTIME"]["FEATURES"]["STARTAT"];
		$row = $_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"];
		
		$j = 0;
		for($i = $start - 1; $i < ($start + ($row - 1)); $i++) {
			
			if(!isset($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][0])) break;
					
			$className = ($j % 2) ? "" : "altRow";
			$scrolling = strlen($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][0]) > 35 ? "onmouseover=\"Scroller.start(this);\" onmouseout=\"Scroller.stop(this);\"" : "";
			$scrollingFeat = strlen($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][1]) > 35 ? "onmouseover=\"Scroller.start(this);\" onmouseout=\"Scroller.stop(this);\"" : "";
			
			$productName = strlen($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][0]) > 35 ? substr($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][0],0,35) . "..." : $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][0];
			$featureName = strlen($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][1]) > 35 ? substr($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][1],0,35) . "..." : $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][1];
			$featureVersion = ($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][2] < 0 || $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][2] == "") ? "N/A" : $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][2];
			$totalLicenses =$_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][3];
			$expiry = ($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][4] != "N/A") ? '<div style="float: left;">' . $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][7] . '</div><div style="float: right;">' . $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][8]  . '</div>' : '<div style="float: left;">' . $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][7] . '</div><div style="float: right;">Expired for ' . $_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][8] . '</div>';
			$expiryClass = ($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][4] != "N/A") ? ($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][5] < 24 ? "critical{$this->CSS_for_IE6}" : ($_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][5] < 168 ? "warning{$this->CSS_for_IE6}" : "current{$this->CSS_for_IE6}") ) : "fatal{$this->CSS_for_IE6}";
			
			echo "<tr id=\"item_{$j}\" style=\"cursor:pointer;\" class=\"{$className}\" onmouseover=\"showHideDescription(this.id,true);\" onmouseout=\"showHideDescription(this.id,false);\">" . chr(13);
			echo "	<td value=\"{$_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][0]}\" {$scrolling}>{$productName}</td>" . chr(13);
			echo "	<td value=\"{$_SESSION["REALTIME"]["FEATURE_EXPIRY"][$i][1]}\" {$scrollingFeat}>{$featureName}</td>" . chr(13);
			echo "	<td>{$featureVersion}</td>" . chr(13);
			echo "	<td>{$totalLicenses}</td>" . chr(13);
			echo "	<td class=\"$expiryClass\">{$expiry}</td>" . chr(13);
			echo "</tr>" . chr(13);
			$j++;
		}
		
		if($j == 0) {
			echo "<tr class=altRow><td colspan=5 align=center>No record found.</td></tr>";
		}
	}
	
	public function pages() {
		//Just print spaces
		echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		
		$currentPage = $_SESSION["REALTIME"]["FEATURES"]["PAGE"];
		$rowsPerPage = $_SESSION["REALTIME"]["FEATURES"]["ROW_PAGE"];
		$startAt   = $_SESSION["REALTIME"]["FEATURES"]["STARTAT"];
		$countDisplay = count($_SESSION["REALTIME"]["FEATURE_EXPIRY"]);
		
		$showEachSide = 5;		// Display of items on both sides of selected page.
		
		$maxPage = ceil($countDisplay/$rowsPerPage);
				
		$s = $currentPage - $showEachSide;
		$e = $currentPage + $showEachSide;
		if($e > $maxPage) {
			$s = $s - ($e - $maxPage);
			$e = $maxPage;
		} elseif($e <= ($showEachSide * 2) + 1) {
			$e = $maxPage;
		}
		if($s <= 0) $s = 1;		
		if($s > 1) echo "<a onClick=\"showList('/module/feature_status/page/1',false);\">&laquo; First</a>&nbsp; ... ";
		
		$dsp=1;
		for($i=$s; $i <= $e; $i++) {
			$class = ($i == $currentPage) ? "pageselected" : "";
			echo "&nbsp;<a class=\"{$class}\" onClick=\"showList('/module/feature_status/page/{$i}',false);\">{$i}</a>&nbsp;";
			$dsp++;
			if($dsp > ($showEachSide * 2) + 1) {
				$dsp = $i;
				break;
			}
		}
		if($dsp < $maxPage) echo " ... <a onClick=\"showList('/module/feature_status/page/{$maxPage}',false);\">Last &raquo;</a>&nbsp;";
		
		if($maxPage > 0) echo " &nbsp;&nbsp;&nbsp;&nbsp; [ Page <strong>{$currentPage}</strong> of <strong>{$maxPage}</strong> ]";
	}	

}


function sortNumeric($a,$b) {
	$key = $_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"];
	if($_SESSION["REALTIME"]["FEATURES"]["ORDER"] == "ASC") {
		return $a[$key] - $b[$key]; 			
	} else {
		return $b[$key] - $a[$key];
	}
}
	
function sortText($a,$b) {
	$key = $_SESSION["REALTIME"]["FEATURES"]["SORTINDEX"];

	$aTemp = strtolower($a[$key]);
	$bTemp = strtolower($b[$key]);
	
	if($_SESSION["REALTIME"]["FEATURES"]["ORDER"] == "ASC")
		return strcasecmp($aTemp,$bTemp);
	else
		return strcasecmp($bTemp,$aTemp);
}

?>
