<?php
header('Content-Type: application/xml');
?><?= '<?xml version="1.0"?>' ?>
<?php 
$prefix = "http";
if(isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on"){
	$prefix = "https";
}

$realtime = RealTime::getInstance(true);
$list = $realtime->getProducts(true);

$entrycount=0;
$warning = 0;
$critical = 0;
$fatal = 0;
foreach ($list as $product) { 
	$featureList = $product->getFeatures();
	
	foreach ($featureList as $feature) {
		$expiry = $feature->getExpiry();
		if ($expiry > 168 && $expiry <= 504){
			$entrycount++;
			$warning++;
		}else if ($expiry >0 && $expiry <= 168){
			$entrycount++;
			$critical++;
		}else if ($expiry == 'N/A'){
			$entrycount++;
			$fatal++;
		}
	}
}
?>	
<rss version="2.0">

	<channel>
		<title>Open iT - Feature Status Monitor</title>
		<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		<description></description>
		<?php if ($warning>0){?>
		<item>
			<guid isPermaLink="false">WARNING: <?= date('F d Y') ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>WARNING: Features expiring in 3 weeks: <?=$warning?></title>
 			<description>
 			<?php 
 				if($warning>0){
 					if($warning>1) echo 'There are '. $warning .' features that will expire in three(3) weeks.';
 					else echo 'There is a feature that will expire in three(3) weeks.';
 				}else echo 'There are no features expiring in three(3) weeks.';
 			?>
			</description>
			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		</item>
		<?php }
		
		if ($critical>0){?>
		<item>
			<guid isPermaLink="false">CRITICAL: <?= date('F d Y') ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>CRITICAL: Features expiring in 1 week: <?=$critical?></title>
 			<description>
 			<?php 
 				if($critical>0){
 					if($critical>1) echo 'There are '. $critical .' features that will expire in one(1) week.';
 					else echo 'There is a feature that will expire in one(1) week.';
 				}else echo 'There are no features expiring in one(1) week.';
 			?>
			</description>
			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		</item>
		<?php }

		if ($fatal>0){?>
		<item>
			<guid isPermaLink="false">FATAL: <?= date('F d Y') ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>FATAL: Features that are already expired: <?=$fatal?></title>
 			<description>
 			<?php 
 				if($fatal>0){
 					if($fatal>1) echo 'There are '. $fatal .' expired features.';
 					else echo 'There is an expired feature.';
 				}else echo 'There are no expired features.';
 			?>
			</description>
			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		</item>
		<?php }
		if ($entrycount==0){?>
		<item>
			<guid isPermaLink="false">Normal: <?= date('F d Y') ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>No expiry warnings today</title>
 			<description>No features are expiring anytime soon.</description>
			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		</item>
		<?php }
if (isset($_SESSION["TMP_USER"])){
 	if($_SESSION["TMP_USER"]!=NULL){
		$_SESSION["USER"] = new User($_SESSION["TMP_USER"]->getId(), 
									$_SESSION["TMP_USER"]->getUsername(), 
									$_SESSION["TMP_USER"]->getPassword(), 
									$_SESSION["TMP_USER"]->getName(), 
									$_SESSION["TMP_USER"]->getDivision(), 
									$_SESSION["TMP_USER"]->isAdmin(),
									$_SESSION["TMP_USER"]->isAgreement(), 
									$_SESSION["TMP_USER"]->isTemplateUser(), 
									$_SESSION["TMP_USER"]->isViewUser(), 
									$_SESSION["TMP_USER"]->isReportGeneratorUser());
		UserSettings::setValue($_SESSION["USER"], UserSettings::REALTIME_ACCESS, true);
		$_SESSION["TMP_USER"]=null;
 	}else{
		session_start();
		// Unset all of the session variables.
		$_SESSION = array();
		// If it's desired to kill the session, also delete the session cookie.
		// Note: This will destroy the session, and not just the session data!
		if (ini_get("session.use_cookies")) {
		    $params = session_get_cookie_params();
		    setcookie(session_name(), '', time() - 42000,
		        $params["path"], $params["domain"],
		        $params["secure"], $params["httponly"]
		    );
		}
		// Finally, destroy the session.
		session_destroy();
 	}
 }else{
 	//remove session 
	session_start();
	$_SESSION = array();
	if (ini_get("session.use_cookies")) {
	    $params = session_get_cookie_params();
	    setcookie(session_name(), '', time() - 42000,
	        $params["path"], $params["domain"],
	        $params["secure"], $params["httponly"]
	    );
	}
	session_destroy();
}
?>
	</channel>        
</rss>