<?php

class Mapping_Config extends AbstractController {
	
	private static $SUBMODULES = array('source', 'type');
	
	private $config;
	private $configs;
	
	
	public function init() {
		// Load the initiation file
		require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");
		//$this->getDocument()->title = 'Mapping';
	}
	
	
	public function getModel() {
		return $this->config;
	}	
	
	public function getList() {
		//if (!is_array($this->configs)) return array();
		return $this->configs;
	}
	
	public function index() {
		$this->getDocument()->styles[] = 'hwlloo'; 
		$this->configs = MappingConfig::getConfigs();
	}
	
	public function edit() {
		//$this->getDocument()->title = 'Edit Mapping';
		$this->config = MappingConfig::getConfig($this->getRequest()->id);
	}
	
	public function create() {
		//$this->getDocument()->title = 'New Mapping';
		$this->config = new MappingConfig();
		$this->getRequest()->action = 'edit';
	}
	
	public function getSubModules() {
		return self::$SUBMODULES;
	}
	
	public function test() {
		print_r($_REQUEST);
	}
	
	
	
	public function validate() {
		$this->getValidator()->setRequired('sourceid', 'You have to select one action from this field');
		$this->getValidator()->setRequired('maptypeid', 'You have to select one action from this field');
		$this->getValidator()->setRequired('file', 'You need to have a output mapping file');
	}
	
	public function getMenu() {
		return 'admin';
	}
	
	public function getSubMenu() {
		return 'mappingsub';
	}
	
	public function delete() {
		if (isset($_REQUEST['mapping'])) {
			foreach ($_REQUEST['mapping'] as $id) {
				MappingConfig::delete($id);
			}
		}
		$this->redirect(array());
	}
	
	public function update() {
		
		// Get the exisint object
		$config = MappingConfig::getConfig($this->getRequest()->id);
		
		//var_dump($config); var_dump($this->getRequest()->_POST);exit;
		
		// Update the object with new values
		$config->setSourceId($this->getRequest()->_POST['sourceid']);
		$config->setMapTypeId($this->getRequest()->_POST['maptypeid']);
		$config->setFile($this->getRequest()->_POST['file']);
		$config->setHistoric($this->getRequest()->_POST['historic']);
		
		if (!MappingConfig::store($config)) {
			var_dump($config);	
			var_dump($this->getRequest()->_POST);
			die('Error updating...');
		}

		
		if (isset($this->getRequest()->_POST['include']) || isset($this->getRequest()->_POST['shownSpan'])) {
			MappingConfigField::deleteByMap($this->getRequest()->id);
			$postValue = $this->getRequest()->_POST['shownSpan'];
			if($postValue == "single"){
				// Add sourceFieldMapId			
				//MappingConfigField::store(new MappingConfigField(null, $this->getRequest()->id, $this->getRequest()->_POST['sourceFieldMapId'], '0'));
				foreach ($this->getRequest()->_POST['sourceFieldMapId'] as $keys) {
					MappingConfigField::store(new MappingConfigField(null, $this->getRequest()->id, $keys, '0'));
				}
				
				
				// For each include field
				foreach ($this->getRequest()->_POST['include'] as $sourceFieldId) {
					if(is_array($sourceFieldId)) {
						foreach($this->getRequest()->_POST['include'] as $sourceId => $key) {
							foreach($key as $value) {
								MappingConfigField::store(new MappingConfigField(null, $this->getRequest()->id, $value, '1'));
							}
						}
					} else {
						MappingConfigField::store(new MappingConfigField(null, $this->getRequest()->id, $sourceFieldId, '1'));
					}
				}
				
			}else{
				// Add sourceFieldMapId			
				//MappingConfigField::store(new MappingConfigField(null, $this->getRequest()->id, $this->getRequest()->_POST['msourceFieldMapId'], '0'));
				foreach ($this->getRequest()->_POST['msourceFieldMapId'] as $keys) {
					MappingConfigField::store(new MappingConfigField(null, $this->getRequest()->id, $keys, '0'));
				}
				
				// For each include field
				foreach ($this->getRequest()->_POST['minclude'] as $sourceFieldId) {
					MappingConfigField::store(new MappingConfigField(null, $this->getRequest()->id, $sourceFieldId, '1'));
				}	
			}
		}
		
		//var_dump($this->getRequest()->_POST); exit;
		
		// Redirect back to edit view...
		$this->redirect(array());
	}
	
	public function put() {
		
		// Create new object
		$config = new MappingConfig();
		
		// Update the object with new values
		$config->setSourceId($this->getRequest()->_POST['sourceid']);
		$config->setMapTypeId($this->getRequest()->_POST['maptypeid']);
		$config->setFile($this->getRequest()->_POST['file']);
		$config->setHistoric($this->getRequest()->_POST['historic']);
		
		if (!$status = MappingConfig::store($config)) {
			var_dump($config);	
			var_dump($this->getRequest()->_POST);
			die('Error updating...');
		}
		
		// Redirect to edit view...
		$this->redirect(array($status, 'edit'));		
	}
	
	public function preview() {		
		$actions = $this->getRequest()->subs;
		if (!isset($actions[3])) return;
		$sourceId = $actions[2];
		echo MappingBackendConnector::getPreviewData($sourceId, $actions[3]);
	}
	
}

?>