<?php

// Load sources
$sources = MappingSource::getSources();

// Load mapping types
$mappingTypes = MappingType::getTypes();
$sourceFields = array();
$counter = 0;

// Load source fields
if($model->getSourceId() != null){
	$sourceFields = MappingSourceField::getFields($model->getSourceId());
        if (!is_array($sourceFields)) $sourceFields = array($sourceFields);
}

$mappingConfigFields = MappingConfigField::getFields($model->getId());

// Should we allow multiple includes?
$multipleIncludes = $model->getMapType() == 'license-multi' ? true : false;

$configFields = array();
if(is_array($mappingConfigFields)){
	foreach ($mappingConfigFields as $mappingConfigField) {
		$configFields[$mappingConfigField->getSourceFieldId()] = $mappingConfigField;
	}
}
$mapConfigs = MappingConfig::getConfigs();
if (!is_array($mapConfigs)) $mapConfigs = array();
/* @var $model MappingConfig */

?>

<html>

<head>
	<style>
	h2 {
		background-image:url(/gfx/icons/folder_document.png);
		background-repeat:no-repeat;
		height:22px;
		margin:0 0 10px;
		padding-left:30px;
		padding-top:2px;
	}	
	</style>

	<script type="text/javascript">
	<!--
	var previewId = new Array();
	<?php 
		if($model->getSourceId() > 0){
			$tt = explode(",",$model->getSourceId());
			$tmp = "";
		 	foreach ($tt as $i) {?>
		 		previewId[<?=$i?>] = 0;
	 	<?php }}?>


	
	function getPreview(id) {	
		var shown = document.getElementById('sourceFieldsSingle');
		var prev = 'preview_'+id+'_';
		var dataTab = 'data'+id;
		if(shown.style.display != "block"){
			prev = 'mpreview_'+id+'_';
			dataTab = 'mdata'+id;
		}

		var ele = 'span[id^='+prev+']';
		var jsonRequest = new Request({url: "<?= $controller->getURL(array(null, 'preview')) ?>/"+ id +"/" + previewId[id] + ".raw", format: "json", onSuccess: function(list){
			preview = eval("(" + list + ")");

			if(list ==  "[]"){
				$(dataTab).getElements(ele).each(function(el) { el.set('text', '- No data -'); });
			}else{
			
			// Empty all first
			$$(ele).each(function(el) { el.set('text', ''); });
			
			// Inserting data			
			preview.each(function(el){
				for(var p in el) if ($(prev + p)) $(prev + p).set('text', el[p]);
			});	
			}
		}}).get();
	}
	
	function nextPreview(id) {

		var shown = document.getElementById('sourceFieldsSingle');
		var prev = 'preview_';
		var dataTab = 'data'+id;
		if(shown.style.display != "block"){
			prev = 'mpreview_';
			dataTab = 'mdata'+id;
		}
		previewId[id]++;
		
		var ele = 'span[id^='+prev+']';
		// Empty all exisiting data..
		$(dataTab).getElements(ele).each(function(el) { el.set('text', '- Loading -'); });
		
		getPreview(id);
	}
		
	function previousPreview(id) {
		if (previewId[id] <= 1) {
			alert('You are at the first record..');
			return;
		} 
		previewId[id]--;
		previewId[id]--;
		nextPreview(id);
	}
	
	function dd(obj) {
		var typeSel = document.getElementById('maptypeid');
		if (obj.selectedIndex + 1  != '<?= $model->getSourceId() ?>') {
			$('sourceFieldsSingle').setStyle('display', 'none');
			$('sourceFieldsMulti').setStyle('display', 'none');
		} else {
			if(typeSel.selectedIndex == 3){
				$('sourceFieldsSingle').setStyle('display', 'none');
				$('sourceFieldsMulti').setStyle('display', 'block');
			}
			else{
				$('sourceFieldsSingle').setStyle('display', 'block');
				$('sourceFieldsMulti').setStyle('display', 'none');
			}
		}
	}
	
	function verifyKeySelection(id) {

		var shown = document.getElementById('sourceFieldsSingle');

		var sinclude = "";
		if(shown.style.display == "block"){
			sinclude = 'includeBox';
		}else{
			sinclude = 'mincludeBox';
		}
		
		var box = document.getElementById(sinclude + id);
		if (box && box.checked) {
			box.checked = false;
		}
	}
	
	function verifyIncludeSelection(id) {
		var shown = document.getElementById('sourceFieldsSingle');

		var skey = "";
		if(shown.style.display == "block"){
			skey = 'keyBox';
		}else{
			skey = 'mkeyBox';
		}
		var box = document.getElementById(skey + id);
		if (box && box.checked) {
			box.checked = false;
		}
	}

	function verifyKeyAndIncludeSelection() {
		var iflag = false;
		var kflag = false;
		
		el = $$('table.list');
		for(g=0; g < el.length; g++) {
		
			var count = document.getElementById('count').value;
			var start = document.getElementById('start').value;
			var shown = document.getElementById('sourceFieldsSingle');
	
			var sinclude = "";
			var skey = "";
	
			if(shown.style.display == "block")
				tableid = null;
			else
				tableid = "multi";
					
			if(el[g].getProperty('id') == tableid) {

				iflag = false;
				kflag = false;
				
				var ele = el[g].getElementsByTagName("input");
				for( var i =0 ; i < (ele.length); i++){
					if(ele[i].type == 'radio') {
						iflag = iflag || ele[i].checked;
					} else {
						if(ele[i].id.indexOf('minclude') > -1)
							iflag = iflag || ele[i].checked;
						else							
							kflag = kflag || ele[i].checked;
					}
				}
				if(!kflag || !iflag) break;
			}
		}

		if(!kflag || !iflag) {
			if(!kflag) {
				alert("At least one field should be set as key for each Source Table" );
			}else if(!iflag) {
				alert("At least one field should be included for each Source Table");
			}
			return false;
		} else return true;
	}

	function validateInput(action){
		var maptypeid = document.getElementById('maptypeid');
		var file = document.getElementById('file');
		var count = document.getElementById('c').value;
		if(action == 'Submit'){
			for(var i = 0; i < count; i++){
				if(document.getElementById('sourceID'+i).checked){
					var check = true;
				}
			}
			if(check != true){
				message = "No input for Mapping Config Source";
				alert(message);
				return false;
			}
			if(maptypeid.value.length <= 0){
				message = "No input for Mapping Config type";
				alert(message);
				return false;
			}

			if(file.value.length <= 0){
				message = "No input for Mapping Config Label";
				alert(message);
				return false;
			}else if(file.value.search(/[^0-9a-zA-Z\-\_\040\.]/g) >= 0){
                                message = "Only alphanumeric characters(A to z, 0 to 9), space, and the following characters (_.-) are allowed.";
				alert(message);
				return false;
                        }
			<?php 
				if($mapConfigs > 0 && count($model->getSourceId()) <= 0 ){
					foreach ($mapConfigs as $mapConfig) {
			?>
			if(file.value == '<?= $mapConfig->getFile() ?>' ){
				message = "<?= $mapConfig->getFile() ?> already exist";
				alert(message);
				return false;
			}
			<?php			
					}
				}
			?>
		}	
	}
        
        function checkKeycode(e) {
                var keycode;
                if (window.event) keycode = window.event.keyCode;
                else if (e) keycode = e.which;
                if (keycode==13){
                        return false;
                }
        }

	function copySelections(){
		//copies the current selection to the table to be shown
		var count = document.getElementById('count').value;
		var start = document.getElementById('start').value;
		var shown = document.getElementById('sourceFieldsSingle');

		var sinclude = "";
			var skey = "";
			var dinclude = "";
			var dkey = "";
			if(shown.style.display == "block"){
				sinclude = 'includeBox';
				skey = 'keyBox';
				dinclude = 'mincludeBox';
				dkey = 'mkeyBox';
			}else{
				sinclude = 'mincludeBox';
				skey = 'mkeyBox';
				dinclude = 'includeBox';
				dkey = 'keyBox';
			}


			
			//clear selections
			for (i = 0; i <= count; i++){
				if(document.getElementById(dinclude + i)) {
					document.getElementById(dinclude + i).checked = false;
					document.getElementById(dkey + i).checked = false;
				}
			} 
	
			//copy the current selections
			for (i = 0; i <= count; i++){
				if(document.getElementById(dinclude + i)) {
				document.getElementById(dinclude + i).checked = document.getElementById(sinclude + i).checked;
				document.getElementById(dkey + i).checked = document.getElementById(skey + i).checked;
				}
			} 
	}

	function Refresh(id){
		var single = document.getElementById('sourceFieldsSingle');
		var multi = document.getElementById('sourceFieldsMulti');
		var showSpan = document.getElementById('shownSpan');
		if(id == 3){
			copySelections();
			single.style.display="none";
			multi.style.display="block";
			showSpan.value = "";
		}else{
			copySelections();
			single.style.display="block";
			multi.style.display="none";
			showSpan.value = "single";
		}
	}
	//-->
	</script>	
</head>

<body>


	<div style="margin: 10px">
		<h2>Mapping Config</h2>
		<form name="mapping" id="mappingform" action="<?= $controller->getURL(array(null)) ?>" onsubmit="<?php if(count($model->getSourceId()) > 0 ) echo 'return verifyKeyAndIncludeSelection(this)'; ?>" method="post">
			<fieldset>
				<legend>Editing Mapping Config</legend>
				
				<div>		
					<p style="float: left; margin-right: 10px;">
						Source:
						<?php 
						$c = 0;	
						foreach ($sources as $sourceEntry) { ?>
							<label><input type="checkbox" id="sourceID<?= $c ?>" value="<?= $sourceEntry->getId() ?>" name="sourceid[]" <?= $model->getSourceId() == $sourceEntry->getId() || in_array($sourceEntry->getId(),explode(",",$model->getSourceId())) ? 'checked="checked"' : '' ?>><?= $sourceEntry->getName() ?></label>
						<?php 
						$c++;
						} ?>
					</p>

					<p style="float: left; margin-right: 10px;">
						Type:
						<select name="maptypeid" id="maptypeid" onChange="Refresh(this.value)">
							<option value="">Select Type</option>
							<?php foreach ($mappingTypes as $mappingType) { ?>
							<option value="<?= $mappingType->getId() ?>" <?= $model->getMapTypeId() == $mappingType->getId() || (isset($_POST['mapType']) && $_POST['mapType'] == $mappingType->getId())? 'selected="selected"' : '' ?>><?= $mappingType->getName() ?></option>
							<?php } ?>
						</select>
					</p>
					
					<p style="float: left; margin-right: 10px;">					
						Label: <input type="text" name="file" id="file" value="<?= $model->getFile() ?>" onKeyPress="return checkKeycode(event)">
					</p>
					
					
					<p style="float: left; margin-right: 10px;">					
						Use History:
							<input type="radio" name="historic" id="historic" value="1" <?= $model->getHistoric() ? 'checked="checked"' : '' ?>> Yes
							<input type="radio" name="historic" id="historic" value="0" <?= !$model->getHistoric() ? 'checked="checked"' : '' ?>> No
					</p>
											
					<div class="clearer"></div>
					
				</div>
			</fieldset>
		
		
			<span id="sourceFieldsSingle" style="display:<?= $multipleIncludes ? "none" : "block"?>">
			<?php if (count($sourceFields) > 0) { 
					
				$counter = 0;
				$sourceId = "";
				$recordSet = 0;
				foreach ($sourceFields as $sourceField) {
					
					if($sourceId != $sourceField->getSourceId()) {
						$sourceId = $sourceField->getSourceId();
						
						if($recordSet > 0) echo "</tbody></table><div style='height:15px;'></div>";
						
						$recordSet++;
			?>
			<table class="list">
				
				<thead>
					<tr>
						<th class="title">
							Source Field
							<!-- <a href="<?= $controller->getURL(array('source', $sourceId, 'edit')) ?>">Edit Source</a> -->
							<a href="/module/mapping_source/<?= $sourceId ?>/edit">Edit Source</a>	
						</th>
						<th class="preview">
							Preview
							(
							<a href="javascript:previousPreview(<?= $sourceId?>)">Previous</a> | <a href="javascript:nextPreview(<?= $sourceId?>)">Next</a>
							)	
						</th>
						<th class="edit">Key(s)</th>
						<th class="edit">Include</th>
					</tr>
				</thead>
					
				<tbody id="data<?= $sourceId?>">
			<?php 
					}					
					$counter++;
					$oddEven = !isset($oddEven) || $oddEven == 'odd' ? 'even' : 'odd';
				
			?>
					<tr class="<?= $oddEven ?>">
						<td class="title"><?= $sourceField->getName() ?></td>
						<td class="preview"><span id="preview_<?= $sourceId?>_<?= $sourceField->getName() ?>">- Not loaded -</span></td>
						<td class="edit">
							<input type="checkbox" name="sourceFieldMapId[]" id="keyBox<?= $sourceField->getId() ?>" value="<?= $sourceField->getId() ?>" onclick="verifyKeySelection(<?= $sourceField->getId() ?>)" onkeyup="verifyKeySelection(<?= $sourceField->getId() ?>)" <?=  isset($configFields[$sourceField->getId()]) && !$configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> /></td>						
						<td class="edit">
							<input type="radio" id="includeBox<?= $sourceField->getId() ?>" name="include[<?= $sourceField->getSourceId() ?>][]" value="<?= $sourceField->getId() ?>" onclick="verifyIncludeSelection(<?= $sourceField->getId() ?>)" <?= isset($configFields[$sourceField->getId()]) && $configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> />
						</td>
					</tr>		
					<?php }
					?>			
				</tbody>
				
				</table>
				<?php } ?>
			</span>
			
			
			<span id="sourceFieldsMulti" style="display:<?= $multipleIncludes ? "block" : "none"?>">
			<?php if (count($sourceFields) > 0) { 
						
						$counter = 0;
						$sourceId = "";
						$recordSet = 0;
						
						foreach ($sourceFields as $sourceField) {
							
							if($sourceId != $sourceField->getSourceId()) {
								$sourceId = $sourceField->getSourceId();
								
								if($recordSet > 0) echo "</tbody></table><div style='height:15px;'></div>";
								
								$recordSet++;
			?>	
			<table id="multi" class="list" >
				
				<thead>
					<tr>
						<th class="title">
							Source Field
							<!-- <a href="<?= $controller->getURL(array('source', $sourceId, 'edit')) ?>">Edit Source</a> -->
							<a href="/module/mapping_source/<?= $sourceId ?>/edit">Edit Source</a>	
						</th>
						<th class="preview">
							Preview
							(
							<a href="javascript:previousPreview(<?= $sourceId?>)">Previous</a> | <a href="javascript:nextPreview(<?= $sourceId?>)">Next</a>
							)	
						</th>
						<th class="edit">Key(s)</th>
						<th class="edit">Include</th>
					</tr>
				</thead>
					
				<tbody id="mdata<?= $sourceId?>">
					<?php
						}
						$counter++;
						$oddEven = !isset($oddEven) || $oddEven == 'odd' ? 'even' : 'odd';
					?>
					<tr class="<?= $oddEven ?>">
						<td class="title"><?= $sourceField->getName() ?></td>
						<td class="preview"><span id="mpreview_<?= $sourceId?>_<?= $sourceField->getName() ?>">- Not loaded -</span></td>
						<td class="edit">
							<input type="checkbox" name="msourceFieldMapId[]" id="mkeyBox<?= $sourceField->getId() ?>" value="<?= $sourceField->getId() ?>" onclick="verifyKeySelection(<?= $sourceField->getId() ?>)" onkeyup="verifyKeySelection(<?= $sourceField->getId() ?>)" <?=  isset($configFields[$sourceField->getId()]) && !$configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> /></td>						
						<td class="edit">
							<input type="checkbox" id="mincludeBox<?= $sourceField->getId() ?>" onclick="verifyIncludeSelection(<?= $sourceField->getId() ?>)" name="minclude[]" value="<?= $sourceField->getId() ?>" <?= isset($configFields[$sourceField->getId()]) && $configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> />
						</td>
					</tr>		
					<?php }
					?>			
				</tbody>
				
				</table>
				<?php } ?>
			</span>
			
				<input type="hidden" name="start" id="start" value="<?= $sourceFields  ? $sourceFields[0]->getId() : "" ?>" />
				<input type="hidden" name="shownSpan" id="shownSpan" value="<?= $multipleIncludes  ? "default" : "single" ?>" />
				<input type="hidden" name="count" id="count" value="<?= $counter ?>" />
				<input type="hidden" name="c" id="c" value="<?= $c ?>" />			
			<input type="submit" value="Submit" onclick="return validateInput('Submit');"/>
			
		</form>
	
	</div>
	
</body>
</html>
