<?php

class Openit_Clients extends AbstractController {
	
	private $clients;
	private $client;
	
	public function getModel() {
		return $this->client;
	}
	
	public function getList() {
		return $this->clients;
	}
	
	public function index() {
		$this->clients = $this->getClients();
	}
	
	public function show() {
		
		$this->clients = $this->getClients();
		if (isset($this->clients[$this->getRequest()->id])) {
			$this->client = $this->clients[$this->getRequest()->id];
		}
		
		if (isset($this->getRequest()->subs[1])) {
			switch (strtolower($this->getRequest()->subs[1])) {
				case 'version':
					echo $this->client->version;
					break;
			}
		}
	}
	
	public function get() {
		
		$this->clients = $this->getClients();
		if (isset($this->clients[$this->getRequest()->id])) {
			$this->client = $this->clients[$this->getRequest()->id];
		}

		if (isset($this->getRequest()->subs[2])) {
			switch (strtolower($this->getRequest()->subs[2])) {
				case 'version':
					echo $this->client->version;
					break;
			}
		}
	}
	
	
	private function getClients() {
		$openitServerConfig = new OpeniT_Server_Config();
		
		$clients = array();
		$openit_client_info = "";
		if (!strstr(PHP_OS, "WIN")){
			$openit_client_info = "/var/opt/openit/etc/openit_client_info.json";
		}else{
			$openit_client_info = trim($openitServerConfig->get('ROOT_DIR')) . "/Configuration/openit_client_info.json";
		}
		
		if (file_exists($openit_client_info)) {
			
			// Get objects from json file
			$data = json_decode(file_get_contents($openit_client_info));
			
			// Loop thrugh all the objects, and create Openit_client instances..
			foreach($data as $hostname => $clientInfo) {
				
				if ($clientInfo->client) {
				
					$client = new Openit_Client($hostname);
					
					$client->version = $clientInfo->client->version;
					$client->platform = $clientInfo->client->arch;					
					$client->kernel = $clientInfo->client->os;
					$client->modules = isset($clientInfo->client->modules) ? $clientInfo->client->modules : array();
					$client->patches = isset($clientInfo->client->patches) ? $clientInfo->client->patches : array();					
					
					$client->lastSeen = time() - $clientInfo->server->epoch;

					if (stristr($client->kernel, 'windows')) $client->icon = 'windows';					
					else if (stristr($client->kernel, 'aix')) $client->icon = 'ibm';
					else if (stristr($client->kernel, 'solaris')) $client->icon = 'sun';
					else if (stristr($client->kernel, 'hpux')) $client->icon = 'hp';
					else if (stristr($client->kernel, 'sgi')) $client->icon = 'sgi';
					else if (stristr($client->kernel, 'linux')) $client->icon = 'linux';
					else if (stristr($client->kernel, 'unix')) $client->icon = 'unix';
					else if (stristr($client->kernel, 'apple')) $client->icon = 'apple';					
					else $client->icon = 'default';					

					
					$clients[] = $client;
				}
			}
			
			print_r($data);
		}
		
		else {
				
			$data = str_replace("\n", '', file_get_contents($openit_client_info));
			
			// Parse data
			$parser = new Parser($data, ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_PARENTESE_START)->set(ParserSettings::SKIP_BLANK_LINES, true));
			
			// Parse truh the config file
			while ($parser->hasMore()) {
				
				// Get line
				$line = $parser->next();
				
				for ($i=0; $i<$line->count(); $i++) {
					if (strstr($line->get($i)->toString(), '^')) {
						
						$client = new Openit_Client();
						
						$clientRaw = $line->get($i, ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_COMMA));
						
						$client->hostname = $clientRaw->get(0)->toString();
						//$server = $clientRaw->get(1);
						$client->lastSeen = time() - $clientRaw->get(2)->toString();
						
						$clientInfo = $clientRaw->get(4, ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_SEMI_COLON));
						
						$client->platform = $clientInfo->get(1)->toString();
						$client->kernel = str_replace('^', ' ', $clientInfo->get(2)->toString());
						
						// Get version number from ugly string
						// E.g: Open^iT^version^5.4.0.1^^Host=NHC0SV03^^Architecture=i386^^OS=Windows^Server^2003^^Domain=GOODRICH
						$version = $clientInfo->get(3)->toString();
						if (strstr($version, '^')) {
							$client->version = substr($version, 16, strpos(substr($version, 16), '^'));
						} else {
							$client->version = $version;
						}
						
						//$clientModulesRaw = $clientInfo->get(4, ParserSettings::create(ParserSettings::SPLIT, '-'));
	
						$client->modules = array();
						//for ($j=4; $j<$clientModulesRaw->count(); $j++) {
						for ($j=4; $j<$clientInfo->count(); $j++) {						
							//$client->modules[] = str_replace(')', '', $clientModulesRaw->get($j)->toString());	
							$client->modules[] = str_replace(')', '', $clientInfo->get($j)->toString());
						}
	
						// Find suitable icon.. based on kernel
						if (stristr($client->kernel, 'windows')) $client->icon = 'windows';					
						else if (stristr($client->kernel, 'aix')) $client->icon = 'ibm';
						else if (stristr($client->kernel, 'solaris')) $client->icon = 'sun';
						else if (stristr($client->kernel, 'hpux')) $client->icon = 'hp';
						else if (stristr($client->kernel, 'sgi')) $client->icon = 'sgi';
						else if (stristr($client->kernel, 'linux')) $client->icon = 'linux';
						else if (stristr($client->kernel, 'unix')) $client->icon = 'unix';
						else if (stristr($client->kernel, 'apple')) $client->icon = 'apple';					
						else $client->icon = 'default';					
						
						$clients[$client->hostname] = $client;
											
					}
				}
				
			}
		}
		
		// Sort clients by host
		sort($clients);
		return $clients;
			
		
	}
	
}

?>