<?php

class Product_Status extends AbstractController {

	private $list;
	private $CSS_for_IE6;
	
	public function init() {
		
		// Load the initiation file
		require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");
		if(!isset($_SESSION["USER"])){
			header('Location: /login.php');
		}
		//FeedWriter::init(); Note: moved to products_init()
		/*if (!UserHelper::getCurrentUser()->isAdmin()) {
			header('Location: /access.php?txt=' . urlencode('You don\'t have access to this part of the system'));
			exit;
		}*/
		//$this->getDocument()->title = 'Product Status';
		$this->CSS_for_IE6 = (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6.') !== FALSE || strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 7.') !== FALSE) ? '-IE' : '';
		if(!isset($_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"])) $_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"] = 50;
		if(!isset($_SESSION["REALTIME"]["PRODUCTS"]["ORDER"])) $_SESSION["REALTIME"]["PRODUCTS"]["ORDER"] = "ASC";
	}

	public function getModel() {
		//return '3';
	}

	public function getList() {		
		return $this->list;
	}
	
	public function index() {
		/* Note: "moved to products_init() 
		 * RealTime::clearSelections();
		 * $realtime = RealTime::getInstance(true);
		 * $this->list = $realtime->getProducts(true);
		*/
		self::products_init();
		
		// Add RSS feed link in the header
		$this->getDocument()->head = '<link rel="alternate" type="application/rss+xml" title="Open iT patches" href="' . '/module/product_status/feed.rss" />';

		if (isset($_REQUEST['xauth']) && $_REQUEST['xauth'] == 'asdjkd292de')
			$this->getDocument()->template = 'tiny';
	}
	
	public function put() {
		echo 'put';
		//exit;
	}
	
	public function feed() {
		$this->index();
	//	$this->list
	}
	
	public function create() {
	}
	
	public function show($id = "") {
		
		if(!isset($_SESSION["USER"])){
			exit("timeout");
		}
		
		if(is_array($this->getRequest()->subs)) {
			
			switch(strtolower($this->getRequest()->subs[0])) {
				case "dump":
					
					var_dump($_SESSION["REALTIME"]["PRODUCT_STATUS"]);
					break;
					
				case "sort":
					
					$_SESSION["REALTIME"]["PRODUCTS"]["SORTBY"] = strtoupper($this->getRequest()->subs[1]);
					$_SESSION["REALTIME"]["PRODUCTS"]["ORDER"] = strtoupper($this->getRequest()->subs[2]);
					self::sort();
					self::display();
					break;
					
				case "page":
					
					$page = $this->getRequest()->subs[1];
					$row = $_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"];
					
					$_SESSION["REALTIME"]["PRODUCTS"]["PAGE"] = $page;
					$_SESSION["REALTIME"]["PRODUCTS"]["STARTAT"] = (($page - 1) * $row) + 1;
					
					//self::sort();
					self::display();
					break;
				
				case "filter":
					
					RealTime::clearSelections();
					$realtime = RealTime::getInstance(true);		
					$this->list = $realtime->getProducts(true);
					
					$field = ($this->getRequest()->subs[1] != "") ? $this->getRequest()->subs[1] : null;
					$key = ($this->getRequest()->subs[2] != "") ? $this->getRequest()->subs[2] : null;
					
					$_SESSION["REALTIME"]["PRODUCT_STATUS"] = self::loadProducts($this->list,$field,urldecode($key));
					$_SESSION["REALTIME"]["PRODUCTS"]["PAGE"] = 1;
					$_SESSION["REALTIME"]["PRODUCTS"]["STARTAT"] = 1;
					
					self::sort();
					self::display();
					break;
					
				case "rows":
					
					$_SESSION["REALTIME"]["PRODUCTS"]["PAGE"] = 1;
					$_SESSION["REALTIME"]["PRODUCTS"]["STARTAT"] = 1;
					$_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"] = $this->getRequest()->subs[1];
					
					break;
					
				default:
					foreach($this->getRequest() as $a => $b) {
						echo $a . " --- " . var_dump($b) . "<br/>";
					}
			}
			
		}
	}
		
	public function getMenu() {
		return 'dashboard';
	}
	
	public function validate() {	
		$this->getValidator()->setRequired('mail', 'Need an email adr');
		$this->getValidator()->isEmail('mail', 'Need to be a valid email adr');
	}
	
	public function products_init() {
		
		RealTime::clearSelections();
		$realtime = RealTime::getInstance();		
		$this->list = $realtime->getProducts(true);
		
		$_SESSION["REALTIME"]["PRODUCT_STATUS"] = self::loadProducts($this->list);
		$_SESSION["REALTIME"]["PRODUCTS"]["SORTBY"] = "LASTSEEN";
		$_SESSION["REALTIME"]["PRODUCTS"]["ORDER"] = "ASC";
		$_SESSION["REALTIME"]["PRODUCTS"]["PAGE"] = 1;
		$_SESSION["REALTIME"]["PRODUCTS"]["STARTAT"] = 1;
		$_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"] = 6;
		
		if(!isset($_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"])) $_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"] = 50;
		
		self::sort();
		self::display();		
	}
	
	private function loadProducts($list,$filter = null,$filterText = null) {
		
		$prod = array();
		$i = 0;
		foreach($list as $product) {
			
			$MSU = $product->getMinutesSinceUpdate();
			$lastSeen = $product->getLastSeenFormat();
			
			$serverPortValue = is_numeric($product->serverport) ? $product->serverport : 0;
			$serverPortDisplay = strlen($product->serverport) > 0 ? $product->serverport : "N/A";
			
			if(trim($filter) != "" && trim($filterText) != "") {
				switch($filter) {
					case "product": $strValue = $product->name; break;
					case "status": $strValue = $MSU > 15 ? ($MSU > 60 ? ($MSU > 360 ? 'fatal Last update more than 6 hours ago' : 'critical Last update more than 60 minutes ago')  : 'warning Last update more than 15 min ago') : 'Current'; break;
					case "server": $strValue = $product->server; break;
					case "port": $strValue = $serverPortDisplay; break;
					case "lastseen": $strValue = ($lastSeen != "N/A") ? $lastSeen : "The last seen time seems to be collected in the future. Please check the clock on your server and client(s) N/A"; break;
				}
				$toInclude = (stristr($strValue, $filterText) === FALSE) ? false : true;
			} else {
				$toInclude = true;
			}
				
				if($toInclude) {
					$prod[] = array("{$product->name}",
							(int) $MSU,
							"{$product->server}",
							"{$serverPortDisplay}",
							"{$lastSeen}",
							(int) $serverPortValue,
							(int) $product->getLastSeen()
							);
				}
		}
		
		return $prod;
	}
	
	private function sort() {
		
		$object = &$_SESSION["REALTIME"]["PRODUCT_STATUS"];
		$sort = $_SESSION["REALTIME"]["PRODUCTS"]["SORTBY"];
		
		switch($sort) {
			case "PRODUCT":
					$_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"] = 0;
					usort($object,"sortText");
					break;
			case "STATUS":
					$_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"] = 1;
					usort($object,"sortNumeric");
					break;
			case "SERVER":
					$_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"] = 2;
					usort($object,"sortText");
					break;
			case "PORT":
					$_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"] = 5;
					usort($object,"sortNumeric");
					break;
			case "LASTSEEN":
					$_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"] = 6;
					usort($object,"sortNumeric");
					break;			
		}
	}
	
	public function display() {
		$obj = &$_SESSION["REALTIME"]["PRODUCT_STATUS"];
		$start = $_SESSION["REALTIME"]["PRODUCTS"]["STARTAT"];
		$row = $_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"];
		
		$j = 0;
		for($i = $start - 1; $i < ($start + ($row - 1)); $i++) {
			
			if(!isset($obj[$i][0])) break;
					
			$className = ($j % 2) ? "" : "altRow";
			
			$scrolling = strlen($obj[$i][0]) > 35 ? "onmouseover=\"Scroller.start(this);\" onmouseout=\"Scroller.stop(this);\"" : "";
			$productName = strlen($obj[$i][0]) > 35 ? substr($obj[$i][0],0,35) . "..." : $obj[$i][0];
			
			$connectionStatusClass = ($obj[$i][1] > 15) ? ($obj[$i][1] > 60 ? ($obj[$i][1] > 360 ? 'fatal'.$this->CSS_for_IE6 : 'critical'.$this->CSS_for_IE6) : 'warning'.$this->CSS_for_IE6) : 'current'.$this->CSS_for_IE6;
			$connectionStatus = ($obj[$i][1] > 15) ? ($obj[$i][1] > 60 ? ($obj[$i][1] > 360 ? 'Last update more than 6 hours ago' : 'Last update more than 60 minutes ago')  : 'Last update more than 15 min ago') : 'Current';
			
			$server = $obj[$i][2];
			$port = $obj[$i][3];
			$lastseen = $obj[$i][4];
			
			echo "<tr id=\"item_{$j}\" style=\"cursor:pointer;\" class=\"{$className}\">" . chr(13);
			echo "	<td value=\"{$obj[$i][0]}\" {$scrolling}>{$productName}</td>" . chr(13);
			echo "	<td class=\"{$connectionStatusClass}\">{$connectionStatus}</td>" . chr(13);
			echo "	<td>{$server}</td>" . chr(13);
			echo "	<td>{$port}</td>" . chr(13);
			echo "	<td>{$lastseen}</td>" . chr(13);
			echo "</tr>" . chr(13);
			$j++;
		}
		
		if($j == 0) {
			echo "<tr class=altRow><td colspan=5 align=center>No record found.</td></tr>";
		}
	}
	
	public function pages() {
		
		//Just print spaces
		echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		
		$currentPage = $_SESSION["REALTIME"]["PRODUCTS"]["PAGE"];
		$rowsPerPage = $_SESSION["REALTIME"]["PRODUCTS"]["ROW_PAGE"];
		$startAt   = $_SESSION["REALTIME"]["PRODUCTS"]["STARTAT"];
		$countDisplay = count($_SESSION["REALTIME"]["PRODUCT_STATUS"]);
		
		$showEachSide = 5;		// Display of items on both sides of selected page.
		
		$maxPage = ceil($countDisplay/$rowsPerPage);
		
		$s = $currentPage - $showEachSide;
		$e = $currentPage + $showEachSide;
		if($e > $maxPage) {
			$s = $s - ($e - $maxPage);
			$e = $maxPage;
		} elseif($e <= ($showEachSide * 2) + 1) {
			$e = $maxPage;
		}
		if($s <= 0) $s = 1;		
		if($s > 1) echo "<a onClick=\"showList('/module/product_status/page/1',false);\">&laquo; First</a>&nbsp; ... ";
		
		$dsp=1;
		for($i=$s; $i <= $e; $i++) {
			$class = ($i == $currentPage) ? "pageselected" : "";
			echo "&nbsp;<a class=\"{$class}\" onClick=\"showList('/module/product_status/page/{$i}',false);\">{$i}</a>&nbsp;";
			$dsp++;
			if($dsp > ($showEachSide * 2) + 1) {
				$dsp = $i;
				break;
			}
		}
		if($dsp < $maxPage) echo " ... <a onClick=\"showList('/module/product_status/page/{$maxPage}',false);\">Last &raquo;</a>&nbsp;";
		
		if($maxPage > 0) echo " &nbsp;&nbsp;&nbsp;&nbsp; [ Page <strong>{$currentPage}</strong> of <strong>{$maxPage}</strong> ]";
	}
}

function sortNumeric($a,$b) {
	$key = $_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"];
	if($_SESSION["REALTIME"]["PRODUCTS"]["ORDER"] == "ASC") {
		return $a[$key] - $b[$key]; 			
	} else {
		return $b[$key] - $a[$key];
	}
}
	
function sortText($a,$b) {
	$key = $_SESSION["REALTIME"]["PRODUCTS"]["SORTINDEX"];

	$aTemp = strtolower($a[$key]);
	$bTemp = strtolower($b[$key]);
	
	if($_SESSION["REALTIME"]["PRODUCTS"]["ORDER"] == "ASC")
		return strcasecmp($aTemp,$bTemp);
	else
		return strcasecmp($bTemp,$aTemp);
}

?>
