<?php

class Simple_Max extends AbstractController {
	
	public function getModel() {}
	public function getList() {}
	
	public function index() {}
	
	public function getFeatures() {
		$dataType = DatabaseManager::getDataType(45);
		$features =& $dataType->getClassificationByInternalId('3');
		return $features->getClassificationValues();
	}
	
	public function glenn() {
		@session_start();
		$dataType = DatabaseManager::getDataType(45);
		
		// Get our classifications, we care about
		$time =& $dataType->getClassificationByInternalId('T');
		$product =& $dataType->getClassificationByInternalId('1');
		$features =& $dataType->getClassificationByInternalId('3');

		$time->setSelected(true);
		$product->setSelected(true);
		$features->setSelected(true);
		
		$featureValues =& $features->getClassificationValues();
		
		// select features based on user input...
		$uids = explode(',', $_REQUEST['uids']);
		
		foreach ($featureValues as $featureValue) {
			if (in_array($featureValue->getUID(), $uids)) {
				$featureValue->setSelected(true);
			}		
		}
		
		// Select measurements
		$measurements =& $dataType->getMeasurements();
		foreach ($measurements as $measurement) {
			//echo $measurement->getId() . ' ' . $measurement->getValue() . '<br>';			
			if ($measurement->getId() == 3) {
				$measurement->setSelected(true);
			}
		}
		
		// our hack to get the data from the badly implmenteted report generator..
		function php2js($array) { $_SESSION['AA'] = $array; /* print_r($array); */ }
		
		//$rg = new ReportGenerator('http://demo.openit.com:5001/OpeniT/');
		$rg = new ReportGenerator(ServerConfig::getServerUrl());
		
		$rg->setDataType($dataType);
		$rg->addClassification($time);
		$rg->addClassification($product);
		$rg->addClassification($features);
		
		$rg->setResolution(3);
		
		$rg->setArgument("av", "3");
		
		$rg->setArgument("vertical", 'T');
		$rg->setArgument("horizontal", '1,3');
				
		$rg->setArgument("pres", "table");
		$rg->setPresentationType('table');
		
		$rg->setArgument("others", "false");
		$rg->setArgument("subtotal", "false");
		$rg->setArgument("rowspan", "false");
		
		$rg->setFolder('{Trashcan}');
		$rg->setTitle('Glenn Test');
		
		$rg->setFromDate('2008-01-01');
		$rg->setToDate('2009-11-01');
		
		if ($rg->isValid()) {
			echo $rg->generate();			
		} else echo 'not valid';
		
		
		header('Location: index2');
		exit;
	}
	
	
	public function index2() {
	
		//@session_start();
		// Get data
		//$data = file_get_contents('http://demo.openit.com:5001/OpeniT/results/%7BTrashcan%7D/top_0_80559543491525.data');
		//die(str_replace('localhost:8888', 'demo.openit.com:5001', $_SESSION['AA']['URL']));
		$data = file_get_contents(str_replace('shtml', 'data', $_SESSION['AA']['URL']));
		
		
		// Parse data
		$parser = new Parser($data, ParserSettings::create(ParserSettings::COMMENT_CHAR, "#")->set(ParserSettings::SKIP_COMMENTS, true)->set(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_SEMI_COLON)->set(ParserSettings::SKIP_BLANK_LINES, true));
		//$parser = new Parser($data, ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_PARENTESE_START)->set(ParserSettings::SKIP_BLANK_LINES, true));
		
		// Array to hold data
		$set = array();

		// Parse truh the config file
		while ($parser->hasMore()) {
			
			// Get line
			$line = $parser->next();
			
			// Set data to local variables
			$date = $line->get(2)->toString();
			
			//$product = $line->get(4)->toString();
			
			$feature = $line->get(5, ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_PROSENTAGE))->get(0)->toString();
			//$feature = $line->get(4)->toString() . '/' . $line->get(5, ParserSettings::set(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_PROSENTAGE))->get(0)->toString();
			
			
			$max = $line->get(5, ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_PROSENTAGE))->get(1)->toString();
			
			if (!isset($set[$date])) $set[$date] = array();
			//if (!isset($set[$date][$product])) $set[$date][$product] = array();
			if (!isset($set[$date][$feature])) $set[$date][$feature] = array();
			
			$set[$date][$feature] = $max;
			//echo date('Y-m-d', $date) . " $product $feature $max<br />\n";
			
			//while ($line->hasMore()) {
				//echo $line->next()->toString() . "<br />\n";
			//}

			// Insert key, value into array
			//$this->config[$line->get(0)->toString()] = $line->get(1)->toString();
		}
		
		// Print collected data as XML
		?>
		<graph
			XXXXXX-caption="Max in Use"
			XXXXXX-subcaption="(Daily)"
			hovercapbg="FFECAA"
			hovercapborder="F47E00"
			formatNumberScale="0"
			decimalPrecision="0"
			showvalues="0"
			XXXXXX-numdivlines="3"
			XXXXXX-numVdivlines="0"
			XXXXXX-yaxisminvalue="1000"
			XXXXXX-yaxismaxvalue="1800"
			rotateNames="1"
		>
		<categories>		
		<?php
		foreach($set as $date => $features) {
			echo '<category name="' . date('Y-m-d', $date) . '" />' . "\n";
		}
		?>		
		</categories>
 		
		<?php

		$colors = array('F6BD0F', '1D8BD1', 'F1683C', '2AD62A', 'DBDC25', '56B9F9', 'C9198D');
		
		
		foreach(array_keys($features) as $feature) {
			$color = array_shift($colors);
			echo '<dataset hoverText="OW / ' . $feature . '" seriesName="' . $feature . '" color="' . $color . '" anchorBorderColor="' . $color . '" anchorBgColor="' . $color . '">' . "\n";
			foreach($set as $values) {
				echo '<set value="' . $values[$feature] . '" />' . "\n";
			}
			echo '</dataset>';
		}
		?>		
		</graph>
		
		<?php
		//print_r($set);
		
	}
	
	
}

?>