<?php /*
//
// $Id: classification_value_list.php 1286 2013-07-16 10:24:12Z rcoros $
//
// (C) Copyright 1997-2006 by Open iT Inc, All rights reserved.
//
// This software may be used or copied only with the written permission of
// Open iT Inc or in accordance with the terms and conditions stipulated
// in the agreement under which this software has been supplied.
//
// This file is part of Open iT Resources.
//
// Created by: Glenn O Larsen <glenn.larsen@openit.com>
//
//
// ===========================================================================
//
// Description of file:
//
// This template file should list all classification values in a selection list.
//
///////////////////////////////////////////////////////////////////////////////*/ ?>

<script type="text/javascript">

// Option scroller
var Scroller = {

	// Variables
	object:null,
	timer:null,
	text:null,
	orginaltext:null,
	position:0,
	
	// Start function
	start:function(object) {
	
		// If we have an old object in scrolling list,
		// remove this one before we start a new one
		if (Scroller.object != null) {
			Scroller.stop();
		}
		
		// Start new scroller
		Scroller.object = object;
		Scroller.position = 0;
		Scroller.text = object.text.replace(/ /g, "_");
		Scroller.orginaltext = object.text;
		
		// Start loop
		Scroller.loop();
	},
		
	// Stop function
	stop:function(object) {
		Scroller.object.text = Scroller.orginaltext;
		Scroller.object = null;
		clearTimeout(Scroller.timer); 
	},
	
	// Loop function
	loop:function() {
		// If we don't have any element in the obj variable, stop..
		if (Scroller.object == null) return;
		
		// Find next position of the string
		Scroller.position++;
		if (Scroller.position > Scroller.text.length-1) Scroller.position = 0;
	
		// Set new text back to the object
		Scroller.object.text = Scroller.text.substr(Scroller.position);
	
		// Set the timer to repeat the function after 80 millis
		Scroller.timer = setTimeout("Scroller.loop()", 80);
	}
	
};

function toogleExtraScrollers() {
	var object = document.getElementById('classificationvalues');	
	if (object.className == "") {
		object.className = "extraScroller";
		return;
	}
	
	object.className = "";
}


	// Get object from source, that fits the keywords
	function searchValues(keywordObj) {
		
		// Get elements
		var source = document.getElementById('classificationvaluesList');
		var destination = document.getElementById('classificationvaluesListSearcher');
		var clist = document.getElementById('classvaluesListctrl');
		var clvalue = document.getElementById('classvaluesSearcherctrl');
		var keywords = keywordObj.value;
		
		// Do we have a search word
		if (keywords != "") {
			source.style.display = 'none';
			destination.style.display = 'block';			
			clist.style.display = 'none';
			clvalue.style.display = 'inline';
		}
		
		// No search
		else {
			source.style.display = 'block';
			destination.style.display = 'none';
			clist.style.display = 'inline';
			clvalue.style.display = 'none';
			return;
		}
		
		// Create instance of regular expression validator		
		var regexp = new RegExp(keywords, "i");
		
		// Empty destination
		destination.options.length = 0;
		
		// Create a clone of the source, to the destination	
		for (var i=0; i<source.options.length; i++) {

			// See if we have a match		
			if (regexp.test(source.options[i].text)) {	
			
				// Get a clone
				var clone = source.options[i].cloneNode(true);
				
				// Mark as selected if it should be
				clone.selected = (source.options[i].selected) ? true : false;
				
				// Add to new select box
				destination.appendChild(clone);
			}
		}
			
	}
	
	// Set the selection in the clone back to the original
	function callBack() {
		// Get elements
		var source = document.getElementById('classificationvaluesList');
		var destination = document.getElementById('classificationvaluesListSearcher');
		
		var sourceId = 0;
		
		// Find all elements that has changed, and reflect this back to the source
		for (var i=0; i<destination.options.length; i++) {
		
			// Find the original option object
			for (;sourceId<source.options.length; sourceId++)
				if (source.options[sourceId].value == destination.options[i].value) break;
				
			// Update the source
			source.options[sourceId].selected = destination.options[i].selected;
		} 
		
		// Send the new classification selection...
		sendClassificationValuesSelection();
		
	}



</script>


<?php
// Print extra div for toggeling the overflow scrollbar only for IE
if (strstr($_SERVER["HTTP_USER_AGENT"], "MSIE")) {
?>
  <div id="extraScrollerController" name="extraScrollerController" onclick="toogleExtraScrollers()"><?= tt("completeselection_selection_toggle_scrollbar") ?></div>
<?php
}
?>

<label for="classificationvaluesList" ><?= tt("global_valuesfrom", (isset($classificationName) ? $classificationName : null)) ?></label>
<div class="select_overflow_wrapper">

	<select size="<?= (count($classificationvalues) < 10) ? '10' : count($classificationvalues) ?>" <?php if ($classificationvalues == 0) { ?>style="width:300px;"<?php } ?> id="classificationvaluesList" size="10" name="classificationvaluesList" multiple="multiple">
	<?php 
		if(is_array($classificationvalues)){
			foreach($classificationvalues as $classificationvalue) { ?>
			<option <?= (strlen($classificationvalue->getValue()) > 90) ? 'onmouseover="Scroller.start(this)" onmouseout="Scroller.stop(this)"' : '' ?> value="<?= $classificationvalue->classification->getUID() ?>-<?= $classificationvalue->getUID() ?>" <?php if ($classificationvalue->isSelected()) { ?>selected="selected"<?php } ?>><?= $classificationvalue->getValue() ?></option>
	<?php }} ?>
	</select>

	<select size="<?= (count($classificationvalues) < 10) ? '10' : count($classificationvalues) ?>" <?php if ($classificationvalues == 0) { ?>style="width:300px;"<?php } ?> id="classificationvaluesListSearcher" size="10" name="classificationvaluesListSearcher" multiple="multiple" onchange="callBack()" onclick="callBack()">
	</select>	
</div>

<div class="ctrl">
	
	Search: <input type="text" onkeyup="searchValues(this)" style="margin: 0;">
	
	<span id="classvaluesListctrl">
	<a href="javascript: selectAll('classificationvaluesList'); sendClassificationValuesSelection();"><?= tt("global_selectall") ?></a>&nbsp;
	<a href="javascript: unSelectAll('classificationvaluesList'); sendClassificationValuesSelection();"><?= tt("global_deselectall") ?></a>
	</span>
	
	<span id="classvaluesSearcherctrl" style="display:none;">
	<a href="javascript: selectAll('classificationvaluesListSearcher'); callBack();"><?= tt("global_selectall") ?></a>&nbsp;
	<a href="javascript: unSelectAll('classificationvaluesListSearcher'); callBack(); sendClassificationValuesSelection();"><?= tt("global_deselectall") ?></a>
	</span>
	
<?php if (isset($classification) && ($classification->isAnonymous()) && (isset($enablemasking) && $enablemasking)) { ?>
	<span class="item">
		<input type="checkbox" name="anonymous_<?= $classificationvalue->classification->getUID() ?>" <?php if ($selection->get("anonymous_", $classificationvalue->classification->getUID()) == 1) { ?>checked="checked"<?php } ?> value="1" onchange="setSelection(this);" id="check_use_anonymous_complete_selection" /><label for="check_use_anonymous_complete_selection"><?= tt("global_input_anonymous") ?></label><span class="tip" onmouseover="showHideDescription('anonymous_description', true);" onmouseout="showHideDescription('anonymous_description', false);">?<span class="tooltip_content" id="anonymous_description"><?= tt("global_anonymous_description") ?></span></span>
 	</span>
<?php } ?>
</div>
