<?php include "pages/header.php"; ?>
<?php $_SESSION["USER"]->isAdmin() ? include "components/access_control/submenu.php" : ""?>

<div id="content">
	<div id="spacer">


	<?php if ($user->getId() == "") { ?>
		<h2 id="edit_newuser_header"><?= tt("accesscontrol_groups_newuser_header") ?></h2>
		<p><?= tt("accesscontrol_groups_newuser_description") ?></p>
	<?php } else { ?>
		<h2 id="edit_user_header"><?= tt("accesscontrol_groups_edituser_header", htmlspecialchars($user->getUsername())) ?></h2>
	<?php } ?>

		<?php 
		if(isset($_GET['success'])){
			echo "<strong>Your account has been successfully updated.</strong><br/>";
		}
		?>

                <form action="post_edit_user.php" method="post" autocomplete="off" id="userform" onSubmit="return validateFormText(document.getElementById('userform'));">

			<input type="hidden" name="id" value="<?= $user->getId() ?>" />

			<fieldset id="users_general">
				<legend><?= tt("accesscontrol_users_edit_header_general") ?></legend>
				
				<div class="field">
					<label class="users_general_label" for="username"><?= tt("accesscontrol_users_edit_login_name") ?></label>
					<input class="users_general_input" type="text" id="edit_username" name="edit_username" value="<?= $user->getUsername() ?>" size="20" maxlength="255" alt="Username"/>
				</div>
	
				<?php if (!$ldap) { ?>
	
				<div class="field">
					<label class="users_general_label" for="name"><?= tt("accesscontrol_users_edit_label_name") ?></label>
					<input class="users_general_input" type="text" id="name" name="name" value="<?= $user->getName() ?>" size="30" maxlength="255" alt="Name"/>
				</div>
				
				<div class="field">
					<label class="users_general_label" for="password"><?= tt("accesscontrol_users_edit_label_password") ?></label>
					<input class="users_general_input" type="password" id="edit_password" name="edit_password" value="" size="10" maxlength="255" />
				</div>
				
				<?php } ?>
				
				<div class="field">
					<label class="users_general_label" for="division"><?= tt("accesscontrol_users_edit_label_division") ?></label>
					<input class="users_general_input" type="text" id="division" name="division" value="<?= $user->getDivision() ?>" size="10" maxlength="255" />
				</div>

				<div class="field">
					<label class="users_general_label" for="division"><?= tt("accesscontrol_users_edit_label_language") ?></label>
					<select class="users_general_input" id="language" name="language">
						<option value="0"><?= tt("accesscontrol_users_edit_label_default_language") ?></option>
					<?php foreach($languages as $value => $language) { ?>
						<option value="<?= $value ?>" <?php if ($user->getLanguage() == $value) { ?>selected="selected"<?php } ?>><?= $language ?></option>
					<?php } ?>
					</select>
				</div>
			<?if($_SESSION["USER"]->isAdmin()){ ?>	
				<div class="field">
					<label class="users_general_label"><?= tt("accesscontrol_users_edit_label_admin") ?></label>
					<input type="radio" id="admin1" name="admin" value="1"<?php if ($user->isAdmin()) { ?> checked="checked"<?php } ?> /><label for="admin1"><?= tt("accesscontrol_users_edit_label_admin_yes") ?></label>
					<input type="radio" id="admin0" name="admin" value="0"<?php if (!$user->isAdmin()) { ?> checked="checked"<?php } ?> <?php if ($_GET['id']=='1') { ?> disabled <?php } ?> /><label for="admin0"><?= tt("accesscontrol_users_edit_label_admin_no") ?></label>
				</div>
				
				<div class="field">
					<label class="users_general_label"><?= tt("accesscontrol_users_edit_label_agreement") ?></label>
					<input type="radio" id="agreement1" name="agreement" value="1"<?php if ($user->isAgreement()) { ?> checked="checked"<?php } ?> /><label for="agreement1"><?= tt("accesscontrol_users_edit_label_agreement_yes") ?></label>
					<input type="radio" id="agreement0" name="agreement" value="0"<?php if (!$user->isAgreement()) { ?> checked="checked"<?php } ?> /><label for="agreement0"><?= tt("accesscontrol_users_edit_label_agreement_no") ?></label>
				</div>
				
			</fieldset>

			
			<fieldset id="users_roles">
				<legend><img src="/gfx/icons/user_preferences24.png" border="0" /><?= tt("accesscontrol_users_edit_header_roles") ?></legend>
				<div class="container">
					<div class="item">
						<input type="checkbox" id="templateuser"  name="templateuser" value="1" <?php if ($user->isTemplateUser()) { ?>checked="checked"<?php } ?> /><label for="templateuser"><?= tt("accesscontrol_users_edit_label_templatereporting") ?></label>
					</div>
					<div class="item">
						<input type="checkbox" id="viewuser" name="viewuser" value="1" <?php if ($user->isViewUser()) { ?>checked="checked"<?php } ?> /><label for="viewuser"><?= tt("accesscontrol_users_edit_label_reportsviewing") ?></label>
					</div>
					<div class="item">
						<input type="checkbox" id="reportgeneratoruser" name="reportgeneratoruser" value="1" <?php if ($user->isReportGeneratorUser()) { ?>checked="checked"<?php } ?> /><label for="reportgeneratoruser"><?= tt("accesscontrol_users_edit_label_completereporting") ?></label>
					</div>
					<div class="item">
						<input type="checkbox" id="realtimeuser" name="realtimeuser" value="1" <?php if ($user->isRealtimeUser()) { ?>checked="checked"<?php } ?> /><label for="realtimeuser"><?= tt("accesscontrol_users_edit_label_realtime") ?></label>
					</div>
				</div>
			</fieldset>



			<fieldset id="users_members">
				<legend><img src="/gfx/icons/users_preferences24.png" border="0" /><?= tt("accesscontrol_users_edit_header_memberofgroups") ?></legend>

				<div class="container">
					<?php foreach($groups as $group) { ?>
						<div class="item"><input type="checkbox" name="group[]" id="group_<?= $group->getId() ?>" value="<?= $group->getId() ?>" <?php if ($user->isMemberOf($group)) { ?>checked="checked"<?php } ?> /><label for="group_<?= $group->getId() ?>"><?= htmlspecialchars($group->getName()) ?></label></div>
					<?php } ?>
				</div>

			</fieldset>
			<? } ?>
			
			<div id="users_save">
				<input type="submit" value=<?= tt("global_form_save")?> />
				<?if($_SESSION["USER"]->isAdmin()){ ?>
					<input type="button" value=<?= tt("global_form_cancel") ?> onclick="location.href='index.php'" />
				<?}?>
			</div>
		
		</form>
   
		
		<script type="text/javascript">
		<!--
		// -->
		</script>
		

	</div>

</div>

<?php include "pages/footer.php"; ?>
