<?php
include "pages/header.php";
include "components/complete_selection/submenu.php";
?>

<div id="content">
	<div id="spacer">
	 
	 <h2 id="completeselection_selection_header"><?= tt("completeselection_selection_header") ?></h2>
	 <p><?= tt("completeselection_selection_description") ?></p>
	 
		<fieldset id="modulesdatatypes_fieldset">
	   <legend><img src="/gfx/icons/cubes24.png" border="0" height="24" width="24" /><?= tt("completeselection_selection_header_modulesanddatatypes")?></legend>
	
			<?php /* Include 'module list' component */ ?>
			<div id="modules">
				<?php include "components/complete_selection/module_list.php"; ?>
			</div>

			<?php /* Include 'datatype list' component */ ?>
			<div id="datatypes">
				<?php include "components/complete_selection/datatype_list.php" ?>
			</div>
		
	  </fieldset>

		<fieldset id="measurements_fieldset">
			<legend><img src="/gfx/icons/cube_blue_preferences24.png" border="0" height="24" width="24" />Measurements</legend>

		<?php /* Include 'measurement list' component */ ?>
			<div id="measurements">
				<?php include "components/complete_selection/measurement_list.php" ?>
			</div>
		</fieldset>
		
		<fieldset id="classifications_fieldset">
			<legend><img src="/gfx/icons/cube_blue_preferences24.png" border="0" height="24" width="24" /><?= tt("completeselection_selection_header_measurementsandclassifications") ?></legend>
			
			<?php /* Include 'classification list' component */ ?>
			<div id="classifications">
				<?php include "components/complete_selection/classification_list.php" ?>
			</div>
		
			<?php /* Include 'classification value list' component */ ?>
			<div id="classificationvalues">
				<?php include "components/complete_selection/classification_value_list.php" ?>
			</div>

		</fieldset>
		
		<div class="clearer"></div>
	
	
		
		<script type="text/javascript">
		<!--
		
		function sendModule(id) {
			// Remove other data
			gebi("measurementsList").innerHTML = "";
			gebi("classificationsList").innerHTML = "";
			gebi("classificationvaluesList").innerHTML = "";
			
			sendData('complete_selection/post_module.php', 'returnModule', 'id', id);
		}
		
		function returnModule(data) {
			gebi("datatypes").innerHTML = data;	
			addEvent("datatypesList", "onchange", "sendDataType(getSelectValue(this.name));");
		}

		function sendDataType(id) {

			// Remove other data
			gebi("measurementsList").innerHTML = "";
			gebi("classificationsList").innerHTML = "";
			gebi("classificationvaluesList").innerHTML = "";
			
			// Send data
			if (id >= 0) {
				sendData('complete_selection/post_datatype.php', 'returnDataType', 'datatypeId', id);
			}
		}
		
		function returnDataType(value) {
			if (value == "ERROR") {
				alert("An error has occurred.\nPlease try again.");
				return;
			}
			sendData('complete_selection/get_data.php', 'returnMetadata', 'type', 'all');
			
			// Update the Tabs to be disabled
			returnVerifySelection();
		}
	
		function returnMetadata(data) {

			// Data is returned as a JSON object - An eval will parse the object quickly
			var data = eval('(' + data + ')');
	
			if (data["measurements"]) {
				gebi("measurements").innerHTML = data["measurements"];
				addEvent("measurementsList", "onchange", "sendMeasurementsSelection();");
			}
			
			if (data["classifications"]) {
				gebi("classifications").innerHTML = data["classifications"];
				addEvent("datatypesList", "onchange", "sendDataType(getSelectValue(this.name));");
				consoleLogger();
			}
			
			if (data["classificationvalues"]) {
				gebi("classificationvalues").innerHTML = data["classificationvalues"];
				addEvent("classificationvaluesList", "onchange", "sendClassificationValuesSelection();");
			}
				
		}
		
		function sendMeasurementsSelection() {
			var selectedMeasurementValues = Array();
			var measurementValueObj = document.getElementById("measurementsList");
			
			for (var i=0; i<measurementValueObj.options.length; i++) {
				if (measurementValueObj.options[i].selected) {
					selectedMeasurementValues.push(measurementValueObj.options[i].value);
				}
			}
		
			// Send selected measurements
			sendData('complete_selection/post_measurement.php', 'verifySelection', 'measurementIds', selectedMeasurementValues.join("|"));
		}
		
		function sendClassificationSelection() {
			var selectedClassifications = Array();
			var obj = document.getElementById("classifications");
			var elementList = obj.getElementsByTagName("input");
			
			for (var i=0; i<elementList.length; i++) {
				if (elementList[i].name == "classification[]" && elementList[i].checked) {
					selectedClassifications.push(elementList[i].value);	
				}
			}
		
			// Send selected classifications
			sendData('complete_selection/post_classification.php', 'verifySelection', 'classificationIds', selectedClassifications.join("|"));
		}
		
		
		function verifySelection() {
			sendData('complete_selection/get_verify.php', 'returnVerifySelection');
		}
		
		function returnVerifySelection(status) {
			if (status == "OK-1") {
				MenuTab.enable("complete_selection_presentation");
				MenuTab.enable("complete_selection_generation");
			} else if (status == "OK-2") {
				MenuTab.enable("complete_selection_presentation");
				MenuTab.disable("complete_selection_generation");
			} else {
				MenuTab.disable("complete_selection_presentation");
				MenuTab.disable("complete_selection_generation");		
			}
		}
		
		function sendClassificationValuesSelection() {
			var selectedClassificationValues = Array();
			var classificationValueObj = document.getElementById("classificationvaluesList");
			
			for (var i=0; i<classificationValueObj.options.length; i++) {
				if (classificationValueObj.options[i].selected) {
					selectedClassificationValues.push(classificationValueObj.options[i].value);
				}
			}
			
			var classificationItem = document.getElementById(activeClassificationItemName);
			if (selectedClassificationValues == "") {
				classificationItem.className = "";
			} else {
				classificationItem.className = "filtered";
			}
			
		
			// Send selected measurements
			sendData('complete_selection/post_classification_value.php', '', 'classificationId', activeClassificationId, 'classificationValueIds', selectedClassificationValues.join("|"));	
		
		}
		
		
		var activeClassificationId = 0;
		var activeClassificationItemName = null;
		
		function showClassificationValues(id, classificationItemName) {
		
			// Clean up filter
			classificationvaluesListFilter = null;
		
			activeClassificationItemName = classificationItemName;
			//sendData('complete_selection/get_data.php', 'debug', 'type', 'classificationvalues', 'id', id);
			activeClassificationId = id;
			sendData('complete_selection/get_data.php', 'returnMetadata', 'type', 'classificationvalues', 'id', id);
		}
		
		
		//addEvent("datatypesList", "onchange", "clickTest(getSelectValue(this.name));");
		addEvent("modulesList", "onchange", "sendModule(getSelectValue(this.name));");
		addEvent("datatypesList", "onchange", "sendDataType(getSelectValue(this.name));");
		addEvent("measurementsList", "onchange", "sendMeasurementsSelection();");
		addEvent("classificationvaluesList", "onchange", "sendClassificationValuesSelection();");
		
		


		var posx=0;
		var posy=0;
		var offsetX=16;
		var offsetY=16;
		var popUp = false;
		var ent = document.getElementById("tooltip");

		function mtrack(e){
			if (popUp) {
				if (!e) var e = window.event;
				if (e.pageX || e.pageY) {
					posx = e.pageX;
					posy = e.pageY;
				}
				else if (e.clientX || e.clientY) {
					posx = e.clientX + document.body.scrollLeft;
					posy = e.clientY + document.body.scrollTop;
				}
				ent.style.left = posx + offsetX + "px";
				ent.style.top = posy + offsetY + "px";
			}
		}

		function showHideDescription(id, visible) {

			var desc = document.getElementById(id);
			if (!desc) return;

			if (visible) {
				popUp = true;
				ent.innerHTML = desc.innerHTML;
			}else{
				popUp = false;
				ent.style.left = "-1000px" ;
				ent.style.top = "-1000px";
				ent.innerHTML = "";
			}
		}

		document.onmousemove = mtrack;
		
		// Check if the tabs should be enabled of disabled
		verifySelection();

		// -->
		</script>
		
	<style>
	.myhidden { display: none; color: white; background-color: white; }
	</style>
	
	</div>

</div>


<?php include "pages/footer.php" ?>