<?php
include "pages/header.php";
include "components/resources/submenu.php";

?>
<style type="text/css">
	#sidebar {
		width: 23em;
		float: right;
	}
</style>

<div id="content">

<div id="spacer">

<h2>Bundled Documentation</h2>
<font size=3.5px>Here is a complete documentation for Open iT software.</font><br><br>
Feel free to call or email us to ask for help when you are working with data you are not familiar with. We want to make sure you get the most out of your Open iT  investment.
<br><br>
<fieldset>
<legend>User Guides</legend>
<dl>

<dt>
	<strong>Reporting Server:</strong>
	<a href="/OpeniT/docs/html/user_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/user_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/user_guide_A4.pdf">A4</a>)
</dt>
<dd>Provides details about the Graphical User Interface (GUI) of Open iT and describes step by step, through examples, how to generate reports. <br>
	The intended readers of this guide are those who will be using Open iT&rsquo;s GUI to generate reports. Open iT is a proactive system management tool that prompts customers to analyze and optimize their resource usage by defining data input. <br /></dd>


<dt>
	<strong>Analysis Server:</strong>
	<a href="/OpeniT/docs/html/analysis_server_user_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/analysis_server_user_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/analysis_server_user_guide_A4.pdf">A4</a>)
</dt>
<dd>Shows you how to use Analysis Server&rsquo;s powerful reporting tools to create reports. </dd>

</dl>
</fieldset>

<? if (UserHelper::getCurrentUser()->isAdmin()) {?>
<fieldset>
<legend>Administration Guides</legend>
<dl>
<dt>
	<strong>Unix - Client and Core Server:</strong>
	<a href="/OpeniT/docs/html/admin_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/admin_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/admin_guide_A4.pdf">A4</a>)

</dt>
   <dd>Describes the installation, configuration, and administration of Open iT, management<br />
	tools and the Open iT portal help you perform administrative and user level tasks. Available now to make Open iT software usage and administration easy.<br /></dd>

<dt>
	<strong>Windows Client:</strong>
	<a href="/OpeniT/docs/html/windows_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/windows_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/windows_guide_A4.pdf">A4</a>)
</dt>
<dd>Describes the installation and setup process of an Open iT Windows Client. Based on customer requirements and the installation type chosen, the installation process can vary.<br>
	It is assumed the Open iT Windows client administrator is familiar with the Open iT client-server architecture, and the data flow between the client and server, etc.<br /></dd>

<dt>
	<strong>Windows Core Server:</strong>
	<a href="/OpeniT/docs/html/windows_core_server_admin_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/windows_core_server_admin_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/windows_core_server_admin_guide_A4.pdf">A4</a>)
</dt>
<dd>This guide provides guidance and information to install Open iT Windows Core Server. You will also find guidelines for uninstalling/removing the Server.<br /></dd>
<!-- </dl>
</fieldset>

<fieldset>
<legend>Analysis Server</legend>
Open iT Analysis Server marks a new leap in our ability to perform advanced reporting on all levels of business; from a single user to global operations. 
<dl>
 -->
 
<dt>
	<strong>Analysis Server:</strong>
	<a href="/OpeniT/docs/html/analysis_server_admin_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/analysis_server_admin_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/analysis_server_admin_guide_A4.pdf">A4</a>)

</dt>
<dd>This guide shows the installation, configuration, and maintenance of the underlying components of Open iT Analysis Server, a new leap in the ability to perform advanced reporting on all levels of business; from a single user to global operations.</dd>

</dl>

</fieldset>
<?}?>

<fieldset>
<legend>License Optimizer Guide</legend>
<dl>

<dt>
	<strong>LicenseOptimizer :</strong>
	<a href="/OpeniT/docs/html/license_optimizer_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/license_optimizer_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/license_optimizer_guide_A4.pdf">A4</a>)
</dt>
<dd>This guide is for both administrators and users, and explains different implementations for both versions of the LicenseOptimizer (LO) module: the Hosted Server Environment Edition and Standalone Client Edition. The aim is to give the reader a grasp of LO&rsquo;s unique functionality, in particular about disabling and optimizing applications that are left idle. Well-described, in-depth details of the installation, configuration and maintenance of the product can be found in this manual. <br /></dd>

</dl>
</fieldset>

<!-- 

<div id="sidebar">
<fieldset>
<legend>Bundled Documentation</legend>

<p>Here you will find the complete documentation for the currently installed
version of Open iT.</p>

<ul>
<li>
	Administration Guide:
	<a href="/OpeniT/docs/html/admin_guide/index.html">HTML</a>,
	<a href="/OpeniT/docs/pdf/admin_guide.pdf">PDF</a>

</li>
<li>
	User&rsquo;s Guide:
	<a href="/OpeniT/docs/html/user_guide/index.html">HTML</a>,
	<a href="/OpeniT/docs/pdf/user_guide.pdf">PDF</a>
</li>
<li>
	Windows Admin Guide
	<a href="/OpeniT/docs/html/windows_guide/index.html">HTML</a>,
	<a href="/OpeniT/docs/pdf/windows_guide.pdf">PDF</a>

</li>
</ul>
</fieldset>
</div>


<h3>Description of modules</h3>

<dl>

	<dt><strong>LicenseAnalyzer</strong></dt>

	<dd>Provides an enterprise-wide overview of installed programs showing
	when and by whom they are used over time, by location, business unit or
	project group. Enables chargeback accounting, usage-based license
	agreements, accurate workflow analysis and optimal license usage.<br />
	<a href="http://www.openit.com/index.php?id=24">Click for more
	information</a>.</dd>

	<dt><strong>LicenseOptimizer</strong></dt>

	<dd>Monitors activity levels for installed applications and can free up
	unused licenses for active users on high priority projects delivering
	extremely targeted license management.<br />
	<a href="http://www.openit.com/index.php?id=39">Click for more
	information</a>.</dd>

	<dt><strong>SystemAnalyzer</strong></dt>
	
	<dd>Measures CPU, memory and I/O usage for each application, user, system
	etc., permitting fine-tuning of machine capacity and chargeback or usage
	accounting for a variety of system-wide IT functions.<br />
	<a href="http://www.openit.com/index.php?id=21">Click for more
	information</a>.</dd>

	<dt><strong>StorageAnalyzer</strong></dt>

	<dd>Delivers an overview of disk and backup data enabling optimal data
	storage management. Shows trends and potential capacity problems and
	provides an accurate basis for charging for data storage services.<br />

	<a href="http://www.openit.com/index.php?id=22">Click for more
	information</a>.</dd>

	<dt><strong>UsageAnalyzer</strong></dt>

	<dd>Tracks each user&rsquo;s keyboard and mouse activities enabling personalized
	user training and the formation of best practices for computer usage.
	Delivers a way to identify and discourage work methods that can cause
	strain-related injuries and the means to evaluate software usability before
	purchasing.<br />
	<a href="http://www.openit.com/index.php?id=23">Click for more
	information</a>.</dd>

	<dt><strong>DatabaseReporter</strong></dt>
	
	<dd>Delivers a way to monitor and report on the usage of installed Oracle
	and Sybase databases across an organization. Provides a basis for
	fine-tuning the databases and delivers data for accurate chargeback for
	database usage.<br />
	<a href="http://www.openit.com/index.php?id=20">Click for more
	information</a>.</dd>

	<dt><strong>Availreporter</strong></dt>

	<dd>Measures the availability of services and documents service level
	agreement (SLA) performance for users and service suppliers.<br />

	<a href="http://www.openit.com/index.php?id=19">Click for more
	information</a>.</dd>

	<dt><strong>Base</strong></dt>

	<dd>The base component is an extensive data warehouse used for integrating
	Open iT into your IT infrastructure with a Java-based user interface,
	providing flexible reports from any Web browser.<br />
	<a href="http://www.openit.com/index.php?id=37">Click for more
	information</a>.</dd>

</dl>

 -->



</div>
</div>

