<?php
include "pages/header.php";
include "components/resources/submenu.php";

?>
<style type="text/css">
	#sidebar {
		width: 23em;
		float: right;
	}
</style>

<div id="content">

<div id="spacer">

<h2>Bundled Documentation</h2>
<font size=3.5px>Here is a complete documentation for Open iT software.</font><br><br>
Feel free to call or email us to ask for help when you are working with data you are not familiar with. We want to make sure you get the most out of your Open iT  investment.
<br><br>


<fieldset>
<legend>Installation Guide</legend>
<dl>

<dt>
	<strong>Core Server, Client Modules</strong> and <strong>Analysis Server:</strong>
	<a href="/OpeniT/docs/html/installation_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/installation_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/installation_guide_A4.pdf">A4</a>)
</dt>
<dd>This guide describes how you can perform administrative and user-level installation of the Open iT Software Suite on both Unix and Windows&reg; platforms. <br />
The step-by-step installation procedures are shown in a graphical presentation which include screenshots from the actual installation. The information provided includes guidance of the basic requirements, the setup process, as well as upgrade and uninstallation.  <br />
It also demonstrates the installation of the underlying components of Open iT Analysis Server, a new leap in the ability to perform advanced reporting on all levels of business. <br /></dd>

</dl>
</fieldset>

<? if (UserHelper::getCurrentUser()->isAdmin()) {?>
<fieldset>
<legend>Administration Guide</legend>
<dl>

<dt>
	<strong>Core Server and Client </strong> and <strong>Analysis Server:</strong>
	<a href="/OpeniT/docs/html/admin_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/admin_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/admin_guide_A4.pdf">A4</a>)
</dt>
<dd>This guide is intended  for those who actually do the installation, configuration and maintenance of the Open iT Software Suite; as it describes in detail all references and fundamental management of the software. <br />
Illustrates the management tools of the Open iT Admin Portal, how you can do administrative and user-level tasks. <br />
The Analysis Server post-install configuration includes troubleshooting guidelines during installation or while using the product. <br /></dd>

</dl>
</fieldset><?}?>

<fieldset>
<legend>User Guides</legend>
<dl>

<dt>
	<strong>Reporting Server:</strong>
	<a href="/OpeniT/docs/html/user_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/user_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/user_guide_A4.pdf">A4</a>)
</dt>
<dd>The intended readers of this guide are those who will be using the Open iT Web Interface as it describes solely the step-by-step procedure on generating reports through examples and figures. <br /></dd><br />

<dt>
	<strong>Analysis Server:</strong>
	<a href="/OpeniT/docs/html/analysis_server_user_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/analysis_server_user_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/analysis_server_user_guide_A4.pdf">A4</a>)
</dt>
<dd>This guide describes how to use Analysis Server&rsquo;s reporting tools to create reports. </dd><br />

<dt>
	<strong>LicenseOptimizer :</strong>
	<a href="/OpeniT/docs/html/license_optimizer_guide/index.html">HTML</a>,
	PDF (<a href="/OpeniT/docs/pdf/license_optimizer_guide.pdf">Letter</a>, <a href="/OpeniT/docs/pdf/license_optimizer_guide_A4.pdf">A4</a>)
</dt>
<dd>This guide explains the installation, configuration and maintenance of Open iT License Optimizer, a tool for disabling applications that are left idle.  <br /></dd>

</dl>
</fieldset>

</div>
</div>

