<?php 
// Load presentation layer class
$presentation = new Presentation();

$reportSelection = new ReportSelection();

// Get templates
$templateLoader = new TemplateLoader();

// Get selected template
/*@var $template Template */
$template = $templateLoader->getTemplate($reportSelection->get("PRESENTATION_ID"));

?>
<?php include "pages/header.php"; ?>
<?php include "components/template_selection/submenu.php"; ?>

<div id="content">
	<div id="spacer">

    <?php include "components/generation.php"; ?>

		<div class="clearer"></div>

	
	<script type="text/javascript">
	<!--

	// On load
	document.onload = onLoadCheck();
	
	function onLoadCheck() {
		//disable the add folder button in template selection
		document.getElementById("add_folder_div").style.display="none";
		if (document.getElementById("generation_date_from").value == "") {
			getPeriod(document.getElementById("generation_period"));
		}
	}
	
	
	function generateReport(periodicly) {
		// Send data
                var period = gebi("generation_period").value;
		var titlebox = document.getElementById("generation_title");
		var title = titlebox.value;
		title = title.replace(/^\s*|\s*$/,"");		//trim whitespaces
		if (title == "") {
			alert("You must specify a title on the report you want to generate!");
			titlebox.focus();
			return;
		}
		if (title.search(/[^0-9a-zA-Z\-\_\040\<\>\(\)\%\.]/g) >= 0){
			alert("Only alphanumeric characters(A to z, 0 to 9), space, and the following characters (<>()%_.-) are allowed as a report title.");
			title= title.replace(/[^0-9a-zA-Z\-\_\040\<\>\(\)\%\.]/g,"");
			titlebox.focus();
			return;
		}
                if(period=="C"){
                    if(!isPeriodValid()) return;
                }
		
		if (!periodicly) {
			consoleLogger("<?= tt("consolelogger_messages_report_generating") ?>");
			sendData('template_selection/post_generate.php', 'returnReport');
		} else {
			consoleLogger("<?= tt("consolelogger_messages_report_add_periodic") ?>");
			sendData('template_selection/post_generate.php', 'returnReportPeriodic', 'periodic', '1');
		}
	}
	
	function returnReportPeriodic() {
		consoleLogger("<?= tt("consolelogger_messages_report_periodic_added") ?>");
	}
	
	function returnReport(response) {
		var response = eval( "(" + response + ")" );		
		if (response["STATUS"] == "ERROR") {
			consoleLogger("<?= tt("consolelogger_messages_report_error_generating") ?>" + response["MESSAGE"]);
			showError(response["MESSAGE"]);
			return;
		} else if (response["STATUS"] == "OK") {
			consoleLogger("<?= tt("consolelogger_messages_report_opening_report") ?>");
			<?php if (ServerConfig::getReuseReportWindow()) { ?>
			window.open(response["URL"], "_self");
			<?php } else { ?>			
			window.open(response["URL"], "_blank");
			<?php } ?>			
		} else {
			alert("Can’t handle response message!");
			alert("Response: " + response);
		}
	}
	
	
	function getPeriod(periodObj) {
		var period = periodObj.options[periodObj.selectedIndex].value;
		if (period!="C") sendData('complete_selection/get_period.php', 'returnPeriod', 'period', period);
	}
	
	function returnPeriod(timeArray) {
		var timeArray = eval( "(" + timeArray + ")" );
		if (!timeArray) {
			alert("ERROR #8273");
			return;
		}
		document.getElementById("generation_date_from").value = timeArray["generation_date_from"];
		document.getElementById("generation_date_to").value   = timeArray["generation_date_to"];
	}

	function customPeriodFlag(){
		var sel= document.getElementById("generation_period");
		var txtfrom= document.getElementById("generation_date_from");
		var txtto= document.getElementById("generation_date_to");
		sel.selectedIndex=10;
		period=sel.options[10].value;
		from =txtfrom.value;
		to = txtto.value;
		sendData('complete_selection/custom_period.php','returnPeriod','period',period,'from',from,'to',to);
	}

        function isPeriodValid(){
            var ok=false;
            var fromdt = gebi("generation_date_from").value;
            var todt = gebi("generation_date_to").value;
            var reso;
            
            if(gebi("generation_resolution")) reso = gebi("generation_resolution").value;
            else reso="";
            var resotime = 0, resostring="";
            var now = parseInt((gebi("servertime").value)+"000");
            switch(reso){
                case "1": resotime = 900000; resostring = "15 minutes"; break;
                case "2": resotime = 3.6e+6; resostring = "1 hour"; break;
                case "3": resotime = 8.64e+7; resostring = "24 hours"; break;
                case "4": resotime = 6.048e+8; resostring = "1 week"; break;
                case "5": resotime = 2.63e+9; resostring = "1 month"; break;
                case "6": resotime = 3.156e+10; resostring = "1 year"; break;
                default: resotime = 300000; resostring = "5 minutes"; break;
            }

            if ((now-getEpochTime(fromdt))< resotime) alert("Notice: Start time must be at least "+resostring+" before the server time.");
            else if(now<getEpochTime(todt)) alert("Notice: End time must not be from the future.");
            else if(getEpochTime(todt)<getEpochTime(fromdt)) alert("Notice: End time must be after the start time.");
            else if((getEpochTime(todt)-getEpochTime(fromdt))< resotime) alert("Notice: Start and end time must be at minimum of "+resostring.replace(/s$/, "")+" intervals");
            else ok = true;
            return ok;
        }
        
	//-->
	</script>
	
		
		
	</div>

</div>
<?php include "pages/footer.php"; ?>
